<%@ page session="false" %>
<%@ page import="com.sambar.javaeng.SambarUtils" %>

<%!
public String getServletVersion() 
{
    ServletContext context=getServletConfig().getServletContext();
    int major = context.getMajorVersion();
    int minor = context.getMinorVersion();
    return Integer.toString(major) + '.' + Integer.toString(minor);
}
%>

<html>
<head>
<title>Sambar JavaEngine Console</title>
<link rel="stylesheet" href="/sysuser/style.css" type="text/css">
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="0">
</head>
<body topmargin="4" leftmargin="5" marginheight="4" marginwidth="5" vlink="#0000ff" link="#0000ff">

<br>
&nbsp;&nbsp;<big><B>Sambar Server JavaEngine Console</B></big>
<br>

<TABLE WIDTH=100% BORDER=0 CELLPADDING=10 CELLSPACING=0 ALIGN=CENTER>
<TR><TD>

	<B>JVM Memory</B>
	<br>
	<TABLE cellpadding=8 cellspacing=0 valign=bottom>
	<TR><TD nowrap>
	<% 
	String rungc = request.getParameter("rungc");
	if ((rungc != null) && (rungc.equals("true")))
	{
		Runtime.getRuntime().gc();
	}

	double freeMemory = Runtime.getRuntime().freeMemory();
	double totalMemory = Runtime.getRuntime().totalMemory();
	double maxMemory = Runtime.getRuntime().maxMemory(); 
	double moreToGo = freeMemory + (maxMemory - totalMemory);
	double used = totalMemory - freeMemory;

	int percent = (int)Math.ceil((used * 100)/maxMemory);
	int percentHeap = (int)Math.ceil((used * 100)/totalMemory); 
	%>
	<%=(int)(used/(1024 * 1024))%> MB (<%=percent%>%) of 
	<%=(int)(maxMemory/(1024 * 1024))%> MB (Max Available)
	</TD>
	<TD nowrap>			
	<%=(int)(used/(1024 * 1024))%> MB (<%=percentHeap%>%) of 
	<%=(int)(totalMemory/(1024 * 1024))%> MB (Heap Size)
	</TD>
	<TD nowrap>
	<form name="gc" action="/sysadmin/services/javaeng.jsp?rungc=true" 
		method=post>
	<input type='submit' value='Run Garbage Collection'>
	</form>
	</TD></TR>
	</TABLE> 
</TD></TR>
<TR><TD>
	<B>Class Loaders</B><BR>
	<%
	String loaders = request.getParameter("loaders");
	if ((loaders != null) && (loaders.equals("true")))
	{
		SambarUtils.restartClassLoaders(response);
		out.write("<br><i>Class loaders reloaded.</i> ");
	}
	%>
	<form action="/sysadmin/services/javaeng.jsp?loaders=true" method=post>
	<input type='submit' value='Reload Class Loaders'>
	</form>
</TD></TR>

<TR><TD>
	<TABLE cellpadding=4 cellspacing=0 valign=bottom>
	<TR><TD nowrap><b>Servlet Version</b></TD>
	<TD><%=getServletVersion()%></TD></TR>

	<TR><TD nowrap><b>Platform</b></TD>
	<TD><%=getServletConfig().getServletContext().getServerInfo()%></TD></TR>

	<TR valign=top><TD nowrap><b>System Properties</b></TD>
	<TD>
	<%
    java.util.Enumeration e=null;
    try 
	{
        e= System.getProperties().propertyNames();
    } 
	catch (SecurityException se) 
	{
    }

    if (e!=null) 
	{
        out.write("<pre>");
        for (;e.hasMoreElements();) 
		{
            String key = (String) e.nextElement();
            out.write(key + "=" + System.getProperty(key)+"\n");
        }

        out.write("</pre><p>");

    } 
	else 
	{
        out.write("System properties are not accessible<p>");
    }
	%>
	</TD></TR>
	</TABLE>

</TD></TR>
</TABLE>
			
</body>
</html>
