<HTML>
<HEAD><TITLE><%=txt2html(envt("servername"));%> - JavaEngine Administration</TITLE>
<% 
#include "../../header.asp"
menu = "scripts";
#include "../../menu.asp"
area = "javaeng";
#include "../submenu.asp"
%>
<table border=0 width=98%><tr><td nowrap>
<B>JavaEngine Properties Configuration</B>
[ <A HREF="/sysadmin/scripts/showini.asp?area=javaeng&file=javaeng.ini">javaeng.ini</A> ]
</td><td nowrap align=right>
<A TARGET="help" HREF="/syshelp/javaeng.htm"><small>
<%=message("sa.Help", locale());%></small></A>
</td></tr></table>
<P>
Properties configured below can be retrieved using the 
<B>System.getProperty()</B> method.  These properties are passed as JVM arguments using -D&lt;name&gt;=&lt;value&gt;.  In addition to any user-defined 
properties, it is recommended you have the following properties configured:
<BR>
<blockquote>
	<TABLE border=0 cellpadding=2>
        <TR valign=top>
          <TD nowrap><B>traceServlets =</B></TD>
          <TD nowrap><I>true | false</I></TD>
          <TD>Boolean indicating whether Java servlet execution should be 
            traced to the server.log file.</TD></TR>
        <TR valign=top>
          <TD nowrap><B>sessionTimeout =</B></TD>
          <TD nowrap><I>7200</I></TD>
          <TD>The amount of time, in seconds, that idle sessions should be 
            cached before being automatically logged out.</TD></TR>
        <TR valign=top>
          <TD nowrap><B>sessionCheckFrequency =</B></TD>
          <TD nowrap><I>60</I></TD>
          <TD>The duration, in seconds, between checks of the session cache 
            for idle/expired sessions.</TD></TR>
        <TR valign=top>
          <TD nowrap><B>JSPTrace =</B></TD>
          <TD nowrap><I>warning</I></TD>
          <TD>The JSP trace level: debug | informational | warning | 
		error | fatal</TD></TR>
        <TR valign=top>
          <TD nowrap><B>JSPLog =</B></TD>
          <TD nowrap><I>path</I></TD>
          <TD>The complete path to the JSP log for trace messages.  If left
		blank, all trace information is output to <I>stderr</I>
		(you will need to use bin/serverd.exe to see messages).
		</TD></TR>
	</TABLE>
</blockquote>
<BR>
<BR>
<form method=post action="/sysadmin/scripts/javaeng/index.asp">
<input type=hidden name="action" value="update">
<input type=hidden name="section" value="properties">

<table border=0>
<% 
    ini = iniopen("javaeng.ini");
    inisort(ini, "properties");
    entries = inientries(ini, "properties");
    values = inivalues(ini, "properties");
    pos = 0;
    while (pos < sizeof(entries))
    {
        name = entries[pos];
        val = values[pos];
%>
<tr>
<td><input type=text name="CN<%=pos;%>" size=40 maxlength=40 value="<%=txt2html(name);%>" onkeypress="return handleEnter(this, event)"></td>
<td><input type=text name="CV<%=pos;%>" size=60 maxlength=60 value="<%=txt2html(val);%>" onkeypress="return handleEnter(this, event)"></td>
</tr>
<%   
        pos++;
    } 
%>

<% for (i = 0; i < 3; i++) { %>
<tr>
<td><input type=text name="CN<%=pos + i;%>" size=40 maxlength=40 value="" onkeypress="return handleEnter(this, event)"></td>
<td><input type=text name="CV<%=pos + i;%>" size=60 maxlength=60 value="" onkeypress="return handleEnter(this, event)"></td>
</tr>
<% } %>
</table>
<input type=submit class="mod" value="Update JavaEngine Properties">
</form>
<%
#include "../../footer.asp"
%>
</BODY></HTML>
