<HTML>
<HEAD><TITLE><%=txt2html(envt("servername"));%> - MySQL Manager</TITLE>
<% 
#include "../../header.asp"
menu = "scripts";
#include "../../menu.asp"
area = "dbms";
#include "../submenu.asp"

cache = getParameter($params, "dbcache");
qpm = 0;
uptime = 0;
queries = 0;
insertnum = 0;
selectnum = 0;
updatenum = 0;
%>
<table border=0 width=98%><tr><td nowrap>
<B>MySQL Manager</B>
[ Cache '<%=txt2html(cache);%>' ]
</td><td nowrap align=right>
<A TARGET="help" HREF="/syshelp/db.htm"><small>
<%=message("sa.Help", locale());%></small></A>
</td></tr></table>
<%
try
{
	dbm = dbcache(cache);
	dbcommand(dbm, "show status");
	while ((a = dbfetch(dbm)) != NULL)
	{
  		if (a[0] == "Uptime")
			uptime = (int)a[1];
  		else if (a[0] == "Questions")
			queries = (int)a[1];
		else if (a[0] == "Com_insert")
			insertnum = (int)a[1];
    	else if (a[0] == "Com_select")
			selectnum = (int)a[1];
    	else if (a[0] == "Com_update")
			updatenum = (int)a[1];
	}
	dbclose(dbm);
}
catch (e)
{
	printf("<div class=\"error\">");
	printf(exception(e, "message"));
	printf("</div>");
}
%>
<P>
<table border=0 cellpadding=8 width=90% align=center>
<tr valign=top><td nowrap>
<a href="process.asp?dbcache=<%=urlencode(cache);%>">Process List</a><br>
<a href="status.asp?dbcache=<%=urlencode(cache);%>">System Status</a><br>
<a href="vars.asp?dbcache=<%=urlencode(cache);%>">System Variables</a><br>
<a href="master.asp?dbcache=<%=urlencode(cache);%>">Master/Slave Status</a><br>

</td><td nowrap width=30%>

<table style="border: 1px solid black" cellspacing=2>
<tr bgcolor=#efefef><td nowrap><b>Database(s)</b></td><td></td></tr>
<%
	dbm = dbcache(cache);
	dbprepare(dbm, 
		"show databases", NULL);
	dbexecute(dbm);
	while ((a = dbfetch(dbm)) != NULL)
	{
		printf("<tr><td>%s</td><td><a href=\"tables.asp?database=%s&dbcache=%s\">Tables</a></td></tr>\n", 
			txt2html(a[0]), urlencode(a[0]), urlencode(cache));
	}
	dbclose(dbm);
%>
</table>
</td><td nowrap width=30%>

<table style="border: 1px solid black" cellspacing=2>
<tr bgcolor=#efefef><td nowrap><b>User</b></td><td><b>Host</b></td></tr>
<%
	dbm = dbcache(cache);
	dbprepare(dbm, 
		"select user, host from user order by user asc", NULL);
	dbexecute(dbm);
	while ((a = dbfetch(dbm)) != NULL)
	{
		printf("<tr><td>%s</td><td>%s</td></tr>\n", 
			txt2html(a[0]), txt2html(a[1]));
	}
	dbclose(dbm);
%>
</table>
</td><td width=30%>
<B>MySql Health Report</B>
<br>
<table>
<tr><td nowrap>Database Uptime</td><td nowrap><%=sec2time(uptime);%></td></tr>
<tr><td nowrap>Number of Queries</td><td nowrap><%=queries;%></td></tr>
<% if (uptime > 0) { %>
<tr><td nowrap>Queries per Minute</td><td nowrap><%=(int)(queries / uptime);%></td></tr>
<tr><td nowrap>% Queries Inserts </td><td nowrap><% printf("%.2f%", (insertnum / uptime) * 100); %></td></tr>
<tr><td nowrap>% Queries Selects </td><td nowrap><% printf("%.2f%", (selectnum / uptime) * 100); %></td></tr>
<tr><td nowrap>% Queries Updates </td><td nowrap><% printf("%.2f%", (updatenum / uptime) * 100); %></td></tr>
<% } %>
</table>
</td></tr>
</table>
</P>
<%
#include "../../footer.asp"
%>
</BODY></HTML>
