<HTML>
<HEAD><TITLE><%=txt2html(envt("servername"));%> - Security Administration</TITLE>
<% 
#include "../header.asp"
menu = "security";
#include "../menu.asp"
area = "secini";
#include "submenu.asp"

ini = iniopen("security.ini");
sectype = findParameter($params, "sectype", "redirect");

void showMap(char *s)
{
	printf("<form method=post action=\"/sysadmin/security/secview.asp\">\n");
	printf("<input type=hidden name=\"action\" value=\"update\">\n");
	printf("<input type=hidden name=\"sectype\" value=\"%s\">\n", s);

   	inisort(ini, s);
   	entries = inientries(ini, s);
   	values = inivalues(ini, s);
   	pos = 0;
   	while (pos < sizeof(entries))
   	{
       	name = entries[pos];
       	val = values[pos];
		printf("<tr><td><input type=text name=\"CN%d\" size=40 maxlength=40 value=\"%s\" onkeypress=\"return handleEnter(this, event)\"></td>\n", pos, name);
		printf("<td><input type=text name=\"CV%d\" size=60 maxlength=60 value=\"%s\" onkeypress=\"return handleEnter(this, event)\"></td></tr>\n", pos, val);

       	pos++;
   	} 

	for (i = 0; i < 3; i++) 
	{
		printf("<tr><td><input type=text name=\"CN%d\" size=40 maxlength=40 value=\"\" onkeypress=\"return handleEnter(this, event)\"></td>\n", pos + i);
		printf("<td><input type=text name=\"CV%d\" size=60 maxlength=60 value=\"\" onkeypress=\"return handleEnter(this, event)\"></td></tr>\n", pos + i);
	}

	printf("<tr><td colspan=2><input type=submit class=\"mod\" value=\"Update Configuration\"></form></td></tr>\n");
}

%>
<table border=0 width=98%><tr><td nowrap>
<B>Global Security Configuration</B>
[ <A HREF="/sysadmin/security/showini.asp?area=secini&file=security.ini">security.ini</A> ]
</td><td nowrap align=right>
<A TARGET="help" HREF="/syshelp/security.htm"><small>
<%=message("sa.Help", locale());%></small></A>
</td></tr></table>
<I>Unless manually reloaded below, changes do not take effect until a system restart.</I>
<P>
<I>Wildcard Characters</I>
<BR>
The star (*) wildcard character matches any character string.  The
question mark (?) wildcard character matches any one character in a
fixed position.  The keyword <CODE>null</CODE> matches the absense of
a value (i.e. to block all clients who do not provide a User-Agent string, 
"null" could be used to match.) 
All string matches should be expressed in lower-case.
<P>
<blockquote>

<% if (sectype == "redirect") { %>
<FONT COLOR=#990033><B>Security Redirects</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>URI to Redirect </TH><TH align=left> URL to Redirect To</TH></TR>
<TR><TD><I>/microsoft </I></TD><TD><I> http://www.microsoft.com/</I></TD></TR>
<TR><TD><I>/docs </I></TD><TD><I> http://techpub.sambar.com/</I></TD></TR>
<% showMap(sectype); %>
</TABLE>

<% } else if (sectype == "restrict") { %>

<FONT COLOR=#990033><B>Security Restrictions</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>URI to Restrict </TH><TH align=left> User or Group to Restrict To</TH></TR>
<TR><TD><I>/securedir </I></TD><TD><I> root staff</I></TD></TR>
<TR><TD><I>/foo/bar </I></TD><TD><I> anonymous</I></TD></TR>
<% showMap(sectype); %>
</TABLE>
Note: Users must first be defined using the 
<A HREF="/sysadmin/security/users.asp">User Management</A> forms.

<% } else if (sectype == "iprestrict") { %>

<FONT COLOR=#990033><B>Security IP Restrictions</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>URI to Restrict </TH><TH align=left> IP address to Restrict To</TH></TR>
<TR><TD><I>/securedir </I></TD><TD><I> 140.172.165.*</I></TD></TR>
<TR><TD><I>/foo/bar </I></TD><TD><I> 140.172.* 140.175.150.*</I></TD></TR>
<% showMap(sectype); %>
</TABLE>

<% } else if (sectype == "deny") { %>

<FONT COLOR=#990033><B>Security Deny</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>IP to Deny Access </TH><TH align=left> URL to Redirect To</TH></TR>
<TR><TD><I>140.175.165.22 </I></TD><TD><I> http://www.microsoft.com</I></TD></TR>
<TR><TD><I>140.175.* </I></TD><TD><I> http://www.microsoft.com</I></TD></TR>
<% showMap(sectype); %>
</TABLE>

<% } else if (sectype == "httpaccept") { %>

<FONT COLOR=#990033><B>Security HTTP Accept</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>IP Addresses to Accept </TH><TH align=left> Description</TH></TR>
<TR><TD><I>* </I></TD><TD><I> Allow all clients</I></TD></TR>
<TR><TD><I>140.175* </I></TD><TD><I> Allow only corporate users</I></TD></TR>
<% showMap(sectype); %>
</TABLE>

<% } else if (sectype == "ftpaccept") { %>

<FONT COLOR=#990033><B>Security FTP Accept</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>IP Addresses to Accept </TH><TH align=left> Description</TH></TR>
<TR><TD><I>* </I></TD><TD><I> Allow all clients</I></TD></TR>
<TR><TD><I>140.175* </I></TD><TD><I> Allow only corporate users</I></TD></TR>
<% showMap(sectype); %>
</TABLE>

<% } else if (sectype == "jabberaccept") { %>

<FONT COLOR=#990033><B>Security IM Accept</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>IP Addresses to Accept </TH><TH align=left> Description</TH></TR>
<TR><TD><I>* </I></TD><TD><I> Allow all IM clients</I></TD></TR>
<TR><TD><I>140.175* </I></TD><TD><I> Allow only corporate users</I></TD></TR>
<% showMap(sectype); %>
</TABLE>

<% } else if (sectype == "jabbers2saccept") { %>

<FONT COLOR=#990033><B>Security IM S2S Accept</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>IP Addresses to Accept </TH><TH align=left> Description</TH></TR>
<TR><TD><I>* </I></TD><TD><I> Allow all IM servers</I></TD></TR>
<TR><TD><I>140.175* </I></TD><TD><I> Allow only corporate IM servers</I></TD></TR>
<% showMap(sectype); %>
</TABLE>

<% } else if (sectype == "mailaccept") { %>

<FONT COLOR=#990033><B>Security Mail Accept</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>IP Addresses to Accept </TH><TH align=left> Description</TH></TR>
<TR><TD><I>* </I></TD><TD><I> Allow all clients</I></TD></TR>
<TR><TD><I>140.175* </I></TD><TD><I> Allow only corporate users</I></TD></TR>
<% showMap(sectype); %>
</TABLE>

<% } else if (sectype == "proxyaccept") { %>

<FONT COLOR=#990033><B>Security Proxy Accept</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>IP Addresses to Accept </TH><TH align=left> Description</TH></TR>
<TR><TD><I>* </I></TD><TD><I> Allow all clients</I></TD></TR>
<TR><TD><I>140.175* </I></TD><TD><I> Allow only corporate users</I></TD></TR>
<% showMap(sectype); %>
</TABLE>

<% } else if (sectype == "rproxyaccept") { %>

<FONT COLOR=#990033><B>Security Reverse Proxy Accept</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>IP Addresses to Accept </TH><TH align=left> Description</TH></TR>
<TR><TD><I>* </I></TD><TD><I> Allow all clients</I></TD></TR>
<TR><TD><I>140.175* </I></TD><TD><I> Allow only corporate users</I></TD></TR>
<% showMap(sectype); %>
</TABLE>

<% } else if (sectype == "dnsaccept") { %>

<FONT COLOR=#990033><B>Security DNS Server/Proxy Accept</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>IP Addresses to Accept </TH><TH align=left> Description</TH></TR>
<TR><TD><I>* </I></TD><TD><I> Allow all clients</I></TD></TR>
<TR><TD><I>140.175* </I></TD><TD><I> Allow only corporate users</I></TD></TR>
<% showMap(sectype); %>
</TABLE>

<% } else if (sectype == "tftpaccept") { %>

<FONT COLOR=#990033><B>Security TFTP Server Accept</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>IP Addresses to Accept </TH><TH align=left> Description</TH></TR>
<TR><TD><I>* </I></TD><TD><I> Allow all clients</I></TD></TR>
<TR><TD><I>140.175* </I></TD><TD><I> Allow only corporate users</I></TD></TR>
<% showMap(sectype); %>
</TABLE>

<% } else if (sectype == "syslogaccept") { %>

<FONT COLOR=#990033><B>Security Syslog Server Accept</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>IP Addresses to Accept </TH><TH align=left> Description</TH></TR>
<TR><TD><I>* </I></TD><TD><I> Allow all clients</I></TD></TR>
<TR><TD><I>140.175* </I></TD><TD><I> Allow only corporate users</I></TD></TR>
<% showMap(sectype); %>
</TABLE>

<% } else if (sectype == "httpdeny") { %>

<FONT COLOR=#990033><B>Security HTTP Deny</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>IP Addresses to Deny </TH><TH align=left> Description</TH></TR>
<TR><TD><I>140.172.40.78 </I></TD><TD><I> Deny mother-in-law</I></TD></TR>
<TR><TD><I>140.175* </I></TD><TD><I> Deny competitors</I></TD></TR>
<% showMap(sectype); %>
</TABLE>

<% } else if (sectype == "agentdeny") { %>

<FONT COLOR=#990033><B>Security HTTP User-Agent Deny</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>User-Agent to Deny </TH><TH align=left> Description</TH></TR>
<TR><TD><I>robot* </I></TD><TD><I> Deny robots from www server</I></TD></TR>
<% showMap(sectype); %>
</TABLE>

<% } else if (sectype == "urldeny") { %>

<FONT COLOR=#990033><B>Security HTTP URL Deny</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>URL to Deny </TH><TH align=left> Description</TH></TR>
<TR><TD><I>*%2527* </I></TD><TD><I> PHPbb Attack</I></TD></TR>
<% showMap(sectype); %>
</TABLE>

<% } else if (sectype == "ftpdeny") { %>

<FONT COLOR=#990033><B>Security FTP Deny</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>IP Addresses to Deny </TH><TH align=left> Description</TH></TR>
<TR><TD><I>140.172.40.78 </I></TD><TD><I> Deny mother-in-law</I></TD></TR>
<TR><TD><I>140.175* </I></TD><TD><I> Deny competitors</I></TD></TR>
<% showMap(sectype); %>
</TABLE>

<% } else if (sectype == "jabberdeny") { %>

<FONT COLOR=#990033><B>Security IM Deny</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>IP Addresses to Deny </TH><TH align=left> Description</TH></TR>
<TR><TD><I>140.172.40.78 </I></TD><TD><I> Deny mother-in-law</I></TD></TR>
<TR><TD><I>140.175* </I></TD><TD><I> Deny competitors</I></TD></TR>
<% showMap(sectype); %>
</TABLE>

<% } else if (sectype == "jabbers2sdeny") { %>

<FONT COLOR=#990033><B>Security IM S2S Deny</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>IP Addresses to Deny </TH><TH align=left> Description</TH></TR>
<TR><TD><I>140.172.40.78 </I></TD><TD><I> Deny sambar.com</I></TD></TR>
<TR><TD><I>140.175* </I></TD><TD><I> Deny jabber.org servers</I></TD></TR>
<% showMap(sectype); %>
</TABLE>

<% } else if (sectype == "maildeny") { %>

<FONT COLOR=#990033><B>Security Mail Deny</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>IP Addresses to Deny </TH><TH align=left> Description</TH></TR>
<TR><TD><I>140.172.40.78 </I></TD><TD><I> Deny mother-in-law</I></TD></TR>
<TR><TD><I>140.175* </I></TD><TD><I> Deny competitors</I></TD></TR>
<% showMap(sectype); %>
</TABLE>

<% } else if (sectype == "proxydeny") { %>

<FONT COLOR=#990033><B>Security Proxy Deny</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>IP Addresses to Deny </TH><TH align=left> Description</TH></TR>
<TR><TD><I>140.172.40.78 </I></TD><TD><I> Deny mother-in-law</I></TD></TR>
<TR><TD><I>140.175* </I></TD><TD><I> Deny competitors</I></TD></TR>
<% showMap(sectype); %>
</TABLE>

<% } else if (sectype == "rproxydeny") { %>

<FONT COLOR=#990033><B>Security Reverse Proxy Deny</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>IP Addresses to Deny </TH><TH align=left> Description</TH></TR>
<TR><TD><I>140.172.40.78 </I></TD><TD><I> Deny mother-in-law</I></TD></TR>
<TR><TD><I>140.175* </I></TD><TD><I> Deny competitors</I></TD></TR>
<% showMap(sectype); %>
</TABLE>

<% } else if (sectype == "dnsdeny") { %>

<FONT COLOR=#990033><B>Security DNS Server/Proxy Deny</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>IP Addresses to Deny </TH><TH align=left> Description</TH></TR>
<TR><TD><I>140.172.40.78 </I></TD><TD><I> Deny mother-in-law</I></TD></TR>
<TR><TD><I>140.175* </I></TD><TD><I> Deny competitors</I></TD></TR>
<% showMap(sectype); %>
</TABLE>

<% } else if (sectype == "tftpdeny") { %>

<FONT COLOR=#990033><B>Security TFTP Server</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>IP Addresses to Deny </TH><TH align=left> Description</TH></TR>
<TR><TD><I>140.172.40.78 </I></TD><TD><I> Deny mother-in-law</I></TD></TR>
<TR><TD><I>140.175* </I></TD><TD><I> Deny competitors</I></TD></TR>
<% showMap(sectype); %>
</TABLE>

<% } else if (sectype == "syslogdeny") { %>

<FONT COLOR=#990033><B>Security Syslog Server Deny</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>IP Addresses to Deny </TH><TH align=left> Description</TH></TR>
<TR><TD><I>140.172.40.78 </I></TD><TD><I> Deny mother-in-law</I></TD></TR>
<TR><TD><I>140.175* </I></TD><TD><I> Deny competitors</I></TD></TR>
<% showMap(sectype); %>
</TABLE>

<% } else if (sectype == "hostfilter") { %>

<FONT COLOR=#990033><B>Security Host Filter</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>Host to Filter (via Proxy) </TH><TH align=left> Description</TH></TR>
<TR><TD><I>ad.linkexchange.com </I></TD><TD><I> LinkExchange Ad Server</I></TD></TR>
<TR><TD><I>*.focallink.com </I></TD><TD><I> All Focallink Ad Servers</I></TD></TR>
<TR><TD><I>*.playboy.com </I></TD><TD><I> Get back to work.</I></TD></TR>
<% showMap(sectype); %>
</TABLE>

<% } else if (sectype == "urlfilter") { %>

<FONT COLOR=#990033><B>Security URL Filter</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>URL to Filter (via Proxy) </TH><TH align=left> Description</TH></TR>
<TR><TD><I>/ad/* </I></TD><TD><I> No AD pages/images</I></TD></TR>
<TR><TD><I>/advertising/* </I></TD><TD><I> No advertising pages/images</I></TD></TR>
<% showMap(sectype); %>
</TABLE>

<% } else if (sectype == "hostrestrict") { %>

<FONT COLOR=#990033><B>Security Host Restrict</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>Host to Restrict </TH><TH align=left> Description</TH></TR>
<TR><TD><I>www.mylibrary.com </I></TD><TD><I> Restricted to library.</I></TD></TR>
<TR><TD><I>www.otherlibrary.com </I></TD><TD><I> Restrict to other library.</I></TD></TR>
<% showMap(sectype); %>
</TABLE>
Proxy access is limited to the hosts listed above.  This might be used for
a kiosk (i.e. library browser) where general surfing is not desired.
<BR>

<% } else if (sectype == "urlrestrict") { %>

<FONT COLOR=#990033><B>Security URL Restrict</B></FONT><P>
<TABLE border=0 cellspacing=4>
<TR><TH align=left>URL to Restrict </TH><TH align=left> Description</TH></TR>
<TR><TD><I>/mylibrary/ </I></TD><TD><I> General library URLs.</I></TD></TR>
<% showMap(sectype); %>
</TABLE>
Proxy access is limited to the URLs matching the list above.  This might 
be used for a kiosk (i.e. library browser) where general surfing is not desired.
<% } %>
</blockquote>

<%
#include "../footer.asp"
%>
</BODY></HTML>
