<HTML>
<HEAD><TITLE><%=txt2html(envt("servername"));%> - Security Administration</TITLE>
<% 
#include "../header.asp"
menu = "security";
#include "../menu.asp"
area = "throttle";
#include "submenu.asp"
%>
<table border=0 width=98%><tr><td nowrap>
<B>Throttling Configuration</B>
<br>
<I>Changes take effect immediately!</I>
</td><td nowrap align=right>
<A TARGET="help" HREF="/syshelp/throttle.htm"><small>
<%=message("sa.Help", locale());%></small></A>
</td></tr></table>
<div id="validationError"></div>
<P>
<FORM METHOD=POST ACTION="/session/sysconfig" onsubmit="return validateForm(this)">
<INPUT TYPE=hidden NAME="RCpage" VALUE="/sysadmin/security/throttle.asp">

<TABLE border=0 cellspacing=4 width=90%>

<TR valign=top><TD nowrap><B>Concurrent Requests</B></TD>
<TD width=80%>
<INPUT TYPE=text NAME="throttlenum" VALUE="<%=txt2html(envt("throttlenum"));%>" SIZE=8 MAXLENGTH=8 ptype="int" required="true" onkeypress="return handleEnter(this, event)">
</TD></TR>
<TR><TD colspan=2>
<ul><li id="l_101" class="closed"><a class="about" href="#" onclick="return show(101)">About</a>
</li><div id="m_101" class="hidden" style="position:relative">
This policy imposes a limit on the number of concurrent requests at any
one time from a host.  This can be used to limit the 
effectiveness of some denial of service (DOS) attacks; a typical browser 
will open up 10 or more simultaneous connections to a server (depending on 
the number of images present) whereas a DOS attack might attempt 100 
simultaneous connections.  This feature results in minimal performance 
impact. Set this field to zero (0) to allow unlimited connections from a 
given IP address.
</div></ul>
</TD></TR>

<TR valign=top><TD nowrap><B>Connections per-IP</B></TD>
<TD width=80%>
<INPUT TYPE=text NAME="throttlereqs" VALUE="<%=txt2html(envt("throttlereqs"));%>" SIZE=8 MAXLENGTH=8 ptype="int" required="true" onkeypress="return handleEnter(this, event)">
</TD></TR>
<TR><TD colspan=2>
<ul><li id="l_102" class="closed"><a class="about" href="#" onclick="return show(102)">About</a>
</li><div id="m_102" class="hidden" style="position:relative">
Impose a limit on the number of network requests (connections) per period 
(daily by default), which when exceeded results in subsequent requests being 
denied with a failure message.
If the <code>Requests</code> count is specified (i.e. non-zero), IP
request throttling is enabled.
</div></ul>
</TD></TR>

<TR valign=top><TD nowrap><B>Don't Throttle IPs</B></TD>
<TD width=80%>
<INPUT TYPE=text NAME="throttlenoips" VALUE="<%=txt2html(envt("throttlenoips"));%>" SIZE=40 MAXLENGTH=200 onkeypress="return handleEnter(this, event)"><BR>
</TD></TR>
<TR><TD colspan=2>
<ul><li id="l_112" class="closed"><a class="about" href="#" onclick="return show(112)">About</a>
</li><div id="m_112" class="hidden" style="position:relative">
The IP addresses specified above will not be throttled or monitored by 
the login and request monitors.  Wildcard characters (i.e. *) can be 
used to permit access to an larger IP block.
</div></ul>
</TD></TR>

<TR valign=top><TD nowrap><B>Requests per-User</B></TD>
<TD width=80%>
<INPUT TYPE=text NAME="throttleureqs" VALUE="<%=txt2html(envt("throttleureqs"));%>" SIZE=8 MAXLENGTH=8 ptype="int" required="true" onkeypress="return handleEnter(this, event)">
</TD></TR>
<TR><TD colspan=2>
<ul><li id="l_103" class="closed"><a class="about" href="#" onclick="return show(103)">About</a>
</li><div id="m_103" class="hidden" style="position:relative">
Impose a limit on the number of network requests (connections) per period
(daily by default), which when exceeded results in subsequent requests 
being denied with a failure message.  (Note: Applies only to authenticated 
users.)
</div></ul>
</TD></TR>

<TR valign=top><TD nowrap><B>Login Monitor</B></TD>
<TD width=80%>
<INPUT TYPE=radio NAME="loginmon" VALUE="true" <% if (envt("loginmon") == "true") printf("CHECKED"); %>> On
&nbsp; 
<INPUT TYPE=radio NAME="loginmon" VALUE="false" <% if (envt("loginmon") != "true") printf("CHECKED"); %>> Off<br>
<INPUT TYPE=text NAME="loginmonmax" VALUE="<%=txt2html(envt("loginmonmax"));%>" SIZE=8 MAXLENGTH=8 ptype="int" required="true" onkeypress="return handleEnter(this, event)"> attempts<BR>
<INPUT TYPE=text NAME="loginmonwait" VALUE="<%=txt2html(envt("loginmonwait"));%>" SIZE=8 MAXLENGTH=8 ptype="int" required="true" onkeypress="return handleEnter(this, event)"> sec
</TD></TR>
<TR><TD colspan=2>
<ul><li id="l_104" class="closed"><a class="about" href="#" onclick="return show(104)">About</a>
</li><div id="m_104" class="hidden" style="position:relative">
Impose a limit on the number of invalid login attempts after which the IP
attempting to login will be blocked for the period of time specified.
</div></ul>
</TD></TR>

<TR valign=top><TD nowrap><B>Request Monitor</B></TD>
<TD width=80%>
<INPUT TYPE=radio NAME="requestmon" VALUE="true" <% if (envt("requestmon") == "true") printf("CHECKED"); %>> On
&nbsp; 
<INPUT TYPE=radio NAME="requestmon" VALUE="false" <% if (envt("requestmon") != "true") printf("CHECKED"); %>> Off<br>
<INPUT TYPE=text NAME="requestmonmax" VALUE="<%=txt2html(envt("requestmonmax"));%>" SIZE=8 MAXLENGTH=8 ptype="int" required="true" onkeypress="return handleEnter(this, event)"> attempts<BR>
<INPUT TYPE=text NAME="requestmonwait" VALUE="<%=txt2html(envt("requestmonwait"));%>" SIZE=8 MAXLENGTH=8 ptype="int" required="true" onkeypress="return handleEnter(this, event)"> sec
</TD></TR>
<TR><TD colspan=2>
<ul><li id="l_105" class="closed"><a class="about" href="#" onclick="return show(105)">About</a>
</li><div id="m_105" class="hidden" style="position:relative">
Impose a limit on the number of invalid requests after which the IP
attempting to login will be blocked for the period of time specified.
</div></ul>
</TD></TR>

<TR valign=top><TD nowrap><B>Don't Monitor IPs</B></TD>
<TD width=80%>
<INPUT TYPE=text NAME="nomonip" VALUE="<%=txt2html(envt("nomonip"));%>" SIZE=40 MAXLENGTH=200 onkeypress="return handleEnter(this, event)"><BR>
</TD></TR>
<TR><TD colspan=2>
<ul><li id="l_111" class="closed"><a class="about" href="#" onclick="return show(111)">About</a>
</li><div id="m_111" class="hidden" style="position:relative">
The IP addresses specified above will not be monitored or blocked.  Wildcard
characters (i.e. *) can be used to permit access to an larger IP block.
The "Don't Throttle IPs" rules above is also applied to request and 
login monitoring.
</div></ul>
</TD></TR>

<TR valign=top><TD nowrap><B>Bandwidth per-IP</B></TD>
<TD width=80%>
<INPUT TYPE=text NAME="throttleio" VALUE="<%=size2string(envt("throttleio"));%>" SIZE=8 MAXLENGTH=8 required="true" onkeypress="return handleEnter(this, event)">
</TD></TR>
<TR><TD colspan=2>
<ul><li id="l_106" class="closed"><a class="about" href="#" onclick="return show(106)">About</a>
</li><div id="m_106" class="hidden" style="position:relative">
Impose a limit on the volume (data sent and received) per period 
(daily by default), which when exceeded results in subsequent requests being 
denied with a failure message.
If the <code>I/O</code> volume is specified (i.e. non-zero), IP
bandwidth throttling is enabled (i.e. 100-MB).
</div></ul>
</TD></TR>

<TR valign=top><TD nowrap><B>Bandwidth per-user</B></TD>
<TD width=80%>
<INPUT TYPE=text NAME="throttlereceive" VALUE="<%=size2string(envt("throttlereceive"));%>" SIZE=8 MAXLENGTH=8 required="true" onkeypress="return handleEnter(this, event)"> Incoming<br>
<INPUT TYPE=text NAME="throttlesend" VALUE="<%=size2string(envt("throttlesend"));%>" SIZE=8 MAXLENGTH=8 required="true" onkeypress="return handleEnter(this, event)"> Outgoing
</TD></TR>
<TR><TD colspan=2>
<ul><li id="l_107" class="closed"><a class="about" href="#" onclick="return show(107)">About</a>
</li><div id="m_107" class="hidden" style="position:relative">
Impose a limit on the volume (data sent and/or received) per period
(daily by default), which when exceeded results in subsequent requests 
being denied with a failure message.  If either the <code>Incoming</code> or 
<code>Outgoing</code> volumes are specified (i.e. non-zero), user throttling 
is enabled (i.e. 100-MB).  (Note: Applies only to authenticated users.)
</div></ul>
</TD></TR>

<TR valign=top><TD nowrap><B>Bandwidth per-VHOST</B></TD>
<TD width=80%>
<INPUT TYPE=text NAME="throttlevreceive" VALUE="<%=size2string(envt("throttlevreceive"));%>" SIZE=8 MAXLENGTH=8 required="true" onkeypress="return handleEnter(this, event)"> Incoming<br>
<INPUT TYPE=text NAME="throttlevsend" VALUE="<%=size2string(envt("throttlevsend"));%>" SIZE=8 MAXLENGTH=8 required="true" onkeypress="return handleEnter(this, event)"> Outgoing
</TD></TR>
<TR><TD colspan=2>
<ul><li id="l_108" class="closed"><a class="about" href="#" onclick="return show(108)">About</a>
</li><div id="m_108" class="hidden" style="position:relative">
Impose a limit on the volume (data sent and/or received) per period
(daily by default), which when exceeded results in subsequent requests 
being denied with a failure message.  If either the <code>Incoming</code> or 
<code>Outgoing</code> volumes are specified (i.e. non-zero), VHOST throttling 
is enabled (i.e. 100-MB).
</div></ul>
</TD></TR>

<% if (envt("mailserver") == "true") { %>

<TR valign=top><TD nowrap><B>SMTP Messages per-IP</B></TD>
<TD width=80%>
<INPUT TYPE=text NAME="throttleipsmtp" VALUE="<%=txt2html(envt("throttleipsmtp"));%>" SIZE=8 MAXLENGTH=8 ptype="int" required="true" onkeypress="return handleEnter(this, event)"> Messages
</TD></TR>
<TR><TD colspan=2>
<ul><li id="l_109" class="closed"><a class="about" href="#" onclick="return show(109)">About</a>
</li><div id="m_109" class="hidden" style="position:relative">
Impose a limit on the number of SMTP (mail) messages per period 
(daily by default), which when exceeded results in subsequent requests being 
denied with a failure message.
</div></ul>
</TD></TR>

<TR valign=top><TD nowrap><B>SMTP Messages per-user</B></TD>
<TD width=80%>
<INPUT TYPE=text NAME="throttlesmtp" VALUE="<%=txt2html(envt("throttlesmtp"));%>" SIZE=8 MAXLENGTH=8 ptype="int" required="true" onkeypress="return handleEnter(this, event)"> Messages
</TD></TR>
<TR><TD colspan=2>
<ul><li id="l_110" class="closed"><a class="about" href="#" onclick="return show(110)">About</a>
</li><div id="m_110" class="hidden" style="position:relative">
Impose a limit on the number of SMTP (mail) messages per period
(daily by default), which when exceeded results in subsequent requests 
being denied with a failure message.  (Note: Applies only to authenticated 
SMTP users.)
</div></ul>
</TD></TR>

<% } %>

</TABLE>
<P>
<INPUT TYPE=submit class="mod" VALUE="Update Throttling Configuration">
</FORM>
<%
#include "../footer.asp"
%>
</BODY></HTML>
