<HTML>
<HEAD><TITLE><%=txt2html(envt("servername"));%> - Security Administration</TITLE>
<% 
#include "../header.asp"
menu = "security";
#include "../menu.asp"
area = "throttle";
#include "submenu.asp"

type = findParameter($params, "type", "recent");
w = findParameter($params, "w", "ip");
if ((w == "ip") && (envt("throttleips") != "true"))
  	w = "user";

if ((w == "user") && (envt("throttleusers") != "true"))
	w = "vhost";

pos = indexOf(type, '-');
if (pos > 0)
{
	w = substr(type, pos + 1, strlen(type));
	type = substr(type, 0, pos);
}

resetip = getParameter($params, "resetip");
if (resetip != NULL)
	ipThrottleReset(resetip);

lockip = getParameter($params, "lockip");
if (lockip != NULL)
	ipThrottleLock(lockip, "true");

unlockip = getParameter($params, "unlockip");
if (unlockip != NULL)
	ipThrottleLock(unlockip, "false");

resetuser = getParameter($params, "resetuser");
if (resetuser != NULL)
	userThrottleReset(resetuser);

lockuser = getParameter($params, "lockuser");
if (lockuser != NULL)
	userThrottleLock(lockuser, "true");

unlockuser = getParameter($params, "unlockuser");
if (unlockuser != NULL)
	userThrottleLock(unlockuser, "false");

resetvhost = getParameter($params, "resetvhost");
if (resetvhost != NULL)
	vhostThrottleReset(resetvhost);

lockvhost = getParameter($params, "lockvhost");
if (lockvhost != NULL)
	vhostThrottleLock(lockvhost, "true");

unlockvhost = getParameter($params, "unlockvhost");
if (unlockvhost != NULL)
	vhostThrottleLock(unlockvhost, "false");

int mailserver = 0;
if (envt("mailserver") == "true")
	mailserver = 1;

ini = iniopen("config.ini");
%>
<table border=0 width=98%><tr><td nowrap>
<B>Throttle Usage</B>
&nbsp;&nbsp;&nbsp;
[ <A HREF="/sysadmin/security/throtcnf.asp">Configure</A> ]
</td><td nowrap align=right>
<A TARGET="help" HREF="/syshelp/throttle.htm"><small>
<%=message("sa.Help", locale());%></small></A>
</td></tr></table>
<P>
<table border=0 width=90%>
<tr valign=top><td nowrap>
<form name=selreport method=GET action="/sysadmin/security/throttle.asp">
<select name="type" onchange='javascript:document.selreport.submit();'>
<option value="">-- Select Report --</option>
<% if (envt("loginmon") == "true") { %>
  <option value="logins-mon">Invalid Logins</option>
<% } %>
<% if (envt("requestmon") == "true") { %>
  <option value="requests-mon">Invalid Requests</option>
<% } %>
<% if (envt("throttleips") == "true") { %>
  <option value="maxio-ip">IPs by Usage</option>
  <option value="maxreqs-ip">IPs by Connections</option>
<% if (mailserver == 1) { %>
      <option value="maxsmtp-ip">IPs by Mail Sent</option>

<% } %>
  <option value="recent-ip">Most Recent IPs</option>
<% } %>
<% if (envt("throttleusers") == "true") { %>
  <option value="maxio-user">Users by Usage</option>
  <option value="maxreqs-user">Users by Requests</option>
<% if (mailserver == 1) { %>
      <option value="maxsmtp-user">Users by Mail Sent</option>

<% } %>
  <option value="recent-user">Most Recent Users</option>
<% } %>
<% if (envt("throttlevhosts") == "true") { %>
  <option value="maxio-vhost">VHOSTs by Usage</option>
  <option value="maxreqs-vhost">VHOSTs by Requests</option>
<% } %>
</select></form>
</td><td width=20%>&nbsp;</td><td nowrap width=30%>
<ul><li id="l_101" class="closed"><a class="about" href="#" onclick="return show(101)">Configuration</a>
</li><div id="m_101" class="hidden" style="position:relative">
<table border=0 cellpadding=0 cellspacing=0 bgcolor=#efefef>
<% if (envt("throttleips") == "true") { %>
    <tr><td nowrap>Max I/O per-IP address</td>
    <td nowrap>&nbsp;&nbsp<b><%=size2string(envt("throttleio"));%></b></td></tr>
  <% if ((mailserver == 1) && (atoi(envt("throttleipsmtp")) > 0)) { %>
    <tr><td nowrap>Max Messages per-IP address</td>
    <td nowrap>&nbsp;&nbsp<b><%=txt2html(envt("throttleipsmtp"));%> Msgs</b></td></tr>
  <% } %>
<% } %>
<% if (envt("throttleusers") == "true") { %>
    <tr><td nowrap>Max per-user upload</td>
    <td nowrap>&nbsp;&nbsp<b><%=size2string(envt("throttlereceive"));%></b></td></tr>
    <tr><td nowrap>Max per-user download</td>
    <td nowrap>&nbsp;&nbsp<b><%=size2string(envt("throttlesend"));%></b></td></tr>
    <tr><td nowrap>Max per-user reqs</td>
    <td nowrap>&nbsp;&nbsp<b><%=envt("throttleureqs");%></b></td></tr>
  <% if ((mailserver == 1) && (atoi(envt("throttlesmtp")) > 0)) { %>
    <tr><td nowrap>Max Messages per-user</td>
    <td nowrap>&nbsp;&nbsp<b><%=txt2html(envt("throttlesmtp"));%> Msgs</b></td></tr>
  <% } %>
<% } %>
<% if (envt("throttlevhosts") == "true") { %>
    <tr><td nowrap>Max per-vhost upload</td>
    <td nowrap>&nbsp;&nbsp<b><%=size2string(envt("throttlevreceive"));%></b></td></tr>
    <tr><td nowrap>Max per-vhost download</td>
    <td nowrap>&nbsp;&nbsp<b><%=size2string(envt("throttlevsend"));%></b></td></tr>
<% } %>

<tr><td nowrap>Concurrent Requests</td>
    <td nowrap>&nbsp;&nbsp<b><%=iniget(ini, "common", "Throttle IPs");%></b></td></tr>
<tr><td nowrap>Connections per-IP</td>
    <td nowrap>&nbsp;&nbsp;<b><%=iniget(ini, "common", "Throttle IP Requests");%></b></td></tr>
<tr><td nowrap>Monitor Logins</td>
    <td nowrap>&nbsp;&nbsp;<b><%=(envt("loginmon") == "true") ? "enabled" : "disabled";%></b></td></tr>
<tr><td nowrap>Monitor Requests</td>
    <td nowrap>&nbsp;&nbsp;<b><%=(envt("requestmon") == "true") ? "enabled" : "disabled";%></b></td></tr>
<tr><td nowrap>Throttle IP Size</td>
    <td nowrap>&nbsp;&nbsp;<b><%=iniget(ini, "common", "Throttle IP Size");%></b></td></tr>
<tr><td nowrap>Throttle IP Period</td>
    <td nowrap>&nbsp;&nbsp;<b><%=iniget(ini, "common", "Throttle IP Period");%></b></td></tr>
<tr><td nowrap>Throttle User Period</td>
    <td nowrap>&nbsp;&nbsp;<b><%=iniget(ini, "common", "Throttle User Period");%></b></td></tr>
<tr><td nowrap>Throttle VHOST Period</td>
    <td nowrap>&nbsp;&nbsp;<b><%=iniget(ini, "common", "Throttle VHOST Period");%></b></td></tr>
</table>
</div>
</td><td width=20%>&nbsp;</td><td nowrap width=30%>
<ul><li id="l_102" class="closed"><a class="about" href="#" onclick="return show(102)">Reports</a>
</li><div id="m_102" class="hidden" style="position:relative">
<B>Rotated Throttle Logs</B><BR>
<%
	myparams = allocParameters();
	setParameter(myparams, "nav", "/sysadmin/security/throttle.asp");
	setParameter(myparams, "path", "/sysadmin/reports/throttle");
	if (getParameter($params, "month") != NULL)
	{
		setParameter(myparams, "month", getParameter($params, "month"));
		setParameter(myparams, "year", getParameter($params, "year"));
	}
	rpc("calendar", myparams);
%>
</div>
</td></tr>
</table>
<P>
<%
if ((envt("throttleips") == "true") && (w == "ip"))
{
	results = ipsThrottle(type);
%>
    <% if (type == "maxio") { %>
    <B>Top IP Addresses by Usage</B>
    <% } else if (type == "maxreqs") { %>
    <B>Top 100 IP Addresses by Connections</B>
    <% } else if (type == "maxsmtp") { %>
    <B>Top 100 IP Addresses by Mail Sent</b>
    <% } else if (type == "recent") { %>
    <B>Most recent 100 IP Addresses</B>
    <% } %>
    <a href="/sysuser/rss/throttle.asp?id=<%=urlencode(getUserId($request));%>&type=<%=txt2html(type);%>&w=<%=txt2html(w);%>"><img src="/sysimage/icons/xml.gif" alt="Throttling via RSS feed" align="texttop" name="rss" border="0"></a>
    <BR>
    <BR>
    <table border=0 cellpadding=4>
    <tr valign=top bgcolor=#cccccc>
    <td nowrap><b>IP Address</b></td>
    <td nowrap align=right><b>Last Connect</b></td>
    <td nowrap align=right><b>Connections</b></td>
<%  if (mailserver == 1) { %>
    <td nowrap align=right><b>Mail Sent</b></td>
<%  } %>
    <td nowrap align=right><b>Outbound I/O</b></td>
    <td nowrap align=right><b>Inbound I/O</b></td>
    <td nowrap align=right><b>Invalid Logins</b></td>
    <td nowrap align=right><b>Invalid Requests</b></td>
    <td nowrap align=right><b>Locked?</b></td>
    <td>&nbsp;</td>
    <td>&nbsp;</td></tr>
    <%
    for (j = 0; j < sizeof(results); j++) 
    {
		tip = results[j];
		printf("<tr valign=bottom nowrap><td>%s</td>", tip.ipaddr);
		printf("<td nowrap align=right>&nbsp; &nbsp; &nbsp; &nbsp; ");
        if (tip.lastused == 0)
	    	printf("n/a");
		else
	    	printf("%s", strftime(tip.lastused, "%d %b %Y %H:%M:%S"));
		printf("</td>");

		printf("<td nowrap align=right>%s</td>",
	    	tip.maxreqs ? "<B>Max Connections</B> " : (char *)tip.requests);
		if (mailserver == 1)
		{
			printf("<td nowrap align=right>%s</td>",
	    		(tip.maxsmtp && tip.smtp > 0) ? 
				"<B>Max Msgs</B> " : (char *)tip.smtp);
		}
		printf("<td nowrap align=right>%s</td>",
	    	tip.maxio ? "<B>Max I/O</B> " : getSizeK((int)(tip.send / 1024)));
		printf("<td nowrap align=right>%s</td>",
	    	tip.maxio ? "<B>Max I/O</B> " : getSizeK((int)(tip.receive / 1024)));
		printf("<td nowrap align=right>%s</td>",
	    	tip.maxbadlogins ? "<B>Max Logins</B> " : 
			(char *)tip.badlogins);
		printf("<td nowrap align=right>%s</td>",
	    	tip.maxbadrequests ? "<B>Max Requests</B> " : 
			(char *)tip.badrequests);
		printf("<td nowrap align=right>%s</td>",
	    	tip.locked ? "<B>Yes</B> " : "No");
		printf("<td nowrap align=right>");
		printf("<form method=post action=\"/sysadmin/security/throttle.asp\">");
		printf("<input type=hidden name=\"w\" value=\"ip\">");
		printf("<input type=hidden name=\"type\" value=\"%s\">", type);
		if (tip.locked)
		{
			printf("<input type=hidden name=\"unlockip\" value=\"%s\">", 
				tip.ipaddr);
			printf("<input type=submit class=\"mod\" value=\"unlock\">");
		}
		else
		{
			printf("<input type=hidden name=\"lockip\" value=\"%s\">", 
				tip.ipaddr);
			printf("<input type=submit class=\"mod\" value=\"lock\">");
		}
		printf("</form></td>\n");
		printf("<td nowrap align=right>");
		printf("<form method=post action=\"/sysadmin/security/throttle.asp\">");
		printf("<input type=hidden name=\"w\" value=\"ip\">");
		printf("<input type=hidden name=\"type\" value=\"%s\">", type);
		printf("<input type=hidden name=\"resetip\" value=\"%s\">", 
			tip.ipaddr);
		printf("<input type=submit class=\"mod\" value=\"reset\">");
		printf("</form></td></tr>\n");
    } 
    %>
    </table>
<%
}
else if ((envt("throttleusers") == "true") && (w == "user"))
{
	results = usersThrottle(type);
%>
    <% if (type == "maxio") { %>
    <B>Top 100 users by Usage</b>
    <% } else if (type == "maxreqs") { %>
    <B>Top 100 users by Requests</b>
    <% } else if (type == "maxsmtp") { %>
    <B>Top 100 users by Mail Sent</b>
    <% } else if (type == "recent") { %>
    <B>Most recent 100 users</b>
    <% } %>
    <a href="/sysuser/rss/throttle.asp?id=<%=urlencode(getUserId($request));%>&type=<%=txt2html(type);%>&w=<%=txt2html(w);%>"><img src="/sysimage/icons/xml.gif" alt="Throttling via RSS feed" align="texttop" name="rss" border="0"></a>
    <BR>
    <BR>
    <table border=0 cellpadding=4>
    <tr valign=top bgcolor=#cccccc>
    <td nowrap><b>User Login</b></td>
    <td nowrap align=right><b>Last Login</b></td>
    <td nowrap align=right><b>Logins</b></td>
    <td nowrap align=right><b>Last IP</b></td>
    <td nowrap align=right><b>Last Request</b></td>
    <td nowrap align=right><b>Requests</b></td>
<%  if (mailserver == 1) { %>
    <td nowrap align=right><b>Mail Sent</b></td>
<%  } %>
    <td nowrap align=right><b>Outbound I/O</b></td>
    <td nowrap align=right><b>Inbound I/O</b></td>
    <td nowrap align=right><b>Locked?</b></td>
    <td>&nbsp;</td>
    <td>&nbsp;</td></tr>
    <%
    for (j = 0; j < sizeof(results); j++) 
    {
		user = results[j];
		printf("<tr valign=bottom nowrap><td>%s</td>", user.name);
		printf("<td nowrap align=right>&nbsp; &nbsp;<small>");
        if (user.lastlogin == 0)
	    	printf("n/a");
		else
	    	printf("%s", strftime(user.lastlogin, "%d %b %Y %H:%M:%S"));
		printf("</small></td>");

		printf("<td nowrap align=right>&nbsp; &nbsp; %d</td>",
			user.logins);

		printf("<td nowrap align=right>&nbsp; &nbsp; %s</td>",
			user.ipaddr);

		printf("<td nowrap align=right>&nbsp; &nbsp;<small>");
        if (user.lastused == 0)
	    	printf("n/a");
		else
	    	printf("%s", strftime(user.lastused, "%d %b %Y %H:%M:%S"));
		printf("</small></td>");

		printf("<td nowrap align=right>%s</td>", 
	    	user.maxreqs ? "<B>Max Requests</B> " : (char *)user.requests);

		if (mailserver == 1)
		{
			printf("<td nowrap align=right>%s</td>",
    			(user.maxsmtp  && user.smtp > 0) ? 
				"<B>Max Msgs</B> " : (char *)user.smtp);
		}
		printf("<td nowrap align=right>%s</td>",
	    	user.maxsend ? "<B>Max I/O</B> " : getSizeK((int)(user.send / 1024)));
		printf("<td nowrap align=right>%s</td>",
	    	user.maxreceive ? "<B>Max I/O</B> " : getSizeK((int)(user.receive / 1024)));
		printf("<td nowrap align=right>%s</td>",
	    	user.locked ? "<B>Yes</B> " : "No");
		printf("<td nowrap align=right>");
		printf("<form method=post action=\"/sysadmin/security/throttle.asp\">");
		printf("<input type=hidden name=\"w\" value=\"user\">");
		printf("<input type=hidden name=\"type\" value=\"%s\">", type);
		if (user.locked)
		{
			printf("<input type=hidden name=\"unlockuser\" value=\"%s\">", 
				txt2html(user.name));
			printf("<input type=submit class=\"mod\" value=\"unlock\">");
		}
		else
		{
			printf("<input type=hidden name=\"lockuser\" value=\"%s\">", 
				txt2html(user.name));
			printf("<input type=submit class=\"mod\" value=\"lock\">");
		}
		printf("</form></td>\n");
		printf("<td nowrap align=right>");
		printf("<form method=post action=\"/sysadmin/security/throttle.asp\">");
		printf("<input type=hidden name=\"w\" value=\"user\">");
		printf("<input type=hidden name=\"type\" value=\"%s\">", type);
		printf("<input type=hidden name=\"resetuser\" value=\"%s\">", 
			txt2html(user.name));
		printf("<input type=submit class=\"mod\" value=\"reset\">");
		printf("</form></td></tr>\n");
    } 
    %>
    </table>
<%
}
else if ((envt("throttlevhosts") == "true") && (w == "vhost"))
{
	if (type == "recent")
		type = "maxreqs";

	results = vhostsThrottle(type);
%>
    <% if (type == "maxio") { %>
    <B>Top 100 VHOSTs by Usage</b>
    <% } else if (type == "maxreqs") { %>
    <B>Top 100 VHOSTs by Requests</b>
    <% } %>
    <a href="/sysuser/rss/throttle.asp?id=<%=urlencode(getUserId($request));%>&type=<%=txt2html(type);%>&w=<%=txt2html(w);%>"><img src="/sysimage/icons/xml.gif" alt="Throttling via RSS feed" align="texttop" name="rss" border="0"></a>
    <BR>
    <BR>
    <table border=0 cellpadding=4>
    <tr valign=top bgcolor=#cccccc>
    <td nowrap><b>VHOST Realm</b></td>
    <td nowrap align=right><b>Requests</b></td>
    <td nowrap align=right><b>Outbound I/O</b></td>
    <td nowrap align=right><b>Inbound I/O</b></td>
    <td nowrap align=right><b>Locked?</b></td>
    <td>&nbsp;</td>
    <td>&nbsp;</td></tr>
    <%
    for (j = 0; j < sizeof(results); j++) 
    {
		vhost = results[j];
		printf("<tr valign=bottom nowrap><td>%s</td>", vhost.name);
		printf("<td nowrap align=right>%d</td>", vhost.requests);
		printf("<td nowrap align=right>%s</td>",
	    	vhost.maxsend ? "<B>Max I/O</B> " : getSizeK((int)(vhost.send / 1024)));
		printf("<td nowrap align=right>%s</td>",
	    	vhost.maxreceive ? "<B>Max I/O</B> " : getSizeK((int)(vhost.receive / 1024)));
		printf("<td nowrap align=right>%s</td>",
	    	vhost.locked ? "<B>Yes</B> " : "No");
		printf("<td nowrap align=right>");
		printf("<form method=post action=\"/sysadmin/security/throttle.asp\">");
		printf("<input type=hidden name=\"w\" value=\"vhost\">");
		printf("<input type=hidden name=\"type\" value=\"%s\">", type);
		if (vhost.locked)
		{
			printf("<input type=hidden name=\"unlockvhost\" value=\"%s\">", 
				txt2html(vhost.name));
			printf("<input type=submit class=\"mod\" value=\"unlock\">");
		}
		else
		{
			printf("<input type=hidden name=\"lockvhost\" value=\"%s\">", 
				txt2html(vhost.name));
			printf("<input type=submit class=\"mod\" value=\"lock\">");
		}
		printf("</form></td>\n");
		printf("<td nowrap align=right>");
		printf("<form method=post action=\"/sysadmin/security/throttle.asp\">");
		printf("<input type=hidden name=\"w\" value=\"vhost\">");
		printf("<input type=hidden name=\"type\" value=\"%s\">", type);
		printf("<input type=hidden name=\"resetvhost\" value=\"%s\">", 
			txt2html(vhost.name));
		printf("<input type=submit class=\"mod\" value=\"reset\">");
		printf("</form></td></tr>\n");
    } 
    %>
    </table>
<%
} 
else if (w == "mon")
{
	if ((type == "logins") && (envt("loginmon") == "true"))
		results = loginThrottle();
	else if ((type == "requests") && (envt("requestmon") == "true"))
		results = requestThrottle();
	else
		results = null;
%>
    <% if (type == "logins") { %>
    <B>Most Recent Invalid Logins (blocked) by IP Address</B>
    <% } else if (type == "requests") { %>
    <B>Most Recent Invalid Requests (blocked) by IP Address</B>
    <% } %>
    <BR>
    <BR>
    <table border=0 cellpadding=4>
    <tr valign=top bgcolor=#cccccc>
    <td nowrap><b>IP Address</b></td>
    <td nowrap align=right><b>Last Connect</b></td>
    <td nowrap align=right><b>Connections</b></td>
<%  if (mailserver == 1) { %>
    <td nowrap align=right><b>Mail Sent</b></td>
<%  } %>
    <td nowrap align=right><b>Outbound I/O</b></td>
    <td nowrap align=right><b>Inbound I/O</b></td>
    <td nowrap align=right><b>Invalid Logins</b></td>
    <td nowrap align=right><b>Invalid Requests</b></td>
    <td nowrap align=right><b>Locked?</b></td>
    <td>&nbsp;</td>
    <td>&nbsp;</td></tr>
    <%
    for (j = 0; j < sizeof(results); j++) 
    {
		tip = results[j];
		printf("<tr valign=bottom nowrap><td>%s</td>", tip.ipaddr);
		printf("<td nowrap align=right>&nbsp; &nbsp; &nbsp; &nbsp; ");
        if (tip.lastused == 0)
	    	printf("n/a");
		else
	    	printf("%s", strftime(tip.lastused, "%d %b %Y %H:%M:%S"));
		printf("</td>");

		printf("<td nowrap align=right>%s</td>",
	    	tip.maxreqs ? "<B>Max Connections</B> " : (char *)tip.requests);
		if (mailserver == 1)
		{
			printf("<td nowrap align=right>%s</td>",
	    		(tip.maxsmtp && tip.smtp > 0) ? 
				"<B>Max Msgs</B> " : (char *)tip.smtp);
		}
		printf("<td nowrap align=right>%s</td>",
	    	tip.maxio ? "<B>Max I/O</B> " : getSizeK((int)(tip.send / 1024)));
		printf("<td nowrap align=right>%s</td>",
	    	tip.maxio ? "<B>Max I/O</B> " : getSizeK((int)(tip.receive / 1024)));
		printf("<td nowrap align=right>%s</td>",
	    	tip.maxbadlogins ? "<B>Max Logins</B> " : 
			(char *)tip.badlogins);
		printf("<td nowrap align=right>%s</td>",
	    	tip.maxbadrequests ? "<B>Max Requests</B> " : 
			(char *)tip.badrequests);
		printf("<td nowrap align=right>%s</td>",
	    	tip.locked ? "<B>Yes</B> " : "No");
		printf("<td nowrap align=right>");
		printf("<form method=post action=\"/sysadmin/security/throttle.asp\">");
		printf("<input type=hidden name=\"w\" value=\"%s\">", w);
		printf("<input type=hidden name=\"type\" value=\"%s\">", type);
		if (tip.locked)
		{
			printf("<input type=hidden name=\"unlockip\" value=\"%s\">", 
				tip.ipaddr);
			printf("<input type=submit class=\"mod\" value=\"unlock\">");
		}
		else
		{
			printf("<input type=hidden name=\"lockip\" value=\"%s\">", 
				tip.ipaddr);
			printf("<input type=submit class=\"mod\" value=\"lock\">");
		}
		printf("</form></td>\n");
		printf("<td nowrap align=right>");
		printf("<form method=post action=\"/sysadmin/security/throttle.asp\">");
		printf("<input type=hidden name=\"w\" value=\"%s\">", w);
		printf("<input type=hidden name=\"type\" value=\"%s\">", type);
		printf("<input type=hidden name=\"resetip\" value=\"%s\">", 
			tip.ipaddr);
		printf("<input type=submit class=\"mod\" value=\"reset\">");
		printf("</form></td></tr>\n");
    } 
    %>
    </table>
<%
}
%>
<%
#include "../footer.asp"
%>
</BODY></HTML>
