<%
i = findParameter($params, "i", "docs");
h = findParameter($params, "h", "true");
sb = findParameter($params, "sb", "weight");
so = findParameter($params, "so", "desc");
sr = (int)findParameter($params, "sr", "<%=SEARCH_RULE_OR;%>");
q = findParameter($params, "q", "");
m = (int)findParameter($params, "m", "25");
if ((m < 1) || (m > 500))
	m = 25;
s = (int)findParameter($params, "s", "0");
if ((s < 0) || (s > 100))
	s = 0;
rowstart = s * m;
index = null;
try
{
	index = searchOpen(i);
	redir = searchRedirect(index, q);
	if (redir != null)
	{
	 	sendRedirect($response, redir);
	 	exit;
	}
}
catch (e)
{
	if (index != null)
		searchClose(index);
	index = null;

    write("\n<!--\n");
    write(exception(e, "info"));
    write("\n-->\n");
}
%>
<HTML>
<HEAD><TITLE>Sambar Services Administration</TITLE>
<% 
#include "../header.asp"
menu = "services";
#include "../menu.asp"
area = "search";
#include "submenu.asp"
%>
<script language="JavaScript">
<!--
function submitForm(start)
{
	f = document.getElementById("search");
	f.s.value = start;
	f.submit();
}
//-->
</script>
<FORM id="search" METHOD=GET ACTION="/sysadmin/services/results.asp">
<TABLE cellpadding=4 width=100%>
<TR><TD nowrap align=right><B>Search for: </B></TD>
<TD align=left width=99%>
<INPUT TYPE=hidden NAME="s" VALUE="0">
<INPUT TYPE=hidden NAME="m" VALUE="<%=m;%>">
<INPUT TYPE=hidden NAME="i" VALUE="<%=txt2html(i);%>">
<INPUT TYPE=hidden NAME="sb" VALUE="<%=txt2html(sb);%>">
<INPUT TYPE=hidden NAME="so" VALUE="<%=txt2html(so);%>">
<INPUT TYPE=hidden NAME="sr" VALUE="<%=sr;%>">
<INPUT NAME="q" SIZE=30 VALUE="<%=txt2html(q);%>" MAXLENGTH=40>&nbsp
<INPUT TYPE=image valign=middle border=0 SRC="/sysimage/system/go.gif" height=15 width=15>
</TD></TR>
</TABLE>
</FORM>
<div style="background: #ffCCCC; border-top: 1px solid #990033; width: 100%">
<span style="float: left"><B><%=txt2html(i);%></B></span>
<% 
	try
	{
		r = searchQuery(index, q, sb, so, m, rowstart, sr);
		if (r != null)
		{
			printf("<span style=\"float: right\"><small>Results <B>%d</B> - <B>%d</B> of <B>%d</B> for <B>%s</B> (%.2f seconds)</small></span><br></div>",
				min(r.matches, rowstart + 1), 
				min(rowstart + m, r.matches), r.matches,
				txt2html(r.query), (float)r.msec / 1000);

			words = strstem(r.query, r.alg);

			results = r.results;
			for (i = 0; i < sizeof(results); i++)
			{
				res = results[i];
				prepend = "/";
				if (sizeof(res.name) == 0)
					res.name = "unknown";

				if ((res.name[0] == '/') ||
					(strnicmp(res.name, "http:", 5) == 0) ||
					(strnicmp(res.name, "ftp:", 4) == 0))
				{
					prepend = "";
				}
		
				printf("<P>");

				if (h == "true")
				{
					printf("<a href=\"/session/highlight?color=red&words=%s&url=%s%s%s\">%s</a><br>",
						txt2html(r.query), 
						res.prepend ? res.prepend : "", 
						prepend, txt2html(res.name), 
						strhilight(txt2html(res.description), words, r.alg));
				}
				else
				{
					printf("<a href=\"%s%s%s\">%s</a><br>",
						res.prepend ? res.prepend : "", 
						prepend, txt2html(res.name), 
						strhilight(txt2html(res.description), words, r.alg));
				}

				if (sizeof(res.info) > 0)
				{
					printf("%s...<br>", 
						strhilight(txt2html(res.info), words, r.alg));
				}

				printf("<font color=green>%s%s%s - %s - %s  [%d/%d]</font><br>", 
					res.prepend ? res.prepend : "", 
					prepend, txt2html(res.name), 
					size2string((char *)res.size), 
					strftime(res.timestamp, "%b %d, %Y"),
					res.count, res.score);
			}

			if (r.matches > 0)
			{
				pageid = (s + 1) % m;
				pagemax = (int)(r.matches / m);
				if (r.matches % m != 0)
					pagemax++;
				if (pagemax < (int)r.matches / m)
					pagemax++;
				printf("<div align=center>Result Page: ");
				for (i = 1; i <= min(pagemax, pageid + 9); i++)
				{
					if (i == pageid)
					{
						printf(" <font color=#990033><b>%d</b></font>", i);
					}
					else
					{
						printf(" <a href=\"#%d\" onClick=\"return submitForm(%d);\">%d</a>", i, i - 1, i);
					}
				}
			}
			else
			{
				printf("<center><b><i>No results matched your query.</i></b></center>");
			}
			printf("</div>");

			searchClose(index);
			index = null;
		}
		else
		{
			printf("<br></div>");
		}
	}
	catch (e)
	{
		if (index != null)
			searchClose(index);

		printf("<b><i>Failure quering search index.</i></b>");
        write("\n<!--\n");
        write(exception(e, "info"));
        write("\n-->\n");
	}
%>
<%
#include "../footer.asp"
%>
</BODY></HTML>
