<HTML>
<HEAD><TITLE><%=txt2html(envt("servername"));%> - Services Administration</TITLE>
<% 
/* Generate JavaScript for CRON */
myparams = allocParameters();
setParameter(myparams, "rpc", "addcron");
rpc("helprpcjs", myparams);

#include "../header.asp"
menu = "services";
#include "../menu.asp"
area = "cron";
#include "submenu.asp"

ini = iniopen("schedule.ini");
action = getParameter($params, "action");
section = getParameter($params, "section");
if ((action == "replace") && (section != NULL))
{
	/* Remove the existing section					*/
	iniexpunge(ini, section);

	i = 0;
	while (i < 99)
	{
		name = getParameter($params, "CN" + i);
		value = getParameter($params, "CV" + i);
		if ((name == NULL) || (strlen(name) == 0) ||
			(value == NULL) || (strlen(value) == 0))
		{
			i++;
			continue;
		}

		name = strsubst(name, "\"", "'", 1);
		iniadd(ini, section, name, value);
		i++;
	}

	inireplace(ini, section);

    printf("<center><div class=\"info\">");
    printf("Task Scheduler updated.<BR>");
    printf("</div></center>");
}

void showMap(char *s)
{
	printf("<form method=post action=\"/sysadmin/services/schedule.asp\">\n");
	printf("<input type=hidden name=\"action\" value=\"replace\">\n");
	printf("<input type=hidden name=\"section\" value=\"%s\">\n", s);

	printf("<table border=0>\n");
	printf("<tr><td>Name</td><td>Action</td></tr>\n");
    	inisort(ini, s);
    	entries = inientries(ini, s);
    	values = inivalues(ini, s);
    	pos = 0;
    	while (pos < sizeof(entries))
    	{
        	name = entries[pos];
        	val = values[pos];
			printf("<tr><td><input type=text name=\"CN%d\" size=40 maxlength=40 value=\"%s\"></td>\n", pos, name);
			printf("<td><input type=text name=\"CV%d\" size=60 maxlength=500 value=\"%s\"></td></tr>\n", pos, val);

        	pos++;
    	} 

	for (i = 0; i < 3; i++) 
	{
		printf("<tr><td><input type=text name=\"CN%d\" size=40 maxlength=40 value=\"\"></td>\n", pos + i);
		printf("<td><input type=text name=\"CV%d\" size=60 maxlength=500 value=\"\"></td></tr>\n", pos + i);
	}

	printf("</table>\n");
	printf("<input type=submit class=\"mod\" value=\"Update Configuration\"></form>\n");
}
%>
<table border=0 width=98%><tr><td nowrap>
<B>Task Scheduler</B><BR>
</td></tr>
</table>
<I>Changes take effect immediately!</I>
<P>
The Sambar Server includes a built-in Scheduler for managing events
such as log file rotation, and search re-indexin.
User defined events can be configured using the interfaces below.
<P>
<BLOCKQUOTE><CODE>
	i.e.<BR>
	Task Description = perl\perl.exe tmp\perltask.pl<BR>
	Task Description = http://www.foo.bar/cgi-bin/run.pl?name=value<BR>
</BLOCKQUOTE></CODE>
<P>
See the <A target="help" HREF="/syshelp/sched.htm">Task Scheduler</A> documentation 
for more details.
<P>
<HR>
<P>
<FONT COLOR=#990033><B>Hourly Scheduled Tasks</B></FONT>
<P>
<% showMap("hourly"); %>
<P>
<HR>
<P>
<FONT COLOR=#990033><B>Daily Scheduled Tasks</B></FONT>
<P>
<% showMap("daily"); %>
<P>
<HR>
<P>
<FONT COLOR=#990033><B>Weekly Schedule Tasks</B></FONT>
<P>
<% showMap("weekly"); %>
<P>
<HR>
<P>
<FONT COLOR=#990033><B>Monthly Scheduled Tasks</B></FONT>
<P>
<% showMap("monthly"); %>
<P>
<HR>
<P>
<FONT COLOR=#990033><B>Startup Tasks</B></FONT>
<P>
<% showMap("startup"); %>
<P>
<HR>
<P>
<FONT COLOR=#990033><B>Shutdown Tasks</B></FONT>
<P>
<% showMap("shutdown"); %>
<%
#include "../footer.asp"
%>
</BODY></HTML>
