<HTML>
<HEAD><TITLE><%=txt2html(envt("servername"));%> - Forum Manager</TITLE>
<% 
#include "../header.asp"
menu = "services";
#include "../menu.asp"
area = "webboard";
#include "submenu.asp"
#include "../../sysuser/webboard/config.asp"

action = getParameter($params, "action");
dbcache = getParameter($params, "dbcache");
%>
<form name=newdb method=post style="bottom-margin: 0" action="/sysadmin/services/webboard.asp">
<table border=0 width=98%><tr><td nowrap>
<B>Forum Manager</B>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<B>DB Cache</B>
<%
printf("<select name=dbcache onchange=\"javascript:document.newdb.submit();\">\n");
printf("<option value=''> -- none --\n");
cachelist = dbcachelist();
for (i = 0; i < sizeof(cachelist); i++)
{
    printf("<option value='%s' %s> %s", 
		cachelist[i], cachelist[i] == dbcache ? "SELECTED" : "", cachelist[i]);
}
printf("</select>\n");
%>
</td>
</tr></table>
</form>
<P>
Installing the Forum requires 3 steps:
<BLOCKQUOTE>
<OL>
<LI> Enable DB Scripting in the System Administrator Services page.  
The Forum uses a database to store entries.
<LI> Make sure you have a DB cache configured for use by the Forum.  
The <code>sqlite</code> cache that is configured by default in the 
<I>config/dbconfig.ini</i> can be used.
<LI> Enable the Forum feature on the System Administrator Services page. 
(<I>To reach this page, you have completed this step.</I>)
<LI> <A HREF="/sysadmin/servers/www.asp">Configure</A> the server and/or
<A HREF="/sysadmin/servers/vhosts.asp">Virtual Host</A> with the DB cache to
use to store Forum entries.
<LI> Install the Forum schema in each DB cache configured in step 2 
(use the pulldown at the top of the page to select each DB cache.)
</OL>
</BLOCKQUOTE>
<P>
<%
	if (sizeof(dbcache) > 0)
	{
		dbm = dbcache(dbcache);

		dbprepare(dbm, "select name from sqlite_master where type='table' and name = '" + topictable + "'", NULL);
		dbexecute(dbm);
		int found = 0;
		while ((a = dbfetch(dbm)) != NULL)
			found = 1;

		if ((action == "install") && (!found))
		{
			printf("Installing Forum in DBMS " + dbcache + "<BR>");

			dbcommand(dbm, "CREATE TABLE " + topictable + 
				"(id INTEGER PRIMARY KEY," +
				"subject VARCHAR(60) NOT NULL," +
				"username VARCHAR(255) NOT NULL," +
				"date TIMESTAMP NOT NULL," +
				"post TEXT NOT NULL," +
				"replies INT NOT NULL," +
				"flags INT DEFAULT 0," +
				"icon VARCHAR(30) NOT NULL)");
			printf("Forum table " + topictable + " created.<br>");

			dbcommand(dbm, "CREATE TABLE " + posttable + 
				"(id INTEGER PRIMARY KEY," +
				"topicid INT NOT NULL," +
				"username VARCHAR(255) NOT NULL," +
				"date TIMESTAMP NOT NULL," +
				"post TEXT NOT NULL," +
				"flags INT DEFAULT 0," +
				"icon VARCHAR(30) NOT NULL)");
			dbcommand(dbm, "CREATE INDEX postidx1 ON " + 
				posttable + " (topicid)");
			dbcommand(dbm, "CREATE UNIQUE INDEX postidx2 ON " + 
				posttable + " (id, topicid)");
			printf("Forum table " + posttable + " created.<br>");
			found = 1;

		}
		else if (action == "uninstall")
		{
			printf("Uninstalling Forum from DBMS " + dbcache + "<BR>");
			dbcommand(dbm, "DROP TABLE " + topictable);
			printf("Forum table " + topictable + " deleted.<br>");
			dbcommand(dbm, "DROP TABLE " + posttable);
			printf("Forum table " + posttable + " deleted.<br>");
			found = 0;
		}

		dbclose(dbm);

		if (found)
		{
			printf("<br>Forum installed in DB cache '%s'.<BR><BR>",
				dbcache);
			printf("<a href=\"/sysadmin/services/webboard.asp?action=uninstall&dbcache=%s\">Uninstall Forum</a><br>", dbcache);
		}
		else
		{
			printf("<BR>Forum is not installed in DB cache '%s'.<BR><BR>",
				dbcache);
			printf("<a href=\"/sysadmin/services/webboard.asp?action=install&dbcache=%s\">Install Forum Schema and Enable</a>", dbcache);
		}
	}
%>
<br>
</P>
<%
#include "../footer.asp"
%>
</BODY></HTML>
