<HTML>
<HEAD><TITLE>Sambar SOAP Utility</TITLE>
<% 
#include "../header.asp"
menu = "utils";
#include "../menu.asp"
area = "soap";
#include "submenu.asp"
%>
<FORM method=get action="google.asp">
<table border=0 cellspacing=4>
<tr><td>Google Key</td>
<td><INPUT NAME=key size=40 VALUE="<%=findParameter($params, "key", ""); %>"></td></tr>
<tr><td>Query</td>
<td><INPUT NAME=query size=40 VALUE="<%=findParameter($params, "query", ""); %>"></td>
</tr>
<tr><td></td>
<td><INPUT TYPE=submit VALUE="Google Search"></td></tr>
</tr>
</table>
</FORM>
<CENTER>
<%
key = getParameter($params, "key");
query = getParameter($params, "query");
if ((key != NULL) && (query != NULL))
{
	/*
	** query Google using their SOAP interface
	*/
	$soap = soapService("http://api.google.com/search/beta2", 
		"doGoogleSearch", "GoogleSearch");
	soapPropertySet($soap, "action", "urn:GoogleSearchAction");
	soapParameterAdd($soap, "key", key);
	soapParameterAdd($soap, "q", query);
	soapParameterAdd($soap, "start", 0);
	soapParameterAdd($soap, "maxResults", 10);
	soapParameterAdd($soap, "filter", (boolean)1);
	soapParameterAdd($soap, "restrict", "");
	soapParameterAdd($soap, "safeSearch", (boolean)0);
	soapParameterAdd($soap, "lr", "");
	soapParameterAdd($soap, "ie", "latin1");
	soapParameterAdd($soap, "oe", "latin1");

	/* Google failed to implement chunking from the HTTP/1.1 spec.	*/
	soapPropertySet($soap, "chunk", "false");
	soapCall($soap);

	ret = soapResultGet($soap, "return");
	int end = ret.endIndex;
	int start = ret.startIndex;
	int esttotal = ret.estimatedTotalResultsCount;
	double gtime = ret.searchTime;
	char *query = ret.searchQuery;

	printf("<table width=90% bgcolor=#3366cc cellPadding=1>\n");
	printf("<td nowrap bgColor=#3366cc><font color=#ffffff size=-1>");
	printf("Searched the web for '%s'.&nbsp;</font></td>", query);
	printf("<td nowrap align=right bgcolor=#3366cc>");
	printf("<font color=#ffffff size=-1>Results <B>%d</B> - <B>%d</B> of ",
		start, end);
	printf("about <B>%d</B>. Search took <B>%.02f</B> sec.</font>",
		esttotal, gtime);
	printf("</td></tr></table>\n");
	printf("<table width=90% cellPadding=1><tr><td>\n");

	results = ret.resultElements;
	for (i = 0; i < sizeof(results); i++)
	{
		result = results[i];
		printf("<BR><BR><A href=\"%s\">%s</A><BR>\n", result.URL, result.title);
		printf("<FONT size=-1>%s</FONT><BR>\n", result.snippet);

		if ((result.summary != NULL) && (result.summary != ""))
		{
			printf("<FONT COLOR=#666666 size=-1>Description:</FONT>%s<BR>", 
				result.summary);
		}

		printf("<FONT COLOR=#008800>%s - %s</FONT><BR>", 
			result.URL, result.cachedSize);
	}


	printf("</td></tr></table>\n");
	soapServiceFree($soap);
}
else
{
%>
<BR>
Note:  In order to use the Google Web APIs you must first register
with Google to recieve an authentication key.  You can do this online
at <A HREF="http://www.google.com/apis/">http://www.google.com/apis/</A>.
<BR>
Your key will have a limit on the number of requests a data that you
can make.  The default limit is 1000 queries per day.
<%
}
%>
</CENTER>
<%
#include "../footer.asp"
%>
</BODY></HTML>
