<HTML>
<HEAD><TITLE>Sambar SOAP Utility</TITLE>
<% 
#include "../header.asp"
menu = "utils";
#include "../menu.asp"
area = "soap";
#include "submenu.asp"
%>
<B>Registering soap interop services...</B>
<P><PRE><CODE>
/*
** Register SOAP Services
*/
myparams = allocParameters();
setParameter(myparams, "echoNull", "null");
soapRegister("echoNull", myparams, myparams, SOAP_AUTH_ALL, 
	"/tests/echoNull.c", "Echo a NULL value.");

myparams = allocParameters();
setParameter(myparams, "echoString", "string");
soapRegister("echoString", myparams, myparams, SOAP_AUTH_ALL, 
	"/tests/echoString.c", "Echo a string.");

myparams = allocParameters();
setParameter(myparams, "echoStringArray", "ArrayOfString");
soapRegister("echoStringArray", myparams, myparams, SOAP_AUTH_ALL, 
	"/tests/echoStringArray.c", "Echo a string array.");

myparams = allocParameters();
setParameter(myparams, "echoInteger", "int");
soapRegister("echoInteger", myparams, myparams, SOAP_AUTH_ALL, 
	"/tests/echoInteger.c", "Echo an integer.");

myparams = allocParameters();
setParameter(myparams, "echoIntegerArray", "ArrayOfInt");
soapRegister("echoIntegerArray", myparams, myparams, SOAP_AUTH_ALL, 
	"/tests/echoIntegerArray.c", "Echo an integer array.");

myparams = allocParameters();
setParameter(myparams, "echoFloat", "float");
soapRegister("echoFloat", myparams, myparams, SOAP_AUTH_ALL, 
	"/tests/echoFloat.c", "Echo a floating point number.");

myparams = allocParameters();
setParameter(myparams, "echoFloatArray", "ArrayOfFloat");
soapRegister("echoFloatArray", myparams, myparams, SOAP_AUTH_ALL, 
	"/tests/echoFloatArray.c", "Echo an array of floating point numbers.");

</CODE></PRE></P>
<%
/*
** Register SOAP Services
*/
myparams = allocParameters();
setParameter(myparams, "echoNull", "null");
soapRegister("echoNull", myparams, myparams, SOAP_AUTH_ALL, 
	"/tests/echoNull.c", "Echo a NULL value.");
myparams = allocParameters();
setParameter(myparams, "echoString", "string");
soapRegister("echoString", myparams, myparams, SOAP_AUTH_ALL, 
	"/tests/echoString.c", "Echo a string.");
myparams = allocParameters();
setParameter(myparams, "echoStringArray", "ArrayOfString");
soapRegister("echoStringArray", myparams, myparams, SOAP_AUTH_ALL, 
	"/tests/echoStringArray.c", "Echo a string array.");
myparams = allocParameters();
setParameter(myparams, "echoInteger", "int");
soapRegister("echoInteger", myparams, myparams, SOAP_AUTH_ALL, 
	"/tests/echoInteger.c", "Echo an integer.");
myparams = allocParameters();
setParameter(myparams, "echoIntegerArray", "ArrayOfInt");
soapRegister("echoIntegerArray", myparams, myparams, SOAP_AUTH_ALL, 
	"/tests/echoIntegerArray.c", "Echo an integer array.");
myparams = allocParameters();
setParameter(myparams, "echoFloat", "float");
soapRegister("echoFloat", myparams, myparams, SOAP_AUTH_ALL, 
	"/tests/echoFloat.c", "Echo a floating point number.");
myparams = allocParameters();
setParameter(myparams, "echoFloatArray", "ArrayOfFloat");
soapRegister("echoFloatArray", myparams, myparams, SOAP_AUTH_ALL, 
	"/tests/echoFloatArray.c", "Echo an array of floating point numbers.");
%>
<B>Done registering services...</B>
<P>
<B>Notes...</B>
<UL>
<LI> SOAP services can be registered via the authentication properties: 
<B>SOAP_AUTH_ALL</B> | <B>SOAP_AUTH_USER</B> | <B>SOAP_AUTH_ADMIN</B></LI>
<LI>The <I>path</I> to the file must be specified as either a complete,
file-system path, or the file is assumed to be relative to the <I>syssoap</I>
directory.
<LI>To execute echoInteger() via SOAP::Lite you would use the following:
<BR>
<blockquote><PRE>
use SOAP::Lite;

print SOAP::Lite
        -> proxy('http://localhost/soap')
        -> uri('urn:echoInteger')
        -> echoInteger(SOAP::Data->name("echoInteger")->value(5)->type("int"))
        -> result;
</pre></blockquote>
</UL>
<P>
<I>Hint!</I> To register services "automatically" when the server starts
up, you can place the above calls in the <I>config/globals.c</I> file.
The CScript ASP engine loads and executes the <I>config/globals.c</I>
file at startup of the server. 
<%
#include "../footer.asp"
%>
</BODY></HTML>
