<HTML>
<HEAD><TITLE><%=txt2html(envt("servername"));%> - Amazon S3 Utility</TITLE>
<%
#include "../../header.asp"
menu = "utils";
#include "../../menu.asp"
area = "s3";
#include "../submenu.asp"
#include "list.asp"

s3 = s3init(envt("s3key"), envt("s3secret"));

bucket = getParameter($params, "bucket");
action = getParameter($params, "action");
name = getParameter($params, "name");
if ((action == "mkfile") && (sizeof(name) > 0))
{
	try
	{
		path = getParameter($params, "path");
		mime = getParameter($params, "mime");
		md5 = getParameter($params, "md5");
		acl = getParameter($params, "acl");
		s3mkfile(s3, bucket, name, mime, acl, path, md5);
 		printf("<center><div class=\"info\">");
 		printf("File %s created in Amazon S3 bucket %s.", 
			txt2html(name), txt2html(bucket));
 		printf("</div></center>");
	}
	catch (e)
	{
		write("<!--\n");
		write(exception(e, "info"));
		write("\n-->\n");
 		printf("<center><div class=\"error\">");
 		printf("Unable to create Amazon S3 file %s...", txt2html(name));
		printf("<BR>" + exception(e, "message"));
 		printf("</div></center>");
	}
}

if ((action == "rmfile") && (sizeof(name) > 0))
{
	try
	{
		// First remove a file.
		s3rmfile(s3, bucket, name);
 		printf("<center><div class=\"info\">");
 		printf("File %s deleted from bucket %s in Amazon S3 repository.", 
			txt2html(name), txt2html(bucket));
 		printf("</div></center>");
	}
	catch (e)
	{
		write("<!--\n");
		write(exception(e, "info"));
		write("\n-->\n");
 		printf("<center><div class=\"error\">");
 		printf("Unable to delete Amazon S3 file %s...", txt2html(name));
		printf("<BR>" + exception(e, "message"));
 		printf("</div></center>");
	}
}

if ((action == "setacl") && (sizeof(name) > 0))
{
	try
	{
		acl = getParameter($params, "acl");
		s3setacl(s3, bucket, name, acl);
 		printf("<center><div class=\"info\">");
 		printf("File %s ACL set to %s in Amazon S3 repository.", 
			txt2html(name), txt2html(acl));
 		printf("</div></center>");
	}
	catch (e)
	{
		write("<!--\n");
		write(exception(e, "info"));
		write("\n-->\n");
 		printf("<center><div class=\"error\">");
 		printf("Unable to set ACL on Amazon S3 file %s...", txt2html(name));
		printf("<BR>" + exception(e, "message"));
 		printf("</div></center>");
	}
}
%>
	<SCRIPT language=JavaScript>
	<!--
	agent = navigator.userAgent;
	browserOK = 0;
	if (navigator.appName == "Netscape" && 
		navigator.appVersion.substring(0,1) >= 2)
	{
		browserOK = 1
	}
	else 
	{
		if (navigator.appName == "Microsoft Internet Explorer" && 
			navigator.appVersion.substring(0,1) >= 4)
		{
			browserOK = 1
		}
	}
	//-->
	</SCRIPT>
	<% err = getParameter($params, "err");
	   if (sizeof(err) > 0) { 
	%>
		<BLOCKQUOTE>
		<div class="error"><B>Error! <%=err;%></B></div>
		</BLOCKQUOTE>
		<BR>
	<% } %>

	<font size=+1><B>Amazon S3 Bucket <i><%=txt2html(bucket);%></i></font></B>
	<BR><BR>
	http://s3.amazonaws.com/<%=txt2html(bucket);%>/<i>filename</i>
	<br>

	<!--- ---------- --->
	<!---    BODY    --->
	<!--- ---------- --->
	<blockquote>
	<div id="tabledata">
	<table align=center width=80% border=0 cellpadding=4 cellspacing=0 style="border: 1px solid black">
	<tr bgcolor="#ffff88" id="headerRow">
		<td nowrap style="border:1px solid black; border-width: 0 0 1px 0">
		<a href="javascript:rowSort('1', 1)" title="Sort by Bucket">
		File</div></td>
		<td nowrap style="border:1px solid black; border-width: 0 0 1px 0">
		<a href="javascript:rowSort('2', 1)" title="Last Modified Date">
		Last Modified</div></td>
		<td nowrap style="border:1px solid black; border-width: 0 0 1px 0">
		<a href="javascript:rowSort('3', 1)" title="Size">
		Size</div></td>
		<td width=90% style="border:1px solid black; border-width: 0 0 1px 0">
		&nbsp;</td>
	</tr>

	<% 
		try
		{
			files = s3files(s3, bucket);
			for (i = 0; i < sizeof(files); i++)
			{
				showFile(files[i], bucket, i);
			}

			if (sizeof(files) == 0)
			{
				printf("<tr><td colspan=5 align=center>");
				printf("<i>No files in S3 bucket.</i>");
				printf("</td></tr>");
			}
		}
		catch (e)
		{
			write("<!--\n");
			write(exception(e, "info"));
			write("\n-->\n");
			printf("<BR><B>" + exception(e, "message") + "</B><BR>");
		}
	%>

	</table>
	</div>

	<br>
	<hr>
	<br>
	<FORM METHOD="POST" ACTION="/sysadmin/utils/amazons3/files.asp"
 		onSubmit="return validateForm(this)">
	<input type=hidden name="action" value="mkfile">
	<input type=hidden name="bucket" value="<%=txt2html(bucket);%>">
	<TABLE border=0 cellspacing=4>
	<TR><TD nowrap><B>File Name</B></TD>
	    <TD><input type=text name="name" value="" size=40 maxlength=40 required="true"></TD></TR>
	<TR><TD nowrap><B>Mime Type</B></TD>
	    <TD><input type=text name="mime" value="application/octet-stream" size=40 maxlength=40></TD></TR>
	<TR><TD><B>Path</B></TD>
	    <TD><input type=text name="path" value="" size=40 maxlength=255 required="true"></TD></TR>
	<TR><TD nowrap><B>MD5 Checksum</B></TD>
	    <TD><input type=text name="md5" value="" size=40 maxlength=40> (optional)</TD></TR>
	<TR><TD><B>ACL</B></TD><TD>
		<input type=radio name="acl" value="public-read" CHECKED> public-read
	    &nbsp;&nbsp;&nbsp;
		<input type=radio name="acl" value="private"> private
	</TD></TR>
	<TR><TD></TD><TD>
	<input type=submit class="mod" value="Create File">
	</TD></TR>
	</TABLE>
	</FORM>
	</blockquote>
<br>
<% #include "../../footer.asp" %>
</BODY></HTML>
