<HTML>
<HEAD><TITLE><%=txt2html(envt("servername"));%> - Mail Administration</TITLE>
<%
#include "../header.asp"
menu = "mail";
#include "../menu.asp"
area = "config";
#include "submenu.asp"
%>
<table border=0 width=98%><tr><td nowrap>
<B>Mail Server Configuration</B>
[ <A HREF="/sysadmin/mail/showini.asp?file=mail.ini">mail.ini</A> ]
</td><td nowrap align=right>
<A TARGET="help" HREF="/syshelp/mail.htm"><small>
<%=message("sa.Help", locale());%></small></A>
</td></tr></table>
<P>
<A HREF="/sysadmin/mail/cnfmail.asp"><b>Mail Configuration</b></A>
<BLOCKQUOTE>
<table border=0 cellpadding=0 cellspacing=4>
<% if (envt("os") != "win32") { %>
<tr valign=top><td nowrap><b>Case Insensitive Mailboxes</b></td><td><%=txt2html(envt("mboxcasei"));%></td></tr>
<% } %>
<tr valign=top><td nowrap><b>Don't Log IPs</b></td><td><%=txt2html(envt("nomailip"));%></td></tr>
</table>
</BLOCKQUOTE>
<HR>
<P>
<A HREF="/sysadmin/mail/cnfsmtp.asp"><b>SMTP Configuration</b></A>
<BLOCKQUOTE>
<table border=0 cellpadding=0 cellspacing=4>
<tr valign=top><td nowrap><b>Mail Server</b></td><td><%=txt2html(envt("mailname"));%></td></tr>
<tr valign=top><td nowrap><b>Mail FQDN</b></td><td><%=txt2html(envt("mailfqdn"));%></td></tr>
<tr valign=top><td nowrap><b>Message Delivery</b></td><td><%=txt2html(envt("msgrelay"));%></td></tr>
<tr valign=top><td nowrap><b>Max Mailbox Size</b></td><td><%=size2string(envt("mboxsize"));%></td></tr>
<tr valign=top><td nowrap><b>Max Message Size</b></td><td><%=size2string(envt("maxmsgsize"));%></td></tr>
<tr valign=top><td nowrap><b>Max Message Recipients&nbsp;&nbsp;&nbsp;</b></td><td><%=txt2html(envt("maxrcpt"));%></td></tr>
<tr valign=top><td nowrap><b>Unknown Mailbox</b></td><td><%=txt2html(envt("nombox"));%></td></tr>
<tr valign=top><td nowrap><b>Bounce Mailbox</b></td><td><%=txt2html(envt("bouncembox"));%></td></tr>
<tr valign=top><td nowrap><b>Sent Folder</b></td><td><%=txt2html(envt("sentfolder"));%></td></tr>
<tr valign=top><td nowrap><b>SPAM Folder</b></td><td><%=txt2html(envt("spamfolder"));%></td></tr>
<tr valign=top><td nowrap><b>SPAM Folder Cleanup</b></td><td><%=txt2html(envt("spamcleanup"));%> days</td></tr>
<% if (envt("spamprotect") == "true") { %>
<tr valign=top><td nowrap><b>TSP Password</b></td><td><%=txt2html(envt("spampasswd"));%></td></tr>
<% } %>
<tr valign=top><td nowrap><b>Failure Queue Cleanup</b></td><td><%=txt2html(envt("queuecleanup"));%> days</td></tr>
</table>
</BLOCKQUOTE>
<HR>
<P>
<A HREF="/sysadmin/mail/cnfmta.asp"><b>MTA Configuration</b></A>
<BLOCKQUOTE>
<table border=0 cellpadding=0 cellspacing=4>
<%
val = mailProperty("localdomains");
if (val == NULL)
        val = "";
%>
<tr valign=top><td nowrap><b>Use MTA</b></td><td><%=txt2html(envt("mta"));%></td></tr>
<% if (envt("mta") == "true") { %>
<tr valign=top><td nowrap><b>DNS Primary</b></td><td><%=txt2html(envt("dnsprimary"));%></td></tr>
<tr valign=top><td nowrap><b>DNS Secondary&nbsp;&nbsp;&nbsp;</b></td><td><%=txt2html(envt("dnssecondary"));%></td></tr>
<% } %>
<tr valign=top><td nowrap><b>MTA Threads</b></td><td><%=txt2html(envt("maxrouters"));%></td></tr>
<tr valign=top><td nowrap><b>Local Domains</b></td><td><%=txt2html(val);%></td></tr>
</table>
</BLOCKQUOTE>
<HR>
<P>
<A HREF="/sysadmin/mail/cnfrelay.asp"><b>Message Relay Configuration</b></A>
<BLOCKQUOTE>
<i>Act as a fallback store-and-forward server for another domain.</i><br/>
<table border=0 cellpadding=0 cellspacing=4>
<tr valign=top><td nowrap><b>Restrict Relay IPs</b></td><td><%=txt2html(envt("restrictrelayip"));%></td></tr>
<tr valign=top><td nowrap><b>Relay Domain Options</b></td><td><%=txt2html(envt("relaydomainopt"));%></td></tr>
<%
val = mailProperty("relaydomains");
if (val == NULL)
        val = "";
%>
<tr valign=top><td nowrap><b>Relay Domains</b></td><td><%=txt2html(val);%></td></tr>
</table>
</BLOCKQUOTE>
<HR>
<P>
<A HREF="/sysadmin/mail/cnfproxy.asp"><b>Message SMTP Relay</b></A>
<BLOCKQUOTE>
<% if (envt("mta") == "true") { %>
<i>Note: You must disable the MTA to relay through a remote SMTP server 
rather than communicate directly with the recipients SMTP server.  
This is required if your ISP blocks port 25.</i>
<% } %>
<table border=0 cellpadding=0 cellspacing=4>
<tr valign=top><td nowrap><b>Relay SMTP Server</b></td><td><%=txt2html(envt("smtpserver"));%></td></tr>
<tr valign=top><td nowrap><b>Relay FROM User</b></td><td><%=txt2html(envt("relayuser"));%></td></tr>
<tr valign=top><td nowrap><b>Relay AUTH User</b></td><td><%=txt2html(envt("relayauthuser"));%></td></tr>
</table>
</BLOCKQUOTE>
<%
#include "../footer.asp"
%>
</BODY></HTML>
