<HTML>
<HEAD><TITLE><%=txt2html(envt("servername"));%> - Mail Administration</TITLE>
<% 
#include "../header.asp"
menu = "mail";
#include "../menu.asp"
area = "overview";
#include "submenu.asp"
%>
<table border=0 width=98%><tr><td nowrap>
<B>Mail Server</B>
<% if (envt("mailserver") == "true") { %>
[<SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN>]
&nbsp;&nbsp;&nbsp;&nbsp;<CODE><%=txt2html(envt("mailfqdn")); %></CODE>
&nbsp;&nbsp;&nbsp;&nbsp;[<A HREF="/sysadmin/mail/showini.asp?file=mail.ini">mail.ini</A>]
<% } else { %>
[<A HREF="/session/enable?system=mail&RCredirect=/sysadmin/mail/index.asp"><SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / 
<SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>]
<% } %>
</td><td nowrap align=right>
<A TARGET="help" HREF="/syshelp/mail.htm"><small>
<%=message("sa.Help", locale());%></small></A>
</td></tr></table>
<P>
<% if (envt("mailserver") == "false") { %>
The mail server is not enabled.  After configuring the server with the desired 
settings and enabling the mail server above, the mail configuration options 
will be displayed.  If you do not wish to use the mail server but would like
to use the various internal 'mailto' and 'sendmail' functions, the 
outgoing SMTP Server must be configured.
<br/><br/>
<B>Sendmail SMTP Server</B>&nbsp;&nbsp;&nbsp;<%=txt2html(envt("smtpserver"));%>
&nbsp;&nbsp;
[<A HREF="/sysadmin/mail/sendmail.asp">configure</A>]
<br/><br/>
<b>Steps to configuring the Mail server...</b></br>
<blockquote>
<ul>
<li> Enable the mail server by selecting the 
<SPAN class="on"><%=message("sa.on", locale());%></SPAN> link above.</li>
<li> Modify your DNS records with your DNS provider so that your
MX records indicate that this server is a valid sender of mail from
your domain <b>or</b> setup the "Relay Outgoing Mail" parameter to
send all mail via your ISPs mail servers.</li>
<li> Configure the mail server name and fully-qualified name, 
i.e. sambar.com and mail.sambar.com using the "Configuration" tab when 
the mail server is enabled.  These configurations should match the
DNS records associated with this IP (peer mail servers often check 
that senders of email have A-Record that matches the domain they are
sending mail from.)</li>
<li> Modify the "DNS Primary" and "DNS Secondary" servers to be the DNS
servers your ISP provides you so that mail addresses can be resolved and
anti-spam techniques can be used by the Sambar Server.</li>
<li> Create a mailbox for an existing user (i.e. admin) or create a new
user with a mailbox (via the "Security" tab).</li>
<li> Login to WebMail and send yourself a sample email.<li>
<li> Finally, send a sample email to a remote user and have that user respond.
Check the mail server logs if the mail never arrives to see if the message 
was blocked or the server is mis-configured.  
Assuming all goes well, you have a functioning mail server!</li>
</ul>
</blockquote>
<% } else { %>

  <% if (envt("perftrace") == "true") { %>
  <A HREF="/sysadmin/system/showperf.asp?area=mail&title=Mail+Server">Performance Usage</A><BR>
  <% } %>

  <A HREF="/session/reloadspam?RCredirect=/sysadmin/mail/index.asp">Reload Filters (SPAM, Whitelist etc.)</A><BR>
  &nbsp;&nbsp;&nbsp;
	[<A HREF="/sysadmin/mail/showflt.asp?file=reject.flt">reject.flt</A>]
	[<A HREF="/sysadmin/mail/showflt.asp?file=spam.flt">spam.flt</A>]
	[<A HREF="/sysadmin/mail/showflt.asp?file=whitelist.flt">whitelist.flt</A>]
	[<A HREF="/sysadmin/mail/showflt.asp?file=header.flt">header.flt</A>]
	[<A HREF="/sysadmin/mail/showflt.asp?file=body.flt">body.flt</A>]
  <BR>
  <A HREF="/sysadmin/mail/nombox.asp">Manage Unknown Mailboxes</A><BR>

  <% if (envt("runsmtp") == "true") { %>
  <BR>
  <b>Mail Queues</b>&nbsp;&nbsp;
  <A HREF="/sysadmin/mail/queue.asp?show=spool">Spool</A>&nbsp;
  <A HREF="/sysadmin/mail/queue.asp?show=retry">Retry</A>&nbsp;
  <A HREF="/sysadmin/mail/queue.asp?show=failures">Failures</A>&nbsp;
  <A HREF="/session/enable?system=mtaretry&RCredirect=/sysadmin/mail/index.asp">Retry Outgoing Mail!</A><BR>
  <% } %>

  <BR>

  <table border=0 cellspacing=2>

<% if (envt("ssl") == "true") { %>
  <tr><td nowrap>Advertise STARTTLS</td><td nowrap> [
<% if (envt("mailstarttls") == "true") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
  <A HREF="/session/mailconfig?mailstarttls=false&RCredirect=/sysadmin/mail/index.asp"><SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
  <A HREF="/session/mailconfig?mailstarttls=true&RCredirect=/sysadmin/mail/index.asp">
  <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
  <% } %>
  ] </td><td nowrap>
  <A target="help" HREF="/syshelp/mail.htm">
  <%=message("sa.Help", locale());%></A>
  </td>
  <td nowrap>
  Some mail servers resend repeatedly when sending via STARTTLS.
  </td></tr>
<% } %>


  <tr><td nowrap>SMTP</td><td nowrap> [
<% if (envt("runsmtp") == "true") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN>
<% } else { %>
  <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } %>
  ] </td><td nowrap>
  <A target="help" HREF="/syshelp/mailsmtp.htm">
  <%=message("sa.Help", locale());%></A>
  </td>
  <td nowrap>
  <% if (envt("runsmtp") == "true") { %>
  	<%=txt2html(envt("smtpusers"));%> <%=message("sa.Users", locale());%>
  <% } %>
  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
  <%=size2string(envt("maxmsgsize"));%> MAX Message
  </td>
  </tr>

  <tr><td nowrap>SMTP AUTH</td><td nowrap> [
<% if (envt("runsmtpauth") == "true") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN>
<% } else { %>
  <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } %>
  ] </td><td nowrap>
  <A target="help" HREF="/syshelp/mailsmtp.htm">
  <%=message("sa.Help", locale());%></A>
  </td>
  <td nowrap>
  Port 587
  </td>
  </tr>

<% if (envt("runsmtp") == "true") { %>

  <tr><td nowrap>&nbsp;&nbsp;&nbsp;Allow Localhost</td><td nowrap> [
<% if (envt("allowlocal") == "true") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
  <A HREF="/session/mailconfig?allowlocal=false&RCredirect=/sysadmin/mail/index.asp"><SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
  <A HREF="/session/mailconfig?allowlocal=true&RCredirect=/sysadmin/mail/index.asp">
  <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
  <% } %>
  ] </td><td nowrap>
  <A target="help" HREF="/syshelp/mail.htm">
  <%=message("sa.Help", locale());%></A>
  </td>
  <td nowrap>
  Allow 'localhost' to send unauthenticated mail.
  </td></tr>

  <tr><td nowrap>&nbsp;&nbsp;&nbsp;Archive Mail</td><td nowrap> [
<% if (envt("archivemail") == "true") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
  <A HREF="/session/mailconfig?archivemail=false&RCredirect=/sysadmin/mail/index.asp"><SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
  <A HREF="/session/mailconfig?archivemail=true&RCredirect=/sysadmin/mail/index.asp">
  <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
  <% } %>
  ] </td><td nowrap>
  <A target="help" HREF="/syshelp/mail.htm">
  <%=message("sa.Help", locale());%></A>
  </td>
  <td nowrap>
  Archive all messages received by the SMTP server to <%=envt("archivedir");%>
  </td></tr>

  <tr><td nowrap>&nbsp;&nbsp;&nbsp;Auto-build DNSBL</td><td nowrap> [
<% if (envt("requestmon") != "true") { %>
  <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } else if (envt("builddnsbl") == "true") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
  <A HREF="/session/mailconfig?builddnsbl=false&RCredirect=/sysadmin/mail/index.asp"><SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
  <A HREF="/session/mailconfig?builddnsbl=true&RCredirect=/sysadmin/mail/index.asp">
  <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
  <% } %>
  ] </td><td nowrap>
  <A target="help" HREF="/syshelp/spam.htm">
  <%=message("sa.Help", locale());%></A>
  </td>
  <td nowrap>
<% if ((envt("requestmon") != "true") && 
   (strilike(envt("spamcheck"), "*dnsbl*") != 0)) { %>
  <a href="/sysadmin/security/index.asp">Monitor Invalid Requests</a> or
  <a href="/sysadmin/mail/antispam.asp">Remote DNS blacklists</a> 
  must be enabled.
<% } else { %>
  Append invalid requestors and remote DNSBLs to <%=envt("maildir");%>/dnsbl.dbx
<% } %>
  </td></tr>

  <tr><td nowrap>&nbsp;&nbsp;&nbsp;Backup Mailboxes</td><td nowrap> [
<% if (envt("mboxbackup") == "true") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
  <A HREF="/session/mailconfig?mboxbackup=false&RCredirect=/sysadmin/mail/index.asp"><SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
  <A HREF="/session/mailconfig?mboxbackup=true&RCredirect=/sysadmin/mail/index.asp">
  <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
  <% } %>
  ] </td><td nowrap>
  <A target="help" HREF="/syshelp/mail.htm">
  <%=message("sa.Help", locale());%></A>
  </td>
  <td nowrap>
  Rolling seven day per-user mailbox backup (recoverable via WebMail).  
  Requires Safe Save.
  </td></tr>

  <tr><td nowrap>&nbsp;&nbsp;&nbsp;'everyone' Alias</td><td nowrap> [
<% if (envt("maileveryone") == "true") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
  <A HREF="/session/mailconfig?maileveryone=false&RCredirect=/sysadmin/mail/index.asp"><SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
  <A HREF="/session/mailconfig?maileveryone=true&RCredirect=/sysadmin/mail/index.asp">
  <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
  <% } %>
  ] </td><td nowrap>
  <A target="help" HREF="/syshelp/mail.htm">
  <%=message("sa.Help", locale());%></A>
  </td>
  <td nowrap>
  System administrator usage only (WebMail or SMTP AUTH).
  </td></tr>

  <tr valign=top><td nowrap>&nbsp;&nbsp;&nbsp;Local DNSBL</td><td nowrap> [
<% if (envt("localdnsbl") == "true") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
  <A HREF="/session/mailconfig?localdnsbl=false&RCredirect=/sysadmin/mail/index.asp"><SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
  <A HREF="/session/mailconfig?localdnsbl=true&RCredirect=/sysadmin/mail/index.asp">
  <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
  <% } %>
  ] </td><td nowrap>
<% if (envt("localdnsbl") == "true") { %>
	<A HREF="/sysadmin/mail/showflt.asp?file=dnsbl.dbx">dnsdl.dbx</A>
<% } %>
  </td>
  <td nowrap>
  Lookup IP in <%=envt("maildir");%>/dnsbl.dbx and <i>immediately</i> 
  reject matches as spam.
  </td></tr>

  <tr><td nowrap>&nbsp;&nbsp;&nbsp;MTA</td><td nowrap> [
<% if (envt("mta") == "true") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN>
<% } else { %>
  <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } %>
  ] </td><td nowrap>
  <A HREF="/sysadmin/mail/mxlookup.asp">DNS Test</A>
  </td>
  <td nowrap>
  <% if (envt("mta") == "true") { %>
	<%=txt2html(envt("maxrouters"));%> Delivery Thread(s)
  <% } %>
  </td>
  </tr>

  <tr><td nowrap>&nbsp;&nbsp;&nbsp;Plus (+) Addressing</td><td nowrap> [
<% if (envt("plusaddrs") == "true") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
  <A HREF="/session/mailconfig?plusaddrs=false&RCredirect=/sysadmin/mail/index.asp"><SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
  <A HREF="/session/mailconfig?plusaddrs=true&RCredirect=/sysadmin/mail/index.asp">
  <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
  <% } %>
  ] </td><td nowrap>
  <A target="help" HREF="/syshelp/mailsmtp.htm">
  <%=message("sa.Help", locale());%></A>
  </td><td nowrap></td></tr>

  <tr><td nowrap>&nbsp;&nbsp;&nbsp;Public Mailing Lists</td><td nowrap> [
<% if (envt("maillists") == "true") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
  <A HREF="/session/mailconfig?maillists=false&RCredirect=/sysadmin/mail/index.asp"><SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
  <A HREF="/session/mailconfig?maillists=true&RCredirect=/sysadmin/mail/index.asp">
  <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
  <% } %>
  ] </td><td nowrap>
  <A target="help" HREF="/syshelp/maillist.htm">
  <%=message("sa.Help", locale());%></A>
  </td><td nowrap></td></tr>

  <tr><td nowrap>&nbsp;&nbsp;&nbsp;Require AUTH</td><td nowrap> [
<% if (envt("requireauth") == "true") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
  <A HREF="/session/mailconfig?requireauth=false&RCredirect=/sysadmin/mail/index.asp"><SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
  <A HREF="/session/mailconfig?requireauth=true&RCredirect=/sysadmin/mail/index.asp">
  <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
  <% } %>
  ] </td><td nowrap>
  <A target="help" HREF="/syshelp/mailsmtp.htm">
  <%=message("sa.Help", locale());%></A>
  </td>
  <td nowrap>
  Local users must authenticate via SMTP AUTH.
  </td></tr>

  <tr><td nowrap>&nbsp;&nbsp;&nbsp;Restrict Relay</td><td nowrap> [
<% if (envt("restrictrelay") == "true") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
  <A HREF="/session/mailconfig?restrictrelay=false&RCredirect=/sysadmin/mail/index.asp"><SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
  <A HREF="/session/mailconfig?restrictrelay=true&RCredirect=/sysadmin/mail/index.asp">
  <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
  <% } %>
  ] </td><td nowrap>
  <A target="help" HREF="/syshelp/mailsmtp.htm">
  <%=message("sa.Help", locale());%></A>
  </td>
  <td nowrap>
<% if (envt("restrictrelay") == "false") { %>
  <B>Warning!</B> This should always be enabled if your mail server 
  is publically accessible.
<% } %>
  </td></tr>

  <tr><td nowrap>&nbsp;&nbsp;&nbsp;Safe Save Mailboxes</td><td nowrap> [
<% if (envt("mboxsafesave") == "true") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
  <A HREF="/session/mailconfig?mboxsafesave=false&RCredirect=/sysadmin/mail/index.asp"><SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
  <A HREF="/session/mailconfig?mboxsafesave=true&RCredirect=/sysadmin/mail/index.asp">
  <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
  <% } %>
  ] </td><td nowrap>
  <A target="help" HREF="/syshelp/mail.htm">
  <%=message("sa.Help", locale());%></A>
  </td>
  <td nowrap>
  Administrative backup of last mailbox close.
  </td></tr>

  <tr><td nowrap>&nbsp;&nbsp;&nbsp;SPAM Greeting Delay</td><td nowrap> [
<% if (envt("greetingdelay") == "true") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
  <A HREF="/session/mailconfig?greetingdelay=false&RCredirect=/sysadmin/mail/index.asp"><SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
  <A HREF="/session/mailconfig?greetingdelay=true&RCredirect=/sysadmin/mail/index.asp">
  <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
  <% } %>
  ] </td><td nowrap>
  <A target="help" HREF="/syshelp/spam.htm">
  <%=message("sa.Help", locale());%></A>
  </td>
  <td nowrap>
  </td></tr>

  <tr><td nowrap>&nbsp;&nbsp;&nbsp;SPAM Greylisting</td><td nowrap> [
<% if (envt("greylisting") == "true") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
  <A HREF="/session/mailconfig?greylisting=false&RCredirect=/sysadmin/mail/index.asp"><SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
  <A HREF="/session/mailconfig?greylisting=true&RCredirect=/sysadmin/mail/index.asp">
  <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
  <% } %>
  ] </td><td nowrap>
  <A target="help" HREF="/syshelp/spam.htm">
  <%=message("sa.Help", locale());%></A>
  </td>
  <td nowrap>
  </td></tr>

  <tr><td nowrap>&nbsp;&nbsp;&nbsp;SpamAssassin</td><td nowrap> [
<% if (envt("routercgi") == "mailcgi.pl") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> /
  <A HREF="/session/mailconfig?routercgi=&RCredirect=/sysadmin/mail/index.asp"><SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
  <A HREF="/session/mailconfig?routercgi=mailcgi.pl&RCredirect=/sysadmin/mail/index.asp">
  <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
  <% } %>
  ] </td><td nowrap>
  <A target="help" HREF="/syshelp/spam.htm">
  <%=message("sa.Help", locale());%></A>
  </td>
  <td nowrap>
  <% if (sizeof(envt("routercgi")) > 0) { %>
    Anti-spam CGI is &nbsp;&nbsp;
	<CODE><%=txt2html(envt("routercgi"));%></CODE>
  <% } %>
  </td></tr>

<% if (envt("routercgi") == "mailcgi.pl") { %>
  <tr><td nowrap>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Test Incoming Only</td><td nowrap> [
<% if (envt("routercgiin") == "true") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> /
  <A HREF="/session/mailconfig?routercgiin=false&RCredirect=/sysadmin/mail/index.asp"><SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
  <A HREF="/session/mailconfig?routercgiin=true&RCredirect=/sysadmin/mail/index.asp">
  <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
  <% } %>
  ] </td><td nowrap>
  </td>
  <td nowrap>
  </td></tr>
<% } %>

  <tr><td nowrap>&nbsp;&nbsp;&nbsp;Total SPAM Protection</td><td nowrap> [
<% if (envt("spamprotect") == "true") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
  <A HREF="/session/mailconfig?spamprotect=false&RCredirect=/sysadmin/mail/index.asp"><SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
  <A HREF="/session/mailconfig?spamprotect=true&RCredirect=/sysadmin/mail/index.asp">
  <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
  <% } %>
  ] </td><td nowrap>
  <A target="help" HREF="/syshelp/spam.htm">
  <%=message("sa.Help", locale());%></A>
  </td>
  <td nowrap>
<% if (envt("spamprotect") == "true") { %>
  <% if (sizeof(envt("spampasswd")) > 0) { %>
  Server-wide Subject: password is '<%=txt2html(envt("spampasswd"));%>'
  <% } else { %>
  No server-wide Subject: password is configured.
  <% } %>
<% } %>
  </td></tr>

  <tr><td nowrap>&nbsp;&nbsp;&nbsp;Use Mailbox Indexes</td><td nowrap> [
<% if (envt("mboxindexes") == "true") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
  <A HREF="/session/mailconfig?mboxindexes=false&RCredirect=/sysadmin/mail/index.asp"><SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
  <A HREF="/session/mailconfig?mboxindexes=true&RCredirect=/sysadmin/mail/index.asp">
  <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
  <% } %>
  ] </td><td nowrap>
  <A target="help" HREF="/syshelp/mail.htm">
  <%=message("sa.Help", locale());%></A>
  </td>
  <td nowrap>
  Only rebuild mbox folders when 20% or more of the messages have changed.
  </td></tr>

  <tr><td nowrap>&nbsp;&nbsp;&nbsp;Verify Sender</td><td nowrap> [
<% if (envt("verifysender") == "true") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
  <A HREF="/session/mailconfig?verifysender=false&RCredirect=/sysadmin/mail/index.asp"><SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
  <A HREF="/session/mailconfig?verifysender=true&RCredirect=/sysadmin/mail/index.asp">
  <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
  <% } %>
  ] </td><td nowrap>
  <A target="help" HREF="/syshelp/mail.htm">
  <%=message("sa.Help", locale());%></A>
  </td>
  <td nowrap>
  Disallow spoofing from authenticated SMTP users.
  </td></tr>

<% } %>

  <tr><td nowrap>IMAP4</td><td nowrap> [
<% if (envt("runimap4") == "true") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN>
<% } else { %>
  <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } %>
  ] </td><td nowrap>
  <A target="help" HREF="/syshelp/mailimap.htm">
  <%=message("sa.Help", locale());%></A>
  </td>
  <td nowrap>
  <% if (envt("runimap4") == "true") { %>
  	<%=txt2html(envt("imap4users"));%> <%=message("sa.Users", locale());%>
  <% } %>
  </td>
  </tr>

  <tr><td nowrap>POP3</td><td nowrap> [
<% if (envt("runpop3") == "true") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN>
<% } else { %>
  <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } %>
  ] </td><td nowrap>
  <A target="help" HREF="/syshelp/mailpop3.htm">
  <%=message("sa.Help", locale());%></A>
  </td>
  <td nowrap>
  <% if (envt("runpop3") == "true") { %>
  	<%=txt2html(envt("pop3users"));%> <%=message("sa.Users", locale());%>
  <% } %>
  </td>
  </tr>

  <tr valign=top><td nowrap>WebMail</td><td nowrap> [
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> 
  ] </td><td nowrap colspan=2>
  <A target="help" HREF="/syshelp/webmail.htm">
  <%=message("sa.Help", locale());%></A>
  <A HREF="/sysuser/mail/">Login</A><br>
  <A HREF="/sysadmin/mail/routes.asp">Global Routing</A>
  <A target=help HREF="/syshelp/mailrout.htm">External Filters</A>
  <A HREF="/sysadmin/mail/contacts.asp">Global Contacts List</A>
  </td></tr>

  <tr><td nowrap>RSS Feeds</td><td nowrap> [
<% if ((envt("rss") == "true") && (envt("cachesize") != "0") && 
	(strilike(envt("cacheflags"), "*xml*") == 0)) { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN>
<% } else { %>
  <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
  <% } %>
  ] </td><td nowrap>
  <% if ((envt("cachesize") == "0") || (strilike(envt("cacheflags"), "*xml*") != 0)) { %>
    <i><a href="/sysadmin/services/cache.asp">XML/RSS Caching</a> 
	must be enabled</i>
  <% } %>
  </td><td nowrap></td></tr>

  <tr><td nowrap>Trace SMTP Usage</td><td nowrap> [
<% if (envt("tracesmtp") == "true") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
  <A HREF="/session/mailconfig?tracesmtp=false&RCredirect=/sysadmin/mail/index.asp"><SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
  <A HREF="/session/mailconfig?tracesmtp=true&RCredirect=/sysadmin/mail/index.asp">
  <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
  <% } %>
  ] </td><td nowrap>
  <% if (envt("tracesmtp") == "true") { %>
  <A HREF="/sysadmin/system/showlog.asp?log=smtp.log">smtp.log</A>
  <% } %>
  </td><td nowrap></td></tr>

  <tr><td nowrap>Trace IMAP4 Usage</td><td nowrap> [
<% if (envt("traceimap4") == "true") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
  <A HREF="/session/mailconfig?traceimap4=false&RCredirect=/sysadmin/mail/index.asp"><SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
  <A HREF="/session/mailconfig?traceimap4=true&RCredirect=/sysadmin/mail/index.asp">
  <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
  <% } %>
  ] </td><td nowrap>
  <% if (envt("traceimap4") == "true") { %>
  <A HREF="/sysadmin/system/showlog.asp?log=imap4.log">imap4.log</A>
  <% } %>
  </td><td nowrap></td></tr>

  <tr><td nowrap>Trace POP3 Usage</td><td nowrap> [
<% if (envt("tracepop3") == "true") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
  <A HREF="/session/mailconfig?tracepop3=false&RCredirect=/sysadmin/mail/index.asp"><SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
  <A HREF="/session/mailconfig?tracepop3=true&RCredirect=/sysadmin/mail/index.asp">
  <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
  <% } %>
  ] </td><td nowrap>
  <% if (envt("tracepop3") == "true") { %>
  <A HREF="/sysadmin/system/showlog.asp?log=pop3.log">pop3.log</A>
  <% } %>
  </td><td nowrap></td></tr>

  <tr><td nowrap>Trace MTA Usage</td><td nowrap> [
<% if (envt("tracerouter") == "true") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
  <A HREF="/session/mailconfig?tracerouter=false&RCredirect=/sysadmin/mail/index.asp"><SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
  <A HREF="/session/mailconfig?tracerouter=true&RCredirect=/sysadmin/mail/index.asp">
  <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
  <% } %>
  ] </td><td nowrap>
  <% if (envt("tracerouter") == "true") { %>
  <A HREF="/sysadmin/system/showlog.asp?log=router.log">router.log</A>
  <% } %>
  </td><td nowrap></td></tr>

  <tr><td nowrap>Trace Fetcher Usage</td><td nowrap> [
<% if (envt("tracefetcher") == "true") { %>
  <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
  <A HREF="/session/mailconfig?tracefetcher=false&RCredirect=/sysadmin/mail/index.asp"><SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
  <A HREF="/session/mailconfig?tracefetcher=true&RCredirect=/sysadmin/mail/index.asp">
  <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
  <% } %>
  ] </td><td nowrap>
  <% if (envt("tracefetcher") == "true") { %>
  <A HREF="/sysadmin/system/showlog.asp?log=fetcher.log">fetcher.log</A>
  <% } %>
  </td><td nowrap></td></tr>

  </table>

<% } %>
<%
#include "../footer.asp"
%>
</BODY></HTML>
