<HTML>
<HEAD><TITLE><%=txt2html(envt("servername"));%> - DBMS Administration</TITLE>
<SCRIPT language="JavaScript">
<!--
function confirmDelete()
{
	return confirm("Delete selected DBMS Cache?  (Note: You must restart the server for changes to take effect.)");
}
//-->
</SCRIPT>
<% 
#include "../header.asp"
menu = "scripts";
#include "../menu.asp"
area = "dbms";
#include "submenu.asp"

ini = iniopen("dbconfig.ini");

// Perform any actions
action = getParameter($params, "action");
section = getParameter($params, "section");
if ((action == "delete") && (section != NULL))
{
	iniexpunge(ini, section);
	inisave(ini);

    printf("<center><div class=\"info\">");
    printf("DBMS Cache '%s' deleted.<BR>", section);
    printf("You must RESTART the server before changes take effect.");
    printf("</div></center>");
}
else if ((action == "update") && (section != NULL))
{
	iniset(ini, section, "Description",
		getParameter($params, "desc"));
	iniset(ini, section, "Datasource",
		getParameter($params, "datasource"));
	iniset(ini, section, "Username",
		getParameter($params, "username"));
	iniset(ini, section, "Password",
		getParameter($params, "password"));
	iniset(ini, section, "Query Timeout",
		getParameter($params, "timeout"));
	iniset(ini, section, "Maximum Column Length",
		getParameter($params, "maxcol"));
	iniset(ini, section, "Maximum Used Connections",
		getParameter($params, "maxconns"));
	iniset(ini, section, "Minimum Free Connections",
		getParameter($params, "minfree"));
	iniset(ini, section, "Maximum Idle Period",
		getParameter($params, "maxidle"));
	iniset(ini, section, "Single Thread",
		getParameter($params, "singlethread"));
	iniset(ini, section, "Require Authentication",
		getParameter($params, "requireauth"));
	iniset(ini, section, "Trace Performance",
		getParameter($params, "traceperf"));
	iniset(ini, section, "Trace SQL",
		getParameter($params, "tracesql"));
	iniset(ini, section, "Administrator Only",
		getParameter($params, "adminonly"));
	iniset(ini, section, "Failover DB Cache",
		getParameter($params, "failcache"));
	iniset(ini, section, "Connection Failover Count",
		getParameter($params, "failcount"));
	iniset(ini, section, "Connection Failover Retry Interval",
		getParameter($params, "retryinterval"));
	iniset(ini, section, "Connection Failover Timeout",
		getParameter($params, "failtime"));
	iniset(ini, section, "Restrict to Users",
		getParameter($params, "restrictusers"));
	inisave(ini);

    printf("<center><div class=\"info\">");
    printf("DBMS Cache '%s' modified.<BR>", section);
    printf("You must RESTART the server before changes take effect.");
    printf("</div></center>");
}

%>

<table border=0 width=98%><tr><td nowrap>
<B>DBMS Cache Administration</B>
[ <A HREF="/sysadmin/scripts/showini.asp?area=dbms&file=dbconfig.ini">dbconfig.ini</A> ]
</td><td nowrap align=right>
<A TARGET="help" HREF="/syshelp/db.htm"><small>
<%=message("sa.Help", locale());%></small></A>
</td></tr></table>
<P>
<table border=0 width=90% cellpadding=4>
<tr valign=top><td width=33%>
<A HREF="/sysadmin/scripts/newdbms.asp">Create DBMS Cache</A><BR>
<A HREF="/sysadmin/scripts/odbc.asp">ODBC Datasources</A><BR>
<A HREF="/sysadmin/utils/isql.asp">ISQL Utitlity</A><BR>
</td><td width=33%>
<A HREF="/sysadmin/scripts/showdb.asp">Active Caches</A><BR>
<A HREF="/sysadmin/scripts/showdbc.asp">Active Connections</A><BR>
</td><td width=33%>
<% if (envt("perftrace") == "true") { %>
<A HREF="/sysadmin/system/showperf.asp?area=dbms&title=DBMS">Performance</A><BR>
<% } %>
<A HREF="/sysadmin/system/showlog.asp?log=dbms.log">dbms.log</A><BR>
</td></tr>
</table>
<BR>
<table border=0 cellpadding=4>
<tr bgcolor=#cccccc><td><b>DBMS Cache</b></td><td>&nbsp;</td><td>&nbsp;</td></tr>
<%
cachelist = NULL;
if (envt("usedbms") == "true")
    cachelist = dbcachelist();

sections = inisections(ini);
for (i = 0; i < sizeof(sections); i++)
{
	name = sections[i];

	printf("<tr><td><a href=\"/sysadmin/scripts/newdbms.asp?section=%s\">%s</a></td><td>", name, name);

    // If SQLITE dbms and enabled, show tables list.
    int j = 0;
    int found = 0;
    while ((!found) && (j < sizeof(cachelist)))
    {
        if (cachelist[j] == name)
            found = 1;
        j++;
    }

    if (found)
    {
		info = dbinfo(name);
        if (info.dbmsname != NULL)
		{
        	if ((strnicmp(info.dbmsname, "SQLITE", 6) == 0) ||
        		(strnicmp(info.dbmsname, "SQLITE3", 7) == 0))
			{
        		printf("&nbsp;&nbsp;&nbsp;[ ");
        		printf("<a href=\"/sysadmin/scripts/sqlite/index.asp?dbcache=%s\">",
					name);
        		printf("SQLite Manager</a> ]");
			}
        	else if (strnicmp(info.dbmsname, "MySQL", 5) == 0)
			{
        		printf("&nbsp;&nbsp;&nbsp;[ ");
        		printf("<a href=\"/sysadmin/scripts/mysql/index.asp?dbcache=%s\">",
					name);
        		printf("MySQL Manager</a> ]");
			}
		}
    }

    printf("</td>");
	printf("<td><a href=\"/sysadmin/scripts/dbms.asp?section=%s&action=delete\" onclick=\"return confirmDelete()\">", name);
	printf("<img border=0 align=top src=\"/sysimage/icons/delete.gif\">Delete</a></td></tr>");
}

if (sizeof(sections) < 1)
	printf("<tr><td colspan=3><i>No DBMS caches configured.</i></td></tr>");
%>
</table>
<%
#include "../footer.asp"
%>
</BODY></HTML>
