<HTML>
<HEAD><TITLE><%=txt2html(envt("servername"));%> - JavaEngine Administration</TITLE>
<% 
#include "../../header.asp"
menu = "scripts";
#include "../../menu.asp"
area = "javaeng";
#include "../submenu.asp"

// Perform any actions
action = getParameter($params, "action");
section = getParameter($params, "section");
if ((action == "update") && (section != NULL))
{
	ini = iniopen("javaeng.ini");
	if (section == "javaeng")
	{
		iniset(ini, section, "Verbose",
			getParameter($params, "verbose"));
		iniset(ini, section, "Trace Config",
			getParameter($params, "traceconfig"));
		iniset(ini, section, "Servlet Extension",
			getParameter($params, "servletext"));
		iniset(ini, section, "Servlets Directory",
			getParameter($params, "servletdir"));
		iniset(ini, section, "Preload GenericServlet",
			getParameter($params, "preload"));
		iniset(ini, section, "WEB-INF Directory",
			getParameter($params, "webinfdir"));
		inisave(ini);

    	printf("<center><div class=\"info\">");
    	printf("JavaEngine configuration updated.<BR>");
    	printf("</div></center>");
	}
	else if (section == "initParameters")
	{
		iniset(ini, section, "compiler",
			getParameter($params, "compiler"));
		iniset(ini, section, "debug",
			getParameter($params, "debug"));
		iniset(ini, section, "fork",
			getParameter($params, "fork"));
		iniset(ini, section, "largefile",
			getParameter($params, "largefile"));
		iniset(ini, section, "mappedfile",
			getParameter($params, "mappedfile"));
		iniset(ini, section, "keepgenerated",
			getParameter($params, "keepgenerated"));
		iniset(ini, section, "sendErrToClient",
			getParameter($params, "sendErrToClient"));
		iniset(ini, section, "enablePooling",
			getParameter($params, "enablePooling"));
		iniset(ini, section, "classdebugInfo",
			getParameter($params, "classdebugInfo"));
		iniset(ini, section, "checkInterval",
			getParameter($params, "checkInterval"));
		iniset(ini, section, "development",
			getParameter($params, "development"));
		iniset(ini, section, "reloading",
			getParameter($params, "reloading"));
		iniset(ini, section, "classpath",
			getParameter($params, "classpath"));
		inisave(ini);

    	printf("<center><div class=\"info\">");
    	printf("JavaEngine initParameters updated.<BR>");
    	printf("</div></center>");
	}
	else if ((section == "properties") || (section == "jvmArguments"))
	{
		/* Remove the existing properties section		*/
		iniexpunge(ini, section);

		i = 0;
		while (i < 99)
		{
			name = getParameter($params, "CN" + i);
			value = getParameter($params, "CV" + i);
			if ((name == NULL) || (strlen(name) == 0))
			{
				i++;
				continue;
			}

			if (value == NULL)
				value = "";

			name = strsubst(name, "\"", "'", 1);
			iniadd(ini, section, name, value);
			i++;
		}

		inisave(ini);

    	printf("<center><div class=\"info\">");
    	printf("JavaEngine arguments updated.<BR>");
    	printf("</div></center>");
	}
}
%>
<table border=0 width=98%><tr><td nowrap>
<B>JavaEngine Administration</B>
[
<% if (envt("javaeng") == "true") { %>
    <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> /
    <A HREF="/session/sysconfig?javaeng=false&RCredirect=/sysadmin/scripts/javaeng/index.asp">
    <SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
    <A HREF="/session/sysconfig?javaeng=true&RCredirect=/sysadmin/scripts/javaeng/index.asp">
    <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } %>
]
&nbsp;&nbsp;&nbsp;
[ <A HREF="/sysadmin/scripts/showini.asp?area=javaeng&file=javaeng.ini">javaeng.ini</A> ]
</td><td nowrap align=right>
<A TARGET="help" HREF="/syshelp/javaeng.htm"><small>
<%=message("sa.Help", locale());%></small></A>
</td></tr></table>
<P>
<%  
    if ((action == "update") && (section != NULL))
    {
	    printf("<B>Configuration updated!</B><BR>");
	    printf("<I>Changes take effect after server shutdown and restart!</I><BR>");
    }
%>
<a href="/sysadmin/scripts/mapjava.asp"><%=message("sa.WWW_MapServlet", locale());%></a><BR>
<A HREF="/sysadmin/scripts/javaeng/javaconf.asp">Configure JavaEngine</A><BR>
<A HREF="/sysadmin/scripts/javaeng/initconf.asp">Configure initParameters</A><BR>
<A HREF="/sysadmin/scripts/javaeng/propconf.asp">Configure Properties</A><BR>
<A HREF="/sysadmin/scripts/javaeng/jvmconf.asp">Configure JVM Arguments</A><BR>
<BR>
<% if ((envt("javaeng") == "true") && (envt("perftrace") == "true")) { %>
<A HREF="/sysadmin/system/showperf.asp?area=javaeng&title=JavaEngine">JavaEngine Performance</A><BR>
<% } %>

<% if ((envt("javaeng") == "true") && (envt("JSPLog") != NULL)) { %>
    <A HREF="/sysadmin/system/showfile.asp?file=<%=txt2html(envt("JSPLog")); %>"><%=txt2html(envt("JSPLog")); %></A><BR>
<% } %>
<BR>
<% if (envt("javaeng") == "true") { %>
<TABLE border=0 cellpadding=4 cellspacing=0>
<TR valign=top><TD nowrap><A HREF="/sysadmin/scripts/javaeng/javaeng.jsp">JVM Status</A></TD>
    <TD>Display JVM memory usage and system variables.  
	Allow restart of Class loaders for this virtual host, or you can
	<A HREF="/session/javareload">reload</a> all class loaders.
</TD></TR>
<TR valign=top><TD nowrap><A HREF="/servlet/sysadmin.Snoop">Snoop Servlet</A></TD>
    <TD>Display HTTP headers associated with the request.</TD></TR>
<TR valign=top><TD nowrap><A HREF="/servlet/sysadmin.Snoop2">Snoop2 Servlet</A></TD>
    <TD>Display HTTP headers and API details associated with the request 
    (provided by Ken Johanson).</TD></TR>
<TR valign=top><TD nowrap><A HREF="/servlet/sysadmin.SessionInfo">Session Info</A></TD>
    <TD>Display current sessions.</TD></TR>
</TABLE>
<% } %>
<%
#include "../../footer.asp"
%>
</BODY></HTML>
