<HTML>
<HEAD><TITLE><%=txt2html(envt("servername"));%> - Script Mappings</TITLE>
<%
#include "../header.asp"
menu = "scripts";
#include "../menu.asp"
area = "mappings";
#include "submenu.asp"

files = mappingfiles();
mapfile = getParameter($params, "mapfile");
if ((mapfile == NULL) && (sizeof(files) > 0))
        mapfile = files[0];
else if (sizeof(mapfile) == 0)
        mapfile = "mapping.ini";

ini = iniopen(mapfile);
#include "showmap.asp"
%>

<table border=0 width=98%><tr><td nowrap>
<B><%=message("sa.WWW_MapCGIAlias", locale());%></B>
&nbsp;&nbsp;&nbsp;
[ <a href="/sysadmin/scripts/showini.asp?area=mappings&file=<%=mapfile;%>"><%=mapfile;%></a> ]
<BR>
<I>Unless manually reloaded below, changes do not take effect until a system restart.</I>
</td><td nowrap align=right>
<A TARGET="help" HREF="/syshelp/aliases.htm"><small>
<%=message("sa.Help", locale());%></small></A>
</td></tr></table>
<P>
<B>Wait!</B> You likely want <a href="/sysadmin/scripts/mapassoc.asp?maptype=<%=MAPTYPE_CGI;%>&mapfile=<%=mapfile;%>">CGI Associations</a> if you are attempting to associate a file extension with a CGI executable, i.e. *.php = /php5/php.exe.
<p>
URLs with a (%-decoded) path beginning with the <I>url-path</I>
(left-hand argument) will be mapped to the local files beginning
with the <I>directory-path</I> (right-hand argument).
<BLOCKQUOTE><BLOCKQUOTE><CODE>
	i.e.<BR>
	/scripts/ = c:/scripts/
</BLOCKQUOTE></BLOCKQUOTE></CODE>
<P>
See the <A HREF="/syshelp/aliases.htm">aliases</A> documentation for more
details on Document, CGI and WinCGI and Servlet aliases;
<B><I>aliases must have "matching" trailing slashes as shown above.</I></B>
<P>
For example, the CGI alias: 
<BLOCKQUOTE><CODE>
/cgi/ = c:/mycgis/
</CODE></BLOCKQUOTE><P>
will result in the URL request 
<BLOCKQUOTE><CODE>
/cgi/foo.pl
</CODE></BLOCKQUOTE><P>
being treated as a CGI script; the CGI will be 
retrieved and executed as 
<BLOCKQUOTE><CODE>
c:/mycgis/foo.pl
</CODE></BLOCKQUOTE>
<P>
<% showMap("cgi-aliases", MAPTYPE_CGIALIAS); %>
<P>
Note: The <a href="/sysadmin/scripts/cnfcgi.asp"><I>CGI Extensions</I></a>
configuration feature can be used to execute a CGI script in any
directory, and can be used in place of specific CGI directory aliasing.
<%
#include "../footer.asp"
%>
</BODY></HTML>
