<HTML>
<HEAD><TITLE><%=txt2html(envt("servername"));%> - Script Mappings</TITLE>
<%
#include "../header.asp"
menu = "scripts";
#include "../menu.asp"
area = "mappings";
#include "submenu.asp"

files = mappingfiles();
mapfile = getParameter($params, "mapfile");
if ((mapfile == NULL) && (sizeof(files) > 0))
        mapfile = files[0];
else if (sizeof(mapfile) == 0)
        mapfile = "mappings.ini";

ini = iniopen(mapfile);
action = getParameter($params, "action");
section = getParameter($params, "section");
if ((action == "update") && (section != NULL))
{
	/* Remove the existing section					*/
	iniexpunge(ini, section);

	i = 0;
	while (i < 999)
	{
		name = getParameter($params, "CN" + i);
		value = getParameter($params, "CV" + i);
		if ((name == NULL) || (strlen(name) == 0) ||
			(value == NULL) || (strlen(value) == 0))
		{
			i++;
			continue;
		}

		name = strsubst(name, "\"", "'", 1);
		iniadd(ini, section, name, value);
		i++;
	}

	inisave(ini);

    printf("<center><div class=\"info\">");
    printf("Mapping rules updated.<BR>", section);
    printf("You must reload the server mappings before changes take effect.");
    printf("</div></center>");
}

maptype = (int)getParameter($params, "maptype");
if (maptype <= 0)
    maptype = MAPTYPE_ALIAS;
%>

<table border=0 width=98%><tr><td nowrap>
<B><%=message("sa.WWW_MapContent", locale());%></B>
&nbsp;&nbsp;&nbsp;
[ <a href="/sysadmin/scripts/showini.asp?area=mappings&file=<%=mapfile;%>"><%=mapfile;%></a> ]
<BR>
<I>Unless manually reloaded below, changes do not take effect 
until a system restart.</I>
</td><td nowrap align=right>
<A TARGET="help" HREF="/syshelp/aliases.htm"><small>
<%=message("sa.Help", locale());%></small></A>
</td></tr></table>
<P>
<% if (sizeof(files) > 1) { %>
<table border=0 cellpadding=4>
<tr valign=top><td><I>Change Mappings File:</I></td><td>
<FORM name=newmapping method=GET action="/sysadmin/scripts/mappings.asp" 
	style="bottom-margin: 0">
<INPUT name="maptype" type=hidden value="<%=maptype;%>">
<SELECT name="mapfile" onchange="javascript:document.newmapping.submit();">
<%
        for (i = 0; i < sizeof(files); i++)
        {
                printf("<option %s>%s\n", 
			(files[i] == mapfile) ? "SELECTED" : "" , files[i]);
        }
%>
</SELECT>
</FORM>
</td></tr></table>
<% } %>
<P>
<a href="/session/mappingsreload?RCpage=/sysadmin/scripts/mappings.asp&maptype=<%=maptype;%>&mapfile=<%=txt2html(mapfile);%>">Reload All Mapping Rules</A>
<BR>
<BR>
<table border=0 cellpadding=4>
<tr valign=top><td nowrap>
<B>Active Mappings</B><br>
<table style="border: 1px solid black" cellpadding=4>
<TR><td nowrap bgcolor=<%=(maptype == MAPTYPE_ALIAS) ? "yellow" : "white";%>>
<a href="/sysadmin/scripts/mappings.asp?mapfile=<%=txt2html(mapfile);%>&maptype=<%=MAPTYPE_ALIAS;%>">
<%=message("sa.WWW_MapDocAlias", locale());%></a>
</td><td>
<a href="/sysadmin/scripts/mapdoc.asp?maptype=<%=maptype;%>&mapfile=<%=txt2html(mapfile);%>"><%=message("sa.Configure", locale());%></a>
</td></TR>
<TR><td nowrap bgcolor=<%=(maptype == MAPTYPE_CGI) ? "yellow" : "white";%>>
<a href="/sysadmin/scripts/mappings.asp?mapfile=<%=txt2html(mapfile);%>&maptype=<%=MAPTYPE_CGI;%>">
<%=message("sa.WWW_MapCGIAssoc", locale());%></a>
</td><td>
<a href="/sysadmin/scripts/mapassoc.asp?maptype=<%=maptype;%>&mapfile=<%=txt2html(mapfile);%>"><%=message("sa.Configure", locale());%></a>
</td></TR>
<TR><td nowrap bgcolor=<%=(maptype == MAPTYPE_CGIALIAS) ? "yellow" : "white";%>>
<a href="/sysadmin/scripts/mappings.asp?mapfile=<%=txt2html(mapfile);%>&maptype=<%=MAPTYPE_CGIALIAS;%>">
<%=message("sa.WWW_MapCGIAlias", locale());%></a>
</td><td>
<a href="/sysadmin/scripts/mapcgi.asp?maptype=<%=maptype;%>&mapfile=<%=txt2html(mapfile);%>"><%=message("sa.Configure", locale());%></a>
</td></TR>
<TR><td nowrap bgcolor=<%=(maptype == MAPTYPE_WINCGIALIAS) ? "yellow" : "white";%>>
<a href="/sysadmin/scripts/mappings.asp?mapfile=<%=txt2html(mapfile);%>&maptype=<%=MAPTYPE_WINCGIALIAS;%>">
<%=message("sa.WWW_MapWinCGIAlias", locale());%></a>
</td><td>
<a href="/sysadmin/scripts/mapwin.asp?maptype=<%=maptype;%>&mapfile=<%=txt2html(mapfile);%>"><%=message("sa.Configure", locale());%></a>
</td></TR>
<TR><td nowrap bgcolor=<%=(maptype == MAPTYPE_ISAPI) ? "yellow" : "white";%>>
<a href="/sysadmin/scripts/mappings.asp?mapfile=<%=txt2html(mapfile);%>&maptype=<%=MAPTYPE_ISAPI;%>">
<%=message("sa.WWW_MapISAPIExt", locale());%></a>
</td><td>
<a href="/sysadmin/scripts/mapisapi.asp?maptype=<%=maptype;%>&mapfile=<%=txt2html(mapfile);%>"><%=message("sa.Configure", locale());%></a>
</td></TR>
<TR><td nowrap bgcolor=<%=(maptype == MAPTYPE_PROXYPASS) ? "yellow" : "white";%>>
<a href="/sysadmin/scripts/mappings.asp?mapfile=<%=txt2html(mapfile);%>&maptype=<%=MAPTYPE_PROXYPASS;%>">
<%=message("sa.WWW_MapProxyPass", locale());%></a>
</td><td>
<a href="/sysadmin/scripts/mapproxy.asp?maptype=<%=maptype;%>&mapfile=<%=txt2html(mapfile);%>"><%=message("sa.Configure", locale());%></a>
</td></TR>
<TR><td nowrap bgcolor=<%=(maptype == MAPTYPE_SEARCH) ? "yellow" : "white";%>>
<a href="/sysadmin/scripts/mappings.asp?mapfile=<%=txt2html(mapfile);%>&maptype=<%=MAPTYPE_SEARCH;%>">
<%=message("sa.WWW_MapSearch", locale());%></a>
</td><td>
<a href="/sysadmin/scripts/mapsrch.asp?maptype=<%=maptype;%>&mapfile=<%=txt2html(mapfile);%>"><%=message("sa.Configure", locale());%></a>
</td></TR>
<TR><td nowrap bgcolor=<%=(maptype == MAPTYPE_SERVLET) ? "yellow" : "white";%>>
<a href="/sysadmin/scripts/mappings.asp?mapfile=<%=txt2html(mapfile);%>&maptype=<%=MAPTYPE_SERVLET;%>">
<%=message("sa.WWW_MapServlet", locale());%></a>
</td><td>
<a href="/sysadmin/scripts/mapjava.asp?maptype=<%=maptype;%>&mapfile=<%=txt2html(mapfile);%>"><%=message("sa.Configure", locale());%></a>
</td></TR>
</table>
</td>
<td nowrap>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
<td nowrap width=80% align=left>
<% 
	if (maptype == MAPTYPE_ALIAS) 
		printf("<B>%s</B><BR>", message("sa.WWW_MapDocAlias", locale()));
	else if (maptype == MAPTYPE_CGIALIAS) 
		printf("<B>%s</B><BR>", message("sa.WWW_MapCGIAlias", locale()));
	else if (maptype == MAPTYPE_WINCGIALIAS) 
		printf("<B>%s</B><BR>", message("sa.WWW_MapWinCGIAlias", locale()));
	else if (maptype == MAPTYPE_ISAPI) 
		printf("<B>%s</B><BR>", message("sa.WWW_MapISAPIExt", locale()));
	else if (maptype == MAPTYPE_SERVLET) 
		printf("<B>%s</B><BR>", message("sa.WWW_MapServlet", locale()));
	else if (maptype == MAPTYPE_CGI) 
		printf("<B>%s</B><BR>", message("sa.WWW_MapCGIAssoc", locale()));
	else if (maptype == MAPTYPE_SEARCH) 
		printf("<B>%s</B><BR>", message("sa.WWW_MapSearch", locale()));
%>
<table border=0 cellpadding=2 cellpadding=2>
<% 
aliases = mappings(mapfile, maptype);
if (sizeof(aliases) == 0)
	printf("<tr><td><I>none</I></td></tr>");

for (i = 0; i < sizeof(aliases); i++) 
{
	alias = aliases[i];
	printf("<tr><td><B>%s</B></td><td nowrap>&nbsp; %s</td></tr>",
		txt2html(alias.name), txt2html(alias.value));
}
%>
</table>
</td></tr>
</table>
<%
#include "../footer.asp"
%>
</BODY></HTML>
