<HTML>
<HEAD><TITLE><%=txt2html(envt("servername"));%> - Security Administration</TITLE>
<% 
#include "../header.asp"
menu = "security";
#include "../menu.asp"
area = "overview";
#include "submenu.asp"
%>
<table border=0 width=98%><tr><td nowrap>
<B>Security Administration</B>
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
<code>Authentication <b><%=envt("authtype");%></code>
<% if (envt("authtype") == "passwd") { %>
<small>[<%=envt("passwdcrypt");%>]</small>
<% } %>
</td><td nowrap align=right>
<A TARGET="help" HREF="/syshelp/sec.htm"><small>
<%=message("sa.Help", locale());%></small></A>
</td></tr></table>
<P>
<TABLE border=0 cellpadding=2>

<TR><TD nowrap>Allow .htaccess Upload</TD><TD nowrap> [
<% if (envt("htaccessupload") == "true") { %>
    <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
    <A HREF="/session/sysconfig?htaccessupload=false&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
    <A HREF="/session/sysconfig?htaccessupload=true&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } %>
] </TD>
<TD nowrap></TD></TR>

<% if ((license == "pro") ||
       (license == "demo") ||
       (license == "enterprise")) {
%>

<TR valign=top><TD nowrap>Allow Friends Access</TD><TD nowrap> [
<% if (envt("friends") == "true") { %>
    <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
    <A HREF="/session/sysconfig?friends=false&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
    <A HREF="/session/sysconfig?friends=true&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } %>
] </TD>
<TD nowrap>
Allow users to grant friends access to their account.
</TD></TR>

<TR valign=top><TD nowrap>Allow Masquerade Logins</TD><TD nowrap> [
<% if (envt("masquerade") == "true") { %>
    <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
    <A HREF="/session/sysconfig?masquerade=false&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
    <A HREF="/session/sysconfig?masquerade=true&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } %>
] </TD>
<TD nowrap>
Allow programatic (C or Java) and administrator logins to any account 
without authentication (<i>not recommended</i>).
</TD></TR>

<TR valign=top><TD nowrap>Allow Shared Directory</TD><TD nowrap> [
<% if (envt("shareddisk") == "true") { %>
    <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
    <A HREF="/session/sysconfig?shareddisk=false&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
    <A HREF="/session/sysconfig?shareddisk=true&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } %>
] </TD>
<TD nowrap>
<A HREF="/sysadmin/servers/cnfwww.asp">Location</A>
&nbsp;&nbsp;
Allow all users access to a shared disk space (read/write).
</TD></TR>

<TR valign=top><TD nowrap>Auto-provision Users</TD><TD nowrap> [
<% if (envt("provisionuser") == "true") { %>
    <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
    <A HREF="/session/sysconfig?provisionuser=false&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
    <A HREF="/session/sysconfig?provisionuser=true&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } %>
] </TD>
<TD nowrap>
<A HREF="/sysadmin/security/userprov.asp">Manage</A>
&nbsp;&nbsp;
<% if ((envt("ldapauth") != "true") && 
	(envt("adauth") != "true") &&
	(envt("ntauth") != "true") &&
	(envt("radiusauth") != "true")) { 
%>
LDAP, ActiveDirectory, NT or Radius Authenticated users only.
<% } %>
</TD></TR>

<TR valign=top><TD nowrap>Auto-provision Mailboxes</TD><TD nowrap> [
<% if (envt("provisionmbox") == "true") { %>
    <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
    <A HREF="/session/sysconfig?provisionmbox=false&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
    <A HREF="/session/sysconfig?provisionmbox=true&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } %>
] </TD>
<TD nowrap>
</TD></TR>

<% } %>

<TR><TD nowrap>Digest Authentication</TD><TD nowrap> [
<% if (envt("digestauth") == "true") { %>
    <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
    <A HREF="/session/sysconfig?digestauth=false&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
    <A HREF="/session/sysconfig?digestauth=true&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } %>
] </TD>
<TD nowrap>
Applies to Mail and HTTP authentication.  
Required for Apple &amp; XP WebDAV.
</TD></TR>

<TR><TD nowrap>DOT-File Security</TD><TD nowrap> [
<% if (envt("dotsecurity") == "true") { %>
    <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
    <A HREF="/session/sysconfig?dotsecurity=false&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
    <A HREF="/session/sysconfig?dotsecurity=true&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } %>
] </TD>
<TD nowrap>
<% if ((envt("dotsecurity") == "true") && (envt("webdav") == "true")) { %>
<i>Must be <B>OFF</B> for Apple WebDAV clients.</i>
<% } %>
Disable to allow files with leading periods (.) to be uploaded.
</TD></TR>

<TR><TD nowrap>Enforce .htaccess</TD><TD nowrap> [
<% if (envt("htaccess") == "true") { %>
    <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
    <A HREF="/session/sysconfig?htaccess=false&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
    <A HREF="/session/sysconfig?htaccess=true&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } %>
] </TD>
<TD nowrap>
<A TARGET="help" HREF="/syshelp/htaccess.htm">
<%=message("sa.Help", locale());%></A>
</TD></TR>

<TR><TD nowrap>FTP Name Security</TD><TD nowrap> [
<% if (envt("ftpnamesec") == "true") { %>
    <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
    <A HREF="/session/sysconfig?ftpnamesec=false&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
    <A HREF="/session/sysconfig?ftpnamesec=true&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } %>
] </TD>
<TD nowrap></TD></TR>

<TR><TD nowrap>HttpOnly Sessions</TD><TD nowrap> [ 
<% if (envt("httponly") == "true") { %>
    <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
    <A HREF="/session/sysconfig?httponly=false&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
    <A HREF="/session/sysconfig?httponly=true&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } %>
] </TD>
<TD nowrap>
<% if (envt("httponly") == "false") { %>
<i>Recommend this be <B>ON</B>.</i>
<% } %>
</TD></TR>

<% if ((license == "pro") ||
       (license == "demo") ||
       (license == "enterprise")) {
%>
<TR><TD nowrap>Monitor Invalid Logins</TD><TD nowrap> [
<% if (envt("loginmon") == "true") { %>
    <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
    <A HREF="/session/sysconfig?loginmon=false&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
    <A HREF="/session/sysconfig?loginmon=true&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } %>
] </TD>
<TD nowrap>
<A TARGET="help" HREF="/syshelp/throttle.htm">
<%=message("sa.Help", locale());%></A>
<% if (envt("loginmon") == "true") { %>
<A HREF="/sysadmin/security/throtcnf.asp">Configure</A>
<% } %>
&nbsp; <b><%=txt2html(envt("loginmonmax"));%></b> (max attempts)
&nbsp; <b><%=txt2html(envt("loginmonwait"));%> sec</b> (timeout)
</TD></TR>

<TR><TD nowrap>Monitor Invalid Requests</TD><TD nowrap> [
<% if (envt("requestmon") == "true") { %>
    <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
    <A HREF="/session/sysconfig?requestmon=false&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
    <A HREF="/session/sysconfig?requestmon=true&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } %>
] </TD>
<TD nowrap>
<A TARGET="help" HREF="/syshelp/throttle.htm">
<%=message("sa.Help", locale());%></A>
<% if (envt("requestmon") == "true") { %>
<A HREF="/sysadmin/security/throtcnf.asp">Configure</A>
<% } %>
&nbsp; <b><%=txt2html(envt("requestmonmax"));%></b> (max attempts)
&nbsp; <b><%=txt2html(envt("requestmonwait"));%> sec</b> (timeout)
</TD></TR>
<% } %>

<TR><TD nowrap>Login on .htaccess Authentication</TD><TD nowrap> [ 
<% if (envt("loginonauth") == "true") { %>
    <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
    <A HREF="/session/sysconfig?loginonauth=false&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
    <A HREF="/session/sysconfig?loginonauth=true&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } %>
] </TD>
<TD nowrap>
</TD></TR>

<% if (envt("httpsserver") == "true") { %>
<TR><TD nowrap>Secure Sessions Only</TD><TD nowrap> [ 
<% if (envt("securesessions") == "true") { %>
    <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
    <A HREF="/session/sysconfig?securesessions=false&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
    <A HREF="/session/sysconfig?securesessions=true&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } %>
] </TD>
<TD nowrap>
</TD></TR>
<% } %>

<TR><TD nowrap>SSI #exec Support</TD><TD nowrap> [
<% if (envt("noscriptexec") == "true") { %>
    <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
    <A HREF="/session/sysconfig?noscriptexec=false&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
    <A HREF="/session/sysconfig?noscriptexec=true&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } %>
] </TD>
<TD nowrap>
<A TARGET="help" HREF="/syshelp/ssi.htm">
<%=message("sa.Help", locale());%></A>
&nbsp; SSI extensions: <%=txt2html(envt("ssi"));%>
</TD></TR>

<TR><TD nowrap>Share User Logins</TD><TD nowrap> [ 
<% if (envt("sharelogins") == "true") { %>
    <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
    <A HREF="/session/sysconfig?sharelogins=false&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
    <A HREF="/session/sysconfig?sharelogins=true&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } %>
] </TD>
<TD nowrap>
<% if (envt("sharelogins") == "false") { %>
<i>Recommend this be <B>ON</B>.</i>
<% } %>
</TD></TR>

<% if ((license == "pro") ||
       (license == "demo") ||
       (license == "enterprise")) {
%>
<TR><TD nowrap>Single-Signon</TD><TD nowrap> [ 
<% if (envt("singlesignon") == "true") { %>
    <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
    <A HREF="/session/sysconfig?singlesignon=false&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
    <A HREF="/session/sysconfig?singlesignon=true&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } %>
] </TD>
<TD nowrap>
<% if (envt("singlesignon") == "true") { %>
Session domain <B><%=txt2html(envt("sessoindomain"));%></B>.  
Session key <B><%=txt2html(envt("sessionkey"));%></B>.
<% } %>
</TD></TR>
<% } %>

<% if (envt("httpsserver") == "true") { %>
<TR><TD nowrap>SSL Logins Only</TD><TD nowrap> [ 
<% if (envt("ssllogins") == "true") { %>
    <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
    <A HREF="/session/sysconfig?ssllogins=false&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
    <A HREF="/session/sysconfig?ssllogins=true&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } %>
] </TD>
<TD nowrap>
</TD></TR>
<% } %>

<% if ((license == "pro") ||
       (license == "demo") ||
       (license == "enterprise")) {
%>
<TR valign=top><TD nowrap>Throttling</TD><TD nowrap> [
<% if (envt("throttling") == "true") { %>
    <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN>
<% } else { %>
    <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } %>
] </TD>
<TD nowrap>
<A TARGET="help" HREF="/syshelp/throttle.htm">
<%=message("sa.Help", locale());%></A>
<A HREF="/sysadmin/security/throtcnf.asp">Configure</A>
</TD></TR>

<% } %>

<TR><TD nowrap>Trace User Logins</TD><TD nowrap> [
<% if (envt("tracelogins") == "true") { %>
    <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
    <A HREF="/session/sysconfig?tracelogins=false&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
    <A HREF="/session/sysconfig?tracelogins=true&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } %>
] </TD>
<TD nowrap></TD></TR>

<% if ((license == "pro") ||
       (license == "demo") ||
       (license == "enterprise")) {
%>
<TR valign=top><TD nowrap>Verify provisioned users</TD><TD nowrap> [
<% if (envt("provisionverify") == "true") { %>
    <SPAN CLASS="selectedOn"><%=message("sa.xON", locale());%></SPAN> / 
    <A HREF="/session/sysconfig?provisionverify=false&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="off"><%=message("sa.off", locale());%></SPAN></A>
<% } else { %>
    <A HREF="/session/sysconfig?provisionverify=true&RCredirect=/sysadmin/security/index.asp">
    <SPAN CLASS="on"><%=message("sa.on", locale());%></SPAN></A> / <SPAN CLASS="selectedOff"><%=message("sa.xOFF", locale());%></SPAN>
<% } %>
] </TD>
<TD nowrap>
<A HREF="/sysadmin/security/userprov.asp">Provision</A>
&nbsp;&nbsp;
Verify user directory exists (in '<%=txt2html(envt("usersdir"));%>').
<% if ((envt("ldapauth") != "true") && 
	(envt("adauth") != "true") &&
	(envt("ntauth") != "true") &&
	(envt("radiusauth") != "true")) { 
%>
LDAP, ActiveDirectory, NT or Radius Authenticated users only.
<% } %>
</TD></TR>

<% } %>

</TABLE>

<% if (envt("os") != "win32") { %>
<BR>
<BR>
<TABLE border=0 cellspacing=2>
<TR><TD nowrap><B>CHROOT Path</B></TD>
<TD>
<%
val = envt("chrootpath");
if (sizeof(val) == 0)
    write("<i>not set</i>");
else
    write(val);
%>
</TD></TR>
<TR><TD nowrap><B>SET UID User</B></TD>
<TD>
<%
val = envt("setuiduser");
if (sizeof(val) == 0)
    write("<i>not set</i>");
else
    write(val);
%>
</TD></TR>
<TR><TD nowrap><B>SET GID Group</B>&nbsp;&nbsp;&nbsp;</TD>
<TD>
<%
val = envt("setgidgroup");
if (sizeof(val) == 0)
    write("<i>not set</i>");
else
    write(val);
%>
</TD></TR>
</TABLE>
<% } %>

<BR>
<font color=#990033><B>Login Restrictions</font>
<TABLE border=0 cellspacing=2>
<TR><TD nowrap>System Administrators</TD><TD><%=txt2html(envt("sysadmin"));%></TD></TR>
<TR><TD nowrap>System Administrator IPs&nbsp;&nbsp;&nbsp;</TD><TD><%=txt2html(envt("sysadminip"));%></TD></TR>
<TR><TD nowrap>User IPs&nbsp;&nbsp;&nbsp;</TD><TD><%=txt2html(envt("userip"));%></TD></TR>
</TABLE>

<%
#include "../footer.asp"
%>
</BODY></HTML>
