<HTML>
<HEAD><TITLE><%=txt2html(envt("servername"));%> - Security Administration</TITLE>
<SCRIPT language="JavaScript">
<!--
function confirmDelete()
{
	return confirm("Delete selected user directory?");
}
//-->
</SCRIPT>
<% 
#include "../header.asp"
menu = "security";
#include "../menu.asp"
area = "users";
#include "submenu.asp"

dirs = usersDirectories();
dir = getParameter($params, "usersdir");
if ((dir == NULL) && (sizeof(dirs) > 0))
	dir = dirs[0];
else if (sizeof(dir) == 0)
	dir = "users";

path = getServerPath($request, dir);
pathlen = strlen(path);
if (path[pathlen - 1] == '/')
	path[pathlen - 1] = '\0';

action = getParameter($params, "action");
if (action == "delete")
{
	username = getParameter($params, "username");
	userdir = path + "/" + username;
	if ((sizeof(username) > 0) && (isDir(userdir)))
	{
		// Delete the directory...
		if (rmtree(userdir) != 0)
		{
			printf("<center><div class=\"error\">");
			printf("User '%s' could not be deprovisioned.<br>", username);
			printf("Failure deleting: %s", userdir);
			printf("</div></center>");
		}
		else
		{
			printf("<center><div class=\"info\">");
			printf("User '%s' deprovisioned, directory deleted.<br>", username);

			// Delete the mailbox and any mailing lists
			if (envt("mailserver") == "true")
			{
				if (mboxExists(username))
				{
					printf("User '%s' mailbox deleted.<br>", username);
					mboxDelete(username);
				}
			}

			useraliasDelete(username);

			printf("</div></center>");
		}
	}
}
else if (action == "create")
{
	username = getParameter($params, "username");
	if (sizeof(username) > 0)
	{
		userdir = path + "/" + username;
		if (!isDir(userdir))
		{
			// Create user directory.
			if (mkdir(userdir) != 0)
			{
				printf("<center><div class=\"error\">");
				printf("User '%s' could not be provisioned.<br>", username);
				printf("Failure creating: %s", userdir);
				printf("</div></center>");
			}
			else
			{
				printf("<center><div class=\"info\">");
				printf("User '%s' provisioned, directory created.", username);
				printf("</div></center>");

				mbox = getParameter($params, "mbox");
				if (mbox == "on")
					mboxCreate(username);

				useraliasAdd(username, NULL, userdir);

				mysite = getServerPath($request, "/sysuser/mysite.rss");
				if (isFile(mysite))
    				cp(mysite, userdir + "/mysite.rss");

				myfavs = getServerPath($request, "/sysuser/favorites.rss");
				if (isFile(myfavs))
    				cp(myfavs, userdir + "/favorites.rss");
			}
		}
		else
		{
			printf("<center><div class=\"error\">");
			printf("User '%s' already provisioned.", username);
			printf("</div></center>");
		}

		privatedir = path + "/" + username + "/private";
		if (!isDir(privatedir))
		{
			// Create user private directory.
			if (mkdir(privatedir) != 0)
			{
				printf("<center><div class=\"error\">");
				printf("User '%s' could not be created.<br>", privatedir);
				printf("</div></center>");
			}
			else
			{
				printf("<center><div class=\"info\">");
				printf("User '%s' <B>private</B> directory created.", username);
				printf("</div></center>");
			}
		}

		if (!isDir(privatedir + "/.DAV"))
			mkdir(privatedir + "/.DAV");
	}
}

showUsers(char **users)
{
	throttling = 0;
	if (envt("throttleusers") == "true")
		throttling = 1;

	printf("<table border=0 cellspacing=4>\n");
	printf("<tr bgcolor=#cccccc><td><b>User</b></td>");
	if (throttling)
	{
		printf("<td align=right><b>Last Usage</b></td>");
		printf("<td align=right><b>Requests</b></td>");
		printf("<td align=right><b>Outbound I/O</b></td>");
		printf("<td align=right><b>Inbound I/O</b></td>");
	}
	printf("<td>&nbsp;</td>");
	printf("</tr>");

	for (i = 0; i < sizeof(users); i++) 
	{
		printf("<tr>");

		printf("<td nowrap>%s", txt2html(users[i]));
		if (throttling)
		{
			tuser = userThrottle(users[i]);
			if (tuser == NULL)
			{
				printf("<td align=right>n/a</td><td align=right>n/a</td><td align=right>n/a</td><td align=right>n/a</td>");
			}
			else
			{
				printf("<td nowrap align=right>&nbsp; &nbsp; &nbsp; &nbsp; ");
				if (tuser.lastlogin == 0)
					printf("n/a");
				else
					printf("%s", strftime(tuser.lastlogin, "%d %b %Y %H:%M:%S"));
				printf("</td>");

				printf("<td align=right>%ld</td>", tuser.requests);

				printf("<td nowrap align=right>%s</td>", 
					tuser.maxsend ? "<B>Max Sent</B> " : 
					getSizeK((int)(tuser.send / 1024)));
				printf("<td nowrap align=right>%s</td>", 
					tuser.maxreceive ? "<B>Max Received</B> " : 
					getSizeK((int)(tuser.receive / 1024)));
			}
		}

		printf("<td nowrap><a href=\"/sysadmin/security/userprov.asp?action=delete&username=%s&usersdir=%s\" onclick=\"return confirmDelete()\">\n",
			txt2html(users[i]), dir);
		printf("<IMG border=0 align=top ALT=\"Deprovision User\" SRC=\"/sysimage/icons/delete.gif\">Delete</A></td>\n");

		printf("</tr>\n");
	}

	printf("</table>\n");
}
%>
<table border=0 width=98%><tr><td nowrap>
<B>User Provisioning</B>
</td><td nowrap align=right>
<A TARGET="help" HREF="/syshelp/auth.htm"><small>
<%=message("sa.Help", locale());%></small></A>
</td></tr></table>
<P>
<% if (sizeof(dirs) > 0) { %>
<table border=0 cellpadding=4>
<tr valign=top><td><I>Change Users Directory:</I></td><td>
<FORM name=changedir method=GET action="/sysadmin/security/userprov.asp">
<SELECT name="usersdir" onchange="javascript:document.changedir.submit();">
<% 
	for (i = 0; i < sizeof(dirs); i++) 
	{
		printf("<option %s>%s\n", (dirs[i] == dir) ? "SELECTED" : "",
			dirs[i]);
	}
%>
</SELECT>
</FORM>
</td><td nowrap>
&nbsp;&nbsp;&nbsp;
Real path: <%=path;%>
</td></tr></table>
<blockquote>
<div id="validationError"></div>
<FORM name=newuser method=POST action="/sysadmin/security/userprov.asp"
onSubmit="return validateForm(this)">
<input type=hidden name="action" value="create">
<input type=hidden name="usersdir" value="<%=dir;%>">
<input type=text name="username" value="" ptype="uname" required="true">
<input class="mod" type=submit value="Provision New User">
</form>
<br>
<%
	users = ls(path);
	sort(users);
	showUsers(users);
%>
<% } else { %>
User provisioning is not presently enabled.  The 
<CODE>Auto-provision Users</CODE> or <CODE>Verify provisioned users</CODE> 
configuration options indicate whether to create directories for users that
have authenticated externally, or verify that an externally authenticated
user has a directory provisioned (externally authenticated applies to LDAP,
Radius and NT Authentication).  Each Virtual Host can have it's own 
<CODE>Users Directory</CODE>.
<% } %>
</blockquote>
<%
#include "../footer.asp"
%>
</BODY></HTML>
