<HTML>
<HEAD><TITLE><%=txt2html(envt("servername"));%> - Services Administration</TITLE>
<% 
/* Generate JavaScript for CRON */
myparams = allocParameters();
setParameter(myparams, "rpc", "addcron");
rpc("helprpcjs", myparams);

#include "../header.asp"
menu = "services";
#include "../menu.asp"
area = "cron";
#include "submenu.asp"
%>
<table border=0 width=98%><tr><td nowrap>
<B>CRON Task Scheduler</B>
[ <A HREF="/sysadmin/services/showini.asp?area=cron&file=schedule.ini">schedule.ini</A> ]
</td><td nowrap align=right>
<A TARGET="help" HREF="/syshelp/sched.htm"><small>
<%=message("sa.Help", locale());%></small></A>
</td></tr></table>
<I>Changes take effect immediately!</I>
<UL>
<A HREF="/sysadmin/services/showcron.asp">Scheduled Tasks</A><BR>
<A HREF="/sysadmin/services/schedule.asp">Startup/Shutdown/Hourly/Daily/Weekly Scheduler</A><BR>
</UL>
<P>
The Sambar Server includes a built-in CRON Scheduler for managing events
such as log file rotation, and search re-indexing.
User defined events can be configured using the interfaces below.  
See the <A TARGET="help" HREF="/syshelp/sched.htm">Task Scheduler</A> 
documentation for more details. <b>Note:</b> This is for executing internal
server URLs, NOT for executing external scripts or applications.
<br/><br/>
<b>Scheduling quick and easy...</b>
<blockquote>
<ul>
<li> Create a script that performs some function when executed 
(i.e. <code>/sysadmin/dostuff.asp</code>)
<br/>
ASP, STM, JSP, PHP or any other scripting engine supported by the 
Sambar Server can be used.</li>
<li> Verify that when you load the script via your browser, it performs
the action you desire (i.e. <code>http://localhost/sysadmin/dostuff.asp</code>)
<br/>
The Task Scheduler runs with administrator privileges, so it can execute
scripts in the <code>/sysadmin</code> folder (a safe location).</li>
<li> Finally, use the url2file RPC in the <b>Command</b> entry below to 
execute the script periodically and write the output of the script to 
a temporary file:
<br/>
(i.e. <code>/session/url2file?fname=/tmp/dostuff.out&url=/sysadmin/dostuff.asp</code>)</li>
</ul>
</blockquote>
<br/>
<TABLE border=0 cellspacing=2><TR><TD>
<%
myparams = allocParameters();
setParameter(myparams, "showcron", "/sysadmin/services/cron.asp");
rpc("listcron", myparams);
%>
</TD></TR></TABLE>
<HR>
<P>
<FORM METHOD=POST ACTION=/session/addcron onsubmit="return Validate_addcron(this)">
<INPUT TYPE=hidden NAME="RCpage" VALUE="/sysadmin/services/cron.asp">
<TABLE border=0 cellspacing=4>
<TR><TD><B>Command</B></TD><TD><INPUT TYPE=text NAME="command" SIZE=80 VALUE=""></TD></TR>
<TR><TD></TD><TD><INPUT TYPE=checkbox NAME=parallel CHECKED> Run in parallel</TD></TR>
<TR><TD colspan=2>
	<blockquote>
	<I>i.e.</i> <code>perl/perl.exe tmp/perltask.pl</code><br>
	<I>or...</i> <code>/session/index?indexname=docs&amp;rebuild=y</code><br>
	<I>or...</i> <code>/session/url2file?fname=/docs/inline.htm&amp;url=/samples/inline.stm</code><br>
	<I>or...</i> <code>http://www.foo.com/cgi-bin/run.pl?name1=value1&amp;name2=value2</code><br>
	</blockquote>
</TD></TR>
</TABLE>
<BLOCKQUOTE>
<TABLE border=0 cellspacing=6>
<TR><TD><B>Minutes</B></TD><TD><B>Hours</B></TD><TD><B>Days</B></TD><TD><B>Months</B></TD><TD><B>Weekdays</B></TD></TR>
<TR valign=top>
<TD><INPUT TYPE=radio NAME=minutes VALUE="*" CHECKED> All<BR>
<INPUT TYPE=radio NAME=minutes VALUE="-"> Selected<BR>
	<SELECT NAME=mval SIZE=10 MULTIPLE>
	<OPTION> 0
	<OPTION> 1
	<OPTION> 2
	<OPTION> 3
	<OPTION> 4
	<OPTION> 5
	<OPTION> 6
	<OPTION> 7
	<OPTION> 8
	<OPTION> 9
	<OPTION> 10
	<OPTION> 11
	<OPTION> 12
	<OPTION> 13
	<OPTION> 14
	<OPTION> 15
	<OPTION> 16
	<OPTION> 17
	<OPTION> 18
	<OPTION> 19
	<OPTION> 20
	<OPTION> 21
	<OPTION> 22
	<OPTION> 23
	<OPTION> 24
	<OPTION> 25
	<OPTION> 26
	<OPTION> 27
	<OPTION> 28
	<OPTION> 29
	<OPTION> 30
	<OPTION> 31
	<OPTION> 32
	<OPTION> 33
	<OPTION> 34
	<OPTION> 35
	<OPTION> 36
	<OPTION> 37
	<OPTION> 38
	<OPTION> 39
	<OPTION> 40
	<OPTION> 41
	<OPTION> 42
	<OPTION> 43
	<OPTION> 44
	<OPTION> 45
	<OPTION> 46
	<OPTION> 47
	<OPTION> 48
	<OPTION> 49
	<OPTION> 50
	<OPTION> 51
	<OPTION> 52
	<OPTION> 53
	<OPTION> 54
	<OPTION> 55
	<OPTION> 56
	<OPTION> 57
	<OPTION> 58
	<OPTION> 59
	</SELECT>
</TD>
<TD><INPUT TYPE=radio NAME=hours VALUE="*" CHECKED> All<BR>
<INPUT TYPE=radio NAME=hours VALUE="-"> Selected<BR>
	<SELECT NAME=hval SIZE=10 MULTIPLE>
	<OPTION> 0
	<OPTION> 1
	<OPTION> 2
	<OPTION> 3
	<OPTION> 4
	<OPTION> 5
	<OPTION> 6
	<OPTION> 7
	<OPTION> 8
	<OPTION> 9
	<OPTION> 10
	<OPTION> 11
	<OPTION> 12
	<OPTION> 13
	<OPTION> 14
	<OPTION> 15
	<OPTION> 16
	<OPTION> 17
	<OPTION> 18
	<OPTION> 19
	<OPTION> 20
	<OPTION> 21
	<OPTION> 22
	<OPTION> 23
	</SELECT>
</TD>
<TD><INPUT TYPE=radio NAME=days VALUE="*" CHECKED> All<BR>
<INPUT TYPE=radio NAME=days VALUE="-"> Selected<BR>
	<SELECT NAME=dval SIZE=10 MULTIPLE>
	<OPTION> 0
	<OPTION> 1
	<OPTION> 2
	<OPTION> 3
	<OPTION> 4
	<OPTION> 5
	<OPTION> 6
	<OPTION> 7
	<OPTION> 8
	<OPTION> 9
	<OPTION> 10
	<OPTION> 11
	<OPTION> 12
	<OPTION> 13
	<OPTION> 14
	<OPTION> 15
	<OPTION> 16
	<OPTION> 17
	<OPTION> 18
	<OPTION> 19
	<OPTION> 20
	<OPTION> 21
	<OPTION> 22
	<OPTION> 23
	<OPTION> 24
	<OPTION> 25
	<OPTION> 26
	<OPTION> 27
	<OPTION> 28
	<OPTION> 29
	<OPTION> 30
	<OPTION> 31
	</SELECT>
</TD>
<TD><INPUT TYPE=radio NAME=months VALUE="*" CHECKED> All<BR>
<INPUT TYPE=radio NAME=months VALUE="-"> Selected<BR>
	<SELECT NAME=oval SIZE=12 MULTIPLE>
	<OPTION VALUE=jan> January
	<OPTION VALUE=feb> February
	<OPTION VALUE=mar> March
	<OPTION VALUE=apr> April
	<OPTION VALUE=may> May
	<OPTION VALUE=jun> June
	<OPTION VALUE=jul> July
	<OPTION VALUE=aug> August
	<OPTION VALUE=sep> September
	<OPTION VALUE=oct> October
	<OPTION VALUE=nov> November
	<OPTION VALUE=dec> December
	</SELECT>
</TD>
<TD><INPUT TYPE=radio NAME=weekdays VALUE="*" CHECKED> All<BR>
<INPUT TYPE=radio NAME=weekdays VALUE="-"> Selected<BR>
	<SELECT NAME=wval SIZE=7 MULTIPLE>
	<OPTION VALUE=sun> Sunday
	<OPTION VALUE=mon> Monday
	<OPTION VALUE=tue> Tuesday
	<OPTION VALUE=wed> Wednesday
	<OPTION VALUE=thu> Thursday
	<OPTION VALUE=fri> Friday
	<OPTION VALUE=sat> Saturday
	</SELECT>
</TD></TR>

</TABLE>
<INPUT TYPE=submit class="mod" VALUE="Create Task">
</FORM>
<BR>
<FONT SIZE=-1>Note: Cron jobs terminated after <%=txt2html(envt("crontimeout"));%> 
seconds.</FONT>
</BLOCKQUOTE>
<%
#include "../footer.asp"
%>
</BODY></HTML>
