<HTML>
<HEAD><TITLE><%=txt2html(envt("servername"));%> - <%=message("sa.Sys_ServerCert", locale());%></TITLE>
<%
#include "../header.asp"
menu = "system";
#include "../menu.asp"
area = "ssl";
#include "submenu.asp"

generate = getParameter($params, "generate");
country = findParameter($params, "country", "US");
state = findParameter($params, "state", "CA");
locality = findParameter($params, "locality", "Monterey");
org = findParameter($params, "org", "Operations");
orgunit = findParameter($params, "orgunit", "R&D");
host = findParameter($params, "host", envt("servername"));
email = findParameter($params, "email", "root@localhost");
%>
<table border=0 width=98%><tr><td nowrap>
<B><%=message("sa.Sys_ServerCSR", locale());%></B>
</td></tr>
</table>
<P>
<% if (generate == "true") {
	if (isFile("config/req.pem"))
	{
		printf("%s config/req.pem -&gt; config/req.pem.bkp<BR>", 
			message("sa.RenamingFile", locale()));
		mv("config/req.pem", "config/req.pem.bkp");
	}

	if (!isFile("config/" + envt("keyfile")))
	{
		cmd = "openssl genrsa -out config/" + envt("keyfile") + " 1024";
    	printf("%s<BR><BR><CODE>%s</CODE>", 
			message("sa.Sys_GenSrvKey", locale()), cmd);
    	printf("<BR>");
    	if (system(cmd, 300) != 0)
    	{
    		printf("<font color=#aa0000><B>%s</B></font>", 
				message("sa.FailureLogged", locale()));
        	exit;
		}
	}

	sprintf(cmd, 
		"openssl req -new -key config/" + envt("keyfile") + " -config config/openssl.cnf -out config/req.pem -subj \"/C=%s/ST=%s/L=%s/O=%s/OU=%s/CN=%s/emailAddress=%s\"",
		country, state, locality, org, orgunit, host, email);
	printf("%s<BR><BR><CODE>%s</CODE>", 
		message("sa.Sys_GenCACrt", locale()), cmd);
	printf("<BR><BR>");
	if (system(cmd, 300) != 0)
	{
    	printf("<font color=#aa0000><B>%s</B></font>", 
			message("sa.FailureLogged", locale()));
		exit;
	}

	printf("%s<BR>\n", message("sa.Sys_CSRDone", locale()));
	printf("<BLOCKQUOTE><BLOCKQUOTE><PRE>");
    	char *ini;
    	sprintf(ini, "%s/req.pem", envt("configdir"));
    	myparams = allocParameters();
    	setParameter(myparams, "escapeHTML", "true");
    	setParameter(myparams, "file", ini);
    	rpc("showfile", myparams);
	printf("</PRE></BLOCKQUOTE></BLOCKQUOTE>\n");

} else {
%>
	<% if (isFile("config/req.pem")) { %>
		<font color=#ff0000><B>
		<%=message("sa.Sys_CSRExists", locale());%>
		</B></font>
	<%
		printf("<BR><BLOCKQUOTE><BLOCKQUOTE><PRE>");
    		char *ini;
    		sprintf(ini, "%s/req.pem", envt("configdir"));
    		myparams = allocParameters();
    		setParameter(myparams, "escapeHTML", "true");
    		setParameter(myparams, "file", ini);
    		rpc("showfile", myparams);
		printf("</PRE></BLOCKQUOTE></BLOCKQUOTE>\n");
	} 
	%>
	<P>
	This form allows you to generate a Certificate Signed Request (CSR)
	and private key which you can use to apply for a trusted certificate.
	The CSR is what contains the name information for the certificate 
	(Country, State/Province, City, Organization, Division, 
	Web Server Domain Name, etc).  It also contains your public key.
	<P>
	The formats of certificate and CSR used by the Sambar Server are the
	same as those used by Apache.  The CSR should be sent for 
	verification to Certificate Authority (CA) e.g.  
	Verisign (<A HREF="http://www.verisign.com/">www.verisign.com</A>).
	<BLOCKQUOTE><BLOCKQUOTE>
	<FORM method=POST action="/sysadmin/system/csr.asp">
	<input type=hidden name="generate" value="true">
	<table border=0 cellspacing=4>
	<tr valign=top><td><%=message("sa.Sys_CertCountry", locale());%></td>
	<td><input type=input name="country" value="<%=txt2html(country);%>" size=2 onkeypress="return handleEnter(this, event)">
	</td></tr>
	<tr valign=top><td><%=message("sa.Sys_CertState", locale());%></td>
	<td><input type=input name="state" value="<%=txt2html(state);%>" onkeypress="return handleEnter(this, event)">
	</td></tr>
	<tr valign=top><td><%=message("sa.Sys_CertCity", locale());%></td>
	<td><input type=input name="locality" value="<%=txt2html(locality);%>" onkeypress="return handleEnter(this, event)">
	</td></tr>
	<tr valign=top><td><%=message("sa.Sys_CertOrg", locale());%></td>
	<td><input type=input name="org" value="<%=txt2html(org);%>" onkeypress="return handleEnter(this, event)">
	</td></tr>
	<tr valign=top><td><%=message("sa.Sys_CertUnit", locale());%></td>
	<td><input type=input name="orgunit" value="<%=txt2html(orgunit);%>" onkeypress="return handleEnter(this, event)">
	</td></tr>
	<tr valign=top><td><%=message("sa.Sys_CertName", locale());%></td>
	<td><input type=input name="host" value="<%=txt2html(host);%>" onkeypress="return handleEnter(this, event)">
	<BR>i.e. www.sambar.com
	</td></tr>
	<tr valign=top><td><%=message("sa.Email", locale());%></td>
	<td><input type=input name="email" value="<%=txt2html(email);%>" onkeypress="return handleEnter(this, event)">
	</td></tr>
	<tr><td></td>
	<td><input class="mod" type=submit 
		value="<%=message("sa.Sys_GenCSR", locale());%>">
	</td></tr>
	</table>
	</FORM>
	</BLOCKQUOTE></BLOCKQUOTE>
<% } %>
<%
#include "../footer.asp"
%>
</BODY>
</HTML>
