<HTML>
<HEAD><TITLE><%=txt2html(envt("servername"));%> - <%=message("sa.Logs", locale());%></TITLE>
<% 
#include "../header.asp"
menu = "system";
#include "../menu.asp"
area = "logs";
#include "submenu.asp"

int pagesize = 64000;
int maxlines = 100;

char *query = getParameter($params, "q");
char *name = getParameter($params, "log");
if ((name != NULL) && (name[0] == '/'))
	sprintf(log, "%s%s", envt("logdir"), name);
else if ((name != NULL) && (name[0] != '/') && (name[1] != ':'))
	sprintf(log, "%s/%s", envt("logdir"), name);
else
	log = name;

if (log != null)
{
	l = strlen(log);
	if ((l > 3) && (strcasecmp(&log[l - 3], ".gz") == 0))
	{
		gunzip(log);
		log[l - 3] = '\0';
		n = strlen(name);
		name[n - 3] = '\0';
	}
}

s = stat(log);
if ((s == null) || (s.isdirectory))
{
	printf("<br><b>Log file '%s' could not be found.</b>", log); 
}
else if ((query != null) && (sizeof(query) > 0))
{
	printf("<table border=0><tr valign=bottom nowrap>");
	printf("<td nowrap><B>%s - %s</B> &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;</td>", 
		txt2html(name), txt2html(envt("servername")));
	printf("</td></tr></table>\n");
	printf("<form method=post action=/sysadmin/system/showlog.asp>");
	printf("<input type=hidden name=\"log\" value=\"%s\">", txt2html(name));
	printf("<input type=text name=\"q\" value=\"%s\" size=20>", txt2html(query));
	printf("<input class=\"mod\" type=submit value=\"Search File\">");
	printf("</form>");
	f = fopen(log, "ra");
	i = 0;
	done = 0;
	printf("<pre>\n");
	while ((!done) && (i < maxlines))
	{
		b = ffindl(f, query);
		if (b == null)
		{
			done = 1;
			continue;
		}

		write(txt2html(b));
		write("\n");

		i++;
	}
	printf("\n<!--- --->\n</pre>");

	fclose(f);
}
else
{
	uint64 pos = (uint64)findParameter($params, "p", "0");
    if (getParameter($params, "tail") == "y")
	{
		pos = s.size - pagesize;
	}

	if (pagesize > s.size)
		pos = 0;

	f = fopen(log, "ra");
	if (pos != 0)
		fseek(f, (uint64)pos);

	len = pagesize;
	if (len > s.size - pos)
		len = s.size - pos;

	r = fread(f, (int)len);
	fclose(f);

	printf("<table border=0><tr valign=bottom>");
	printf("<td nowrap><B>%s - %s</B> &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;</td>", 
		txt2html(name), txt2html(envt("servername")));
  	printf("<td><a href=\"/sysadmin/system/showlog.asp?log=%s&p=%qu\">",
		urlencode(name), (uint64)pos);
	printf("<img border=0 src=/sysimage/icons/refresh.gif></a>&nbsp;&nbsp;&nbsp;&nbsp;</td>");

	if (pos > 0)
	{
		printf("<td><a href=\"/sysadmin/system/showlog.asp?log=%s&p=0\">",
			urlencode(name));
		printf("<img border=0 vspace=0 hspace=2 width=15 height=15 src=/sysimage/webmail/first.gif></a></td>");

		prev = pos - pagesize;
		if (prev < 0)
			prev = 0;
		printf("<td><a href=\"/sysadmin/system/showlog.asp?log=%s&p=%qu\">",
			urlencode(name), (uint64)prev);
		printf("<img border=0 vspace=0 hspace=2 width=15 height=15 src=/sysimage/webmail/prev.gif></a></td>");
	}
	else
	{
		printf("<td><img border=0 vspace=0 hspace=2 width=15 height=15 src=/sysimage/webmail/firstd.gif></td>");
		printf("<td><img border=0 vspace=0 hspace=2 width=15 height=15 src=/sysimage/webmail/prevd.gif></td>");
	}

	printf("<td nowrap><table border=1 cellpadding=0 cellspacing=0><tr><td nowrap align=center> %s&nbsp;&nbsp;<b>-</b> &nbsp;&nbsp;%s &nbsp;&nbsp; <b>/</b> &nbsp;&nbsp; %s </td></tr></table></td>",
		size2string((char *)pos),
		size2string((char *)(pos + len)),
		size2string((char *)s.size));

	if (pos + pagesize < s.size)
	{
		printf("<td><a href=\"/sysadmin/system/showlog.asp?log=%s&p=%qu\">",
			urlencode(name), (uint64)(pos + pagesize));
		printf("<img border=0 vspace=0 hspace=2 width=15 height=15 src=/sysimage/webmail/next.gif></a></td>");

		printf("<td><a href=\"/sysadmin/system/showlog.asp?log=%s&tail=y\">",
			urlencode(name));
		printf("<img border=0 vspace=0 hspace=2 width=15 height=15 src=/sysimage/webmail/last.gif></a></td>");
	}
	else
	{
		printf("<td><img border=0 vspace=0 hspace=2 width=15 height=15 src=/sysimage/webmail/nextd.gif></td>");
		printf("<td><img border=0 vspace=0 hspace=2 width=15 height=15 src=/sysimage/webmail/lastd.gif></td>");
	}

	printf("</tr></table>\n");

	printf("<form method=get action=/sysadmin/system/showlog.asp>");
	printf("<input type=hidden name=\"log\" value=\"%s\">", txt2html(name));
	printf("<input type=text name=\"q\" value=\"\" size=20>");
	printf("<input class=\"mod\" type=submit value=\"Search File\">");
	printf("</form>");

	printf("<pre>\n");
	write(txt2html(r));
	printf("\n<!--- --->\n</pre>");
}

#include "../footer.asp"
%>
</BODY></HTML>
