<HTML>
<HEAD><TITLE><%=txt2html(envt("servername"));%> - SOAP Utility</TITLE>
<% 
#include "../header.asp"
menu = "utils";
#include "../menu.asp"
area = "soap";
#include "submenu.asp"
key = findParameter($params, "key", "");
if (sizeof(key) == 0)
	key = envt("s3key");
%>
<FORM method=get action="amazon.asp">
<table border=0 cellspacing=4>
<tr><td>Amazon DEV Token</td>
<td><INPUT NAME=key size=40 VALUE="<%=key;%>"></td></tr>
<tr><td>Query</td>
<td><INPUT NAME=query size=40 VALUE="<%=findParameter($params, "query", ""); %>"></td>
</tr>
<tr><td></td>
<td><INPUT TYPE=submit class="mod" VALUE="Amazon Book Search"></td></tr>
</tr>
</table>
</FORM>
<%
typedef struct search 
{
	char *devtag;
	char *keyword;
	char *page;
	char *tag;
	char *type;
	char *mode;
};

key = getParameter($params, "key");
query = getParameter($params, "query");
if ((key != NULL) && (query != NULL))
{
	struct search s;

	s.devtag = key;
	s.keyword = query;
	s.page = "1";
	s.tag = "webservices-20";
	s.type = "lite";
	s.mode = "books";

	/*
	** query Amazon using their SOAP interface
	*/
	$soap = soapService("http://xml.amazon.com/onca/soap2",
		"KeywordSearchRequest", "PI/DevCentral/SoapService");
	soapParameterAdd($soap, "KeywordSearch", s);

	soapCall($soap);

	printf("<center><table width=90% bgcolor=#3366cc cellPadding=1>\n");
	printf("<td nowrap bgColor=#3366cc><font color=#ffffff size=-1>");
	printf("Searched Amazon for books matching '%s'.&nbsp;</font></td>", 
		query);
	printf("</tr></table>\n");
	printf("<table width=90% cellPadding=1><tr><td>\n");

	ret = soapResultGet($soap, "return");
	for (i = 0; i < sizeof(ret.Details); i++)
	{
		detail = ret.Details[i];
		if ((isMember(detail, "ProductName")) &&
			(isMember(detail, "ListPrice")) &&
			(isMember(detail, "OurPrice")))
		{
			printf("<BR>Book: %s, Price: %s (%s)\n", 
				detail.ProductName, detail.ListPrice,
				detail.OurPrice ? detail.OurPrice : detail.ListPrice);
		}
	}

	printf("</td></tr></table></center>\n");
	soapServiceFree($soap);
}
else
{
%>
<BR>
Note:  In order to use the Amazon Web APIs you must first register
with Amazon to recieve an developer token.  You can do this online
at <A HREF="http://www.amazon.com/webservices">http://www.amazon.com/webservices</A>.
<BR>
Your developer token will have a limit on the number of requests a data that 
you can make.  The default limit is 1 queries per second.
<%
}
%>
<%
#include "../footer.asp"
%>
</BODY></HTML>
