<HTML>
<HEAD><TITLE><%=txt2html(envt("servername"));%> - Amazon S3 Utility</TITLE>
<%
#include "../../header.asp"
menu = "utils";
#include "../../menu.asp"
area = "s3";
#include "../submenu.asp"
#include "list.asp"

s3 = s3init(envt("s3key"), envt("s3secret"));

action = getParameter($params, "action");
name = getParameter($params, "name");
if ((action == "mkbucket") && (sizeof(name) > 0))
{
	try
	{
		s3mkbucket(s3, name);
 		printf("<center><div class=\"info\">");
 		printf("Bucket %s created in Amazon S3 repository.", 
			txt2html(name));
 		printf("</div></center>");
	}
	catch (e)
	{
		write("<!--\n");
		write(exception(e, "info"));
		write("\n-->\n");
 		printf("<center><div class=\"error\">");
 		printf("Unable to create Amazon S3 bucket %s...", txt2html(name));
		printf("<BR>" + exception(e, "message"));
 		printf("</div></center>");
	}
}

if ((action == "rmbucket") && (sizeof(name) > 0))
{
	try
	{
		// First remove all files.
		files = s3files(s3, name);
		for (i = 0; i < sizeof(files); i++)
		{
			file = files[i];
			s3rmfile(s3, name, file.name);
		}

		s3rmbucket(s3, name);
 		printf("<center><div class=\"info\">");
 		printf("Bucket %s deleted from Amazon S3 repository.", 
			txt2html(name));
 		printf("</div></center>");
	}
	catch (e)
	{
		write("<!--\n");
		write(exception(e, "info"));
		write("\n-->\n");
 		printf("<center><div class=\"error\">");
 		printf("Unable to delete Amazon S3 bucket %s...", txt2html(name));
		printf("<BR>" + exception(e, "message"));
 		printf("</div></center>");
	}
}
%>
	<SCRIPT language=JavaScript>
	<!--
	agent = navigator.userAgent;
	browserOK = 0;
	if (navigator.appName == "Netscape" && 
		navigator.appVersion.substring(0,1) >= 2)
	{
		browserOK = 1
	}
	else 
	{
		if (navigator.appName == "Microsoft Internet Explorer" && 
			navigator.appVersion.substring(0,1) >= 4)
		{
			browserOK = 1
		}
	}

    function doValidate(theForm)
    {
        if (theForm.name.value == "")
        {
            alert("Please enter a value for the new \"folder\".");
            theForm.name.focus();
            return (false);
        }

        if (isValidName(theForm.name.value) == false)
        {
            alert("The new \"folder\" contains invalid characters.");
            theForm.name.focus();
            return (false);
        }
        return (true);
    }
	//-->
	</SCRIPT>
	<% err = getParameter($params, "err");
	   if (sizeof(err) > 0) { 
	%>
		<BLOCKQUOTE>
		<div class="error"><B>Error! <%=err;%></B></div>
		</BLOCKQUOTE>
		<BR>
	<% } %>

	<font size=+1><B>Amazon S3</FONT></B>
	<BR><BR>

	<!--- ---------- --->
	<!---    BODY    --->
	<!--- ---------- --->
	<blockquote>
	<div id="tabledata">
	<table align=center width=80% border=0 cellpadding=4 cellspacing=0 style="border: 1px solid black">
	<tr bgcolor="#ffff88" id="headerRow">
		<td nowrap style="border:1px solid black; border-width: 0 0 1px 0">
		<a href="javascript:rowSort('1', 1)" title="Sort by Bucket">
		Bucket</div></td>
		<td nowrap style="border:1px solid black; border-width: 0 0 1px 0">
		<a href="javascript:rowSort('2', 1)" title="Creation Date">
		Creation Date</div></td>
		<td width=90% style="border:1px solid black; border-width: 0 0 1px 0">
		&nbsp;</td>
	</tr>

	<% 
		try
		{
			buckets = s3buckets(s3);
			for (i = 0; i < sizeof(buckets); i++)
			{
				showBucket(buckets[i], i);
			}

			if (sizeof(buckets) == 0)
			{
				printf("<tr><td colspan=3 align=center>");
				printf("<i>No buckets in S3 repository.</i>");
				printf("</td></tr>");
			}
		}
		catch (e)
		{
			write("<!--\n");
			write(exception(e, "info"));
			write("\n-->\n");
			printf("<BR><B>" + exception(e, "message") + "</B><BR>");
		}
	%>

	</table>
	</div>

	<br>
	<hr>
	<br>
	<FORM METHOD="POST" ACTION="/sysadmin/utils/amazons3/index.asp"
 		onSubmit="return doValidate(this)">
	<input type=hidden name="action" value="mkbucket">
	<TABLE border=0 cellspacing=4>
	<TR><TD><B>Create Bucket</B></TD>
	    <TD><input type=text name="name" value="" size=40 maxlength=40></TD></TR>
	<TR><TD></TD><TD><I>(Note: Bucket names may not contain spaces 
	and must be unique across the entire S3 service!)</I>
	</TD></TR>
	<TR><TD></TD><TD>
	<input type=submit class="mod" value="Create Bucket">
	</TD></TR>
	</TABLE>
	</FORM>
	</blockquote>
<br>
<% #include "../../footer.asp" %>
</BODY></HTML>
