<HTML>
<HEAD><TITLE><%=txt2html(envt("servername"));%> - Server-to-Server Synchronization</TITLE>
<script src="/sysuser/calendar.js"></script>
<% 
#include "../header.asp"
menu = "utils";
#include "../menu.asp"
area = "sync";
#include "submenu.asp"

rurl = getParameter($params, "rurl");
if (rurl == NULL)
	rurl = "http://remote-server/";
user = getParameter($params, "user");
if (user == NULL)
	user = "";
pass = getParameter($params, "pass");
if (pass == NULL)
	pass = "";
path = getParameter($params, "path");
if (path == NULL)
	path = envt("defdocsdir");
ifmod = getParameter($params, "ifmod");
if (ifmod == NULL)
	ifmod = "";
inc = getParameter($params, "include");
if (inc == NULL)
	inc = "";
exc = getParameter($params, "exc");
if (exc == NULL)
	exc = "";
modsec = 0;
if (sizeof(ifmod) > 0)
	modsec = parsedate(ifmod);
%>
<table border=0 width=98%><tr><td nowrap>
<B>Server-to-Server Synchronization</B>
</td><td nowrap align=right>
<a target="help" href="/syshelp/sync.htm"><small>
<%=message("sa.Help", locale());%></small></a>
</td></tr></table>
<div id="validationError"></div>
<P>
<%
if ((rurl != "") && (user != "") && (pass != ""))
{
    	printf("<blockquote><pre>Synchronizing with %s...\n", rurl);
        try
        {
			s = sync(user, pass, path, rurl, modsec, inc, exc);
			printf("Failed Updates = %d\n", s.failed);
			if (s.failed > 0)
			{
				printf("    (See <a href=/sysadmin/system/alerts.asp>%s</a> for failures.)\n", message("sa.Alerts", locale()));
			}
            printf("Modified Files = %d\n", s.modified);
            printf("Unmodified Files = %d\n", s.unmodified);
            printf("Locally Modified Files = %d (not affected)\n", 
				s.localmodified);
            printf("Added Files = %d\n", s.added);
            printf("%d msec\n", s.msec);
        }
        catch (e)
        {
                write(exception(e, "info"));
        }

	printf("</pre><font color=green><B>");
	printf("Synchronization complete!");
	printf("</B></font></blockquote><br>");
} 
%>
<FORM METHOD=POST ACTION="/sysadmin/utils/sync.asp" NAME="syncForm" 
onSubmit="return validateForm(this)">
<center>
<table border=0 cellpadding=4>
<tr valign=top><td nowrap><B>URL</B></td>
<td><INPUT TYPE="text" NAME="rurl" VALUE="<%=txt2html(rurl);%>" SIZE="80" 
	MAXLENGTH="256" ptype="notnull" required="true"
	onkeypress="return handleEnter(this, event)">
<br>This URL must point to a remote Sambar Server to 
<b>pull files</b> from; the server must have WebDAV enabled.
</td></tr>
<tr valign=top><td nowrap><B>User</B></td>
<td><INPUT TYPE="text" NAME="user" VALUE="<%=txt2html(user);%>" SIZE="40" 
	MAXLENGTH="255" ptype="uname" required="true"
	onkeypress="return handleEnter(this, event)">
<br>Valid login on remote Sambar Server with access to the path 
specified above.
</td></tr>
<tr valign=top><td nowrap><B>Password</B></td>
<td><INPUT TYPE="password" NAME="pass" VALUE="<%=txt2html(pass);%>" SIZE="40" 
	MAXLENGTH="255" ptype="name" required="true"
	onkeypress="return handleEnter(this, event)">
</td></tr>
<tr valign=top><td nowrap><B>Local Path</B></td>
<td><INPUT TYPE="text" NAME="path" VALUE="<%=txt2html(path);%>" SIZE="80" 
	MAXLENGTH="255" required="true"
	onkeypress="return handleEnter(this, event)">
<br>This is the directory to which files will be copied from the remote server; it must exist.
</td></tr>
<tr valign=top><td nowrap><B>If-Modified-Since</B></td>
<td><INPUT TYPE="text" NAME="ifmod" VALUE="<%=txt2html(ifmod);%>" SIZE="40"
	MAXLENGTH="40" ptype="idate"
	onkeypress="return handleEnter(this, event)">
<a href="javascript:caldate.popup();"><img valign="bottom" src="/sysimage/system/cal.gif" width="16" height="16" border="0" alt="Click Here to set the date"></a>
<br>Only files created or modified after the date specified will 
be examined and copied.  
Leave blank to scan for all files on the remote server.
</td></tr>
<tr valign=top><td nowrap><B>Include (regex)</B></td>
<td><INPUT TYPE="text" NAME="include" VALUE="<%=txt2html(inc);%>" SIZE="40"
	MAXLENGTH="90" onkeypress="return handleEnter(this, event)">
<br>Only include files matching the regular expression specified 
(i.e. <CODE>.htm$</CODE> would only match HTM files).  
Leave blank to scan for all files on the remote server.
</td></tr>
<tr valign=top><td nowrap><B>Exclude (regex)</B></td>
<td><INPUT TYPE="text" NAME="exc" VALUE="<%=txt2html(exc);%>" SIZE="40"
	MAXLENGTH="90" onkeypress="return handleEnter(this, event)">
<br>Exclude files matching the regular expression specified. 
</td></tr>
<tr valign=top><td nowrap>&nbsp;</td>
<td><INPUT class="mod" TYPE=submit VALUE="Synchronize with Server"></td></tr>

</TABLE>
</center>
</FORM>
    <SCRIPT language="JavaScript">
    <!--
    var caldate = new calendar2(document.syncForm.ifmod);
    caldate.year_scroll = true;
    caldate.time_comp = false;
    //-->
    </SCRIPT>
<BR><BR>
<b>Synchronizing daily via the 
<a href="/sysadmin/services/cron.asp">Task Scheduler</a> service...</b>
<blockquote>
One Sambar server can be scheduled to synchronize with another quite easily
using the Task scheduler and this page FORM.  The 
<a href="/sysadmin/services/cron.asp">Task Scheduler</a> command
for that would be:
<br/><br/>
<code>
/session/url2file?fname=/tmp/sync.out&url=/sysadmin/tools/sync.asp&rurl=<i>http://remote-server/</i>&user=<i>user</i>&pass=<i>pass</i>&path=<i>path</i>
</code>
<br/><br/>
Alternatively, and perhaps easier, is to copy this page 
(<code>/sysadmin/tools/sync.asp</code>) to 
<code>/sysadmin/tools/mysync.asp</code> and edit the 
variables at the top of the page, prefilling in the site to sync with, 
username, password, path etc.  Test that simply loading your new
pages <code>/sysadmin/tools/msync.asp</code> causes the desired 
synchronization.  Finally, schedule your new page to run daily using the 
<a href="/sysadmin/services/cron.asp">Task Scheduler</a> command:
<br/><br/>
<code>
/session/url2file?fname=/tmp/sync.out&url=/sysadmin/tools/mysync.asp
</code>
</blockquote>
<%
#include "../footer.asp"
%>
</BODY></HTML>
